 /*****************************************************************/
 /** JNI.CPY - This is the main include for PL/I Java support.    */
 /**         - The source is jni.h in jdk1.1.8                    */
 /**         - This PL/I cpy file is incomplete as delivered but  */
 /**             will be updated with each PL/I CSD release.      */
 /*****************************************************************/
 /*                                                               */
 /*  Licensed Materials - Property of IBM                         */
 /*  5639-A83, 5639-A24 (C) Copyright IBM Corp. 1999.             */
 /*  All Rights Reserved.                                         */
 /*   (C) Copyright IBM Corp. 1998. All Rights Reserved.          */
 /*   US Government Users Restricted Rights-- Use, duplication or */
 /*   disclosure restricted by GSA ADP Schedule Contract with     */
 /*   IBM Corp.                                                   */
 /*                                                               */
 /* DISCLAIMER OF WARRANTIES                                      */
 /*   The following enclosed code is sample code created by IBM */
 /*   Corporation. This sample code is not part of any standard   */
 /*   IBM product and is provided to you solely for the purpose of*/
 /*   assisting you in the development of your applications.  The */
 /*   code is provided "AS IS", without warranty of any kind.     */
 /*   IBM shall not be liable for any damages arising out of your */
 /*   use of the sample code, even if IBM has been advised of the */
 /*   possibility of such damages.                                */
 /*                                                               */
 /*****************************************************************/

 %INCLUDE jni_md;

 define alias jboolean unsigned fixed bin(8);
 define alias jchar unsigned fixed bin(16);
 define alias jshort fixed bin(15);
 define alias jfloat float bin(21);
 define alias jdouble float bin(53);
 define alias jsize type jint;

 define alias jobject pointer byvalue;
 define alias jclass type jobject;
 define alias jthrowable type jobject;
 define alias jstring type jobject;
 define alias jvoid type jobject;
 define alias jfieldID type jobject;
 define alias jmethodID type jobject;
 define alias jarray type jobject;
 define alias jbooleanArray type jarray;
 define alias jbyteArray type jarray;
 define alias jcharArray type jarray;
 define alias jshortArray type jarray;
 define alias jintArray type jarray;
 define alias jlongArray type jarray;
 define alias jfloatArray type jarray;
 define alias jdoubleArray type jarray;
 define alias jobjectArray type jarray;

 define alias jref type jobject; /* For transition---not meant to */
                                 /* be part of public API anymore.*/

 define structure
 1 jvalue union,
    2 z type jboolean,
    2 b type jbyte,
    2 c type jchar,
    2 s type jshort,
    2 i type jint,
    2 j type jlong,
    2 f type jfloat,
    2 d type jdouble,
    2 l type jobject;

 define alias @jvalue handle jvalue;

 /*   jboolean constants  */

 dcl JNI_FALSE fixed bin(31) value(0);
 dcl JNI_TRUE fixed bin(31) value(1);

 /* possible return values for JNI functions.  */

 dcl JNI_OK fixed bin(31) value(0);
 dcl JNI_ERR fixed bin(31) value(-1);

 /* used in ReleaseScalarArrayElements  */

 dcl JNI_COMMIT fixed bin(31) value(1);
 dcl JNI_ABORT fixed bin(31) value(2);

 /* Used in RegisterNatives to describe native method name,      */
 /*   signature, and function pointer.                           */

 define structure
   1 dummy#1,
    2 name pointer,
    2 signature pointer,
    2 fnPtr pointer;

 define alias @dummy#1 handle dummy#1;
 define alias JNINativeMethod type dummy#1;

 /*  JNI Native Method Interface.                                */

 dcl JNIEnv pointer ;
 dcl dJNIEnv pointer based(JNIEnv);

 dcl 1 JNINativeInterface_ based(dJNIEnv),
        2 * pointer,
        2 * pointer,
        2 * pointer,
        2 * pointer,
        2 GetVersion limited entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 DefineClass limited entry
          ( pointer byvalue, pointer byvalue, pointer byvalue,
            fixed bin(31) )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jclass ),
        2 FindClass limited entry
          ( pointer byvalue, nonasgn byaddr char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jclass ),
        2 * pointer,
        2 * pointer,
        2 * pointer,
        2 GetSuperClass limited entry
          ( pointer byvalue, type jclass )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jclass),
        2 IsAssignableFrom limited entry
          ( pointer byvalue, type jclass, type jclass )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 * pointer,
        2 Throw limited entry
          ( pointer byvalue, type jthrowable )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 ThrowNew limited entry
          ( pointer byvalue, type jclass,
            nonasgn byaddr char(*) varz )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 ExceptionOccurred limited entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jthrowable ),
        2 ExceptionDescribe limited entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue optional ),
        2 ExceptionClear limited entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue optional ),

        2 FatalError limited entry
          ( pointer byvalue, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue optional ),
        2 * pointer,
        2 * pointer,

        2 NewGlobalRef limited entry
          ( pointer byvalue, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 DeleteGlobalRef limited entry
          ( pointer byvalue, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue optional ),
        2 DeleteLocalRef limited entry
          ( pointer byvalue, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue optional ),

        2 IsSameObject limited entry
          ( pointer byvalue, type jobject, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 * pointer,
        2 * pointer,

        2 AllocObject limited entry
          ( pointer byvalue, type jclass )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),

        2 NewObject limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 NewObjectV limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 NewObjectA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),

        2 GetObjectClass limited entry
         ( pointer byvalue, type jobject)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jclass ),
        2 IsInstanceOf limited entry
          ( pointer byvalue, type jobject, type jclass)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 GetMethodID limited entry
          ( pointer byvalue, type jclass,
            byaddr nonasgn char(*) varz,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jmethodID ),

        2 CallObjectMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallObjectMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallObjectMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),

        2 CallBooleanMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallBooleanMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallBooleanMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),

        2 CallByteMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallByteMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallByteMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),

        2 CallCharMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallCharMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallCharMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),

        2 CallShortMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallShortMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallShortMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),

        2 CallIntMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallIntMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallIntMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 CallLongMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallLongMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallLongMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),

        2 CallFloatMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallFloatMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallFloatMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),

        2 CallDoubleMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallDoubleMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallDoubleMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 CallVoidMethod limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallVoidMethodV limited entry
          ( pointer byvalue, type jobject, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallVoidMethodA limited entry
          ( pointer byvalue, type jobject, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 CallNonVirtualObjectMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallNonVirtualObjectMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallNonVirtualObjectMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),

        2 CallNonVirtualBooleanMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallNonVirtualBooleanMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallNonVirtualBooleanMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),

        2 CallNonVirtualByteMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallNonVirtualByteMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallNonVirtualByteMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),

        2 CallNonVirtualCharMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallNonVirtualCharMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallNonVirtualCharMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),

        2 CallNonVirtualShortMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallNonVirtualShortMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallNonVirtualShortMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),

        2 CallNonVirtualIntMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallNonVirtualIntMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallNonVirtualIntMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 CallNonVirtualLongMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallNonVirtualLongMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallNonVirtualLongMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),

        2 CallNonVirtualFloatMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallNonVirtualFloatMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallNonVirtualFloatMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),

        2 CallNonVirtualDoubleMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallNonVirtualDoubleMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallNonVirtualDoubleMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 CallNonVirtualVoidMethod limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallNonVirtualVoidMethodV limited entry
          ( pointer byvalue, type jobject, type jclass,
            list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallNonVirtualVoidMethodA limited entry
          ( pointer byvalue, type jobject, type jclass,
            type jmethodID, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 GetFieldID limited entry
          ( pointer byvalue, type jclass,
            byaddr nonasgn char(*) varz,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfieldID ),

        2 GetObjectField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 GetBooleanField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 GetByteField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 GetCharField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 GetShortField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 GetIntField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 GetLongField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 GetFloatField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 GetDoubleField limited entry
          ( pointer byvalue, type jobject, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 SetObjectField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetBooleanField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetByteField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jbyte )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetCharField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jchar )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetShortField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jshort )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetIntField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetLongField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jlong )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetFloatField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jfloat )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetDoubleField limited entry
          ( pointer byvalue, type jobject, type jfieldID,
            type jdouble )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 GetStaticMethodID limited entry
          ( pointer byvalue, type jclass,
            byaddr nonasgn char(*) varz,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jmethodID ),

        2 CallStaticObjectMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallStaticObjectMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 CallStaticObjectMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),

        2 CallStaticBooleanMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallStaticBooleanMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 CallStaticBooleanMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),

        2 CallStaticByteMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallStaticByteMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 CallStaticByteMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),

        2 CallStaticCharMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallStaticCharMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 CallStaticCharMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),

        2 CallStaticShortMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallStaticShortMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 CallStaticShortMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),

        2 CallStaticIntMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallStaticIntMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 CallStaticIntMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 CallStaticLongMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallStaticLongMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 CallStaticLongMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),

        2 CallStaticFloatMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallStaticFloatMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 CallStaticFloatMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),

        2 CallStaticDoubleMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallStaticDoubleMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),
        2 CallStaticDoubleMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 CallStaticVoidMethod limited entry
          ( pointer byvalue, type jclass, list type jmethodID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallStaticVoidMethodV limited entry
          ( pointer byvalue, type jclass, list type jmethodID)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 CallStaticVoidMethodA limited entry
          ( pointer byvalue, type jclass, type jmethodID,
            pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 GetStaticFieldID limited entry
          ( pointer byvalue, type jclass,
            byaddr nonasgn char(*) varz,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfieldID ),
        2 GetStaticObjectField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 GetStaticBooleanField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 GetStaticByteField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 GetStaticCharField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 GetStaticShortField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 GetStaticIntField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 GetStaticLongField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 GetStaticFloatField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 GetStaticDoubleField limited entry
          ( pointer byvalue, type jclass, type jfieldID )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 SetStaticObjectField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticBooleanField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticByteField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jbyte )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticCharField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jchar )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticShortField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jshort )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticIntField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticLongField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jlong )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticFloatField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jfloat )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetStaticDoubleField limited entry
          ( pointer byvalue, type jclass, type jfieldID,
            type jdouble )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 NewString limited entry
          ( pointer byvalue,
            byaddr nonasgn wchar(*) varz,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jstring ),
        2 GetStringLength limited entry
          ( pointer byvalue, type jstring )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jsize ),
        2 GetStringChars limited entry
          ( pointer byvalue, type jstring, byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue ),
        2 ReleaseStringChars limited entry
          ( pointer byvalue, type jstring,
            byaddr nonasgn wchar(*) varz )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 NewStringUTF limited entry
          ( pointer byvalue,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jstring ),
        2 GetStringUTFLength limited entry
          ( pointer byvalue, type jstring )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jsize ),
        2 GetStringUTFChars limited entry
          ( pointer byvalue, type jstring, byaddr type jboolean)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue ),
        2 ReleaseStringUTFChars limited entry
          ( pointer byvalue, type jstring,
            byaddr nonasgn char(*) varz)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 GetArrayLength limited entry
          ( pointer byvalue, type jarray )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jsize ),

        2 NewObjectArray limited entry
          ( pointer byvalue, type jsize, type jclass,
            type jobject  )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobjectArray ),
        2 GetObjectArrayElement limited entry
          ( pointer byvalue, type jobjectArray, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jobject ),
        2 SetObjectArrayElement limited entry
          ( pointer byvalue, type jobjectArray, type jsize,
            type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 NewBooleanArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbooleanArray ),
        2 NewByteArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyteArray ),
        2 NewCharArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jcharArray ),
        2 NewShortArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshortArray ),
        2 NewIntArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jintArray ),
        2 NewLongArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlongArray ),
        2 NewFloatArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloatArray ),
        2 NewDoubleArray limited entry
          ( pointer byvalue, type jsize )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdoubleArray ),

        2 GetBooleanArrayElements limited entry
          ( pointer byvalue, type jbooleanArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jboolean ),
        2 GetByteArrayElements limited entry
          ( pointer byvalue, type jbyteArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jbyte ),
        2 GetCharArrayElements limited entry
          ( pointer byvalue, type jcharArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jchar ),
        2 GetShortArrayElements limited entry
          ( pointer byvalue, type jshortArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jshort ),
        2 GetIntArrayElements limited entry
          ( pointer byvalue, type jintArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( pointer byvalue ),
        2 GetLongArrayElements limited entry
          ( pointer byvalue, type jlongArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jlong ),
        2 GetFloatArrayElements limited entry
          ( pointer byvalue, type jfloatArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jfloat ),
        2 GetDoubleArrayElements limited entry
          ( pointer byvalue, type jdoubleArray,
            byaddr type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jdouble ),

        2 ReleaseBooleanArrayElements limited entry
          ( pointer byvalue, type jbooleanArray, type jboolean,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseByteArrayElements limited entry
          ( pointer byvalue, type jbyteArray, type jbyte,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseCharArrayElements limited entry
          ( pointer byvalue, type jcharArray, type jchar,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseShortArrayElements limited entry
          ( pointer byvalue, type jshortArray, type jshort,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseIntArrayElements limited entry
          ( pointer byvalue, type jintArray, type jint,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseLongArrayElements limited entry
          ( pointer byvalue, type jlongArray, type jlong,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseFloatArrayElements limited entry
          ( pointer byvalue, type jfloatArray, type jfloat,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 ReleaseDoubleArrayElements limited entry
          ( pointer byvalue, type jdoubleArray, type jdouble,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 GetBooleanArrayRegion limited entry
          ( pointer byvalue, type jbooleanArray, type jsize,
            type jsize, type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetByteArrayRegion limited entry
          ( pointer byvalue, type jbyteArray, type jsize,
            type jsize, type jbyte )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetCharArrayRegion limited entry
          ( pointer byvalue, type jcharArray, type jsize,
            type jsize, type jchar )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetShortArrayRegion limited entry
          ( pointer byvalue, type jshortArray, type jsize,
            type jsize, type jshort )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetIntArrayRegion limited entry
          ( pointer byvalue, type jintArray, type jsize,
            type jsize, type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetLongArrayRegion limited entry
          ( pointer byvalue, type jlongArray, type jsize,
            type jsize, type jlong )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetFloatArrayRegion limited entry
          ( pointer byvalue, type jfloatArray, type jsize,
            type jsize, type jfloat )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 GetDoubleArrayRegion limited entry
          ( pointer byvalue, type jdoubleArray, type jsize,
            type jsize, type jdouble )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 SetBooleanArrayRegion limited entry
          ( pointer byvalue, type jbooleanArray, type jsize,
            type jsize, type jboolean )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetByteArrayRegion limited entry
          ( pointer byvalue, type jbyteArray, type jsize,
            type jsize, type jbyte )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetCharArrayRegion limited entry
          ( pointer byvalue, type jcharArray, type jsize,
            type jsize, type jchar )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetShortArrayRegion limited entry
          ( pointer byvalue, type jshortArray, type jsize,
            type jsize, type jshort )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetIntArrayRegion limited entry
          ( pointer byvalue, type jintArray, type jsize,
            type jsize, type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetLongArrayRegion limited entry
          ( pointer byvalue, type jlongArray, type jsize,
            type jsize, type jlong )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetFloatArrayRegion limited entry
          ( pointer byvalue, type jfloatArray, type jsize,
            type jsize, type jfloat )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 SetDoubleArrayRegion limited entry
          ( pointer byvalue, type jdoubleArray, type jsize,
            type jsize, type jdouble )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),

        2 RegisterNatives limited entry
          ( pointer byvalue, type jclass, pointer byvalue,
            type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 UnregisterNatives limited entry
          ( pointer byvalue, type jclass )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 MonitorEnter limited entry
          ( pointer byvalue, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 MonitorExit limited entry
          ( pointer byvalue, type jobject )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),

        2 GetJavaVM limited entry
          ( pointer byvalue, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint )
        ;


 Dcl 1 JDK1_1InitArgs,
        2 version      type jint,
        2 properties   pointer,
        2 checkSource  type jint,
        2 nativeStacksize type jint,
        2 javaStackSize   type jint,
        2 minHeapSize     type jint,
        2 maxHeapSize     type jint,
        2 verifyMode      type jint,
        2 classpath     pointer,
        2 vfprintf limited entry
          ( pointer byvalue, pointer byvalue, pointer byvalue)
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 exit   limited entry
          ( type jint )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 abort  limited entry
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jvoid ),
        2 enableClassGC   type jint,
        2 enableVerboseGC  type jint,
        2 disableAsyncGC   type jint,
        2 verbose     type jint,
        2 debugging type jboolean,
        2 debugPort type jint;


/*
 * JNI Invocation Interface.
 */

 dcl JavaVM pointer ;
 dcl dJavaVM pointer based(JavaVM);

 dcl 1 JNIInvokeInterface_  based(JavaVM),
        2 * pointer,
        2 * pointer,
        2 * pointer,
        2 DestroyJavaVM  entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 AttachCurrentThread  entry
          ( pointer byvalue, pointer byvalue, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint ),
        2 DetachCurrentThread  entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          returns ( type jint );

  Dcl JNI_GetDefaultJavaVMInitArgs entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          external ('JNI_GetDefaultJavaVMInitArgs')
          returns ( fixed bin(31) byvalue );

  Dcl JNI_CreateJavaVM entry
          ( pointer byvalue, pointer byvalue, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          external ('JNI_CreateJavaVM')
          returns ( type jint );

  Dcl JNI_GetCreatedJavaVMs entry
          ( pointer byvalue, type jint, pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          external ('JNI_GetCreatedJavaVMs')
          returns ( type jint );

  Dcl JNI_InitHeapOptions   entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          external ('JNI_InitHeapOptions')
          returns ( type jint );

  Dcl JNI_SetHeapOptions   entry
          ( pointer byvalue )
          options (byvalue nodescriptor linkage(stdcall) )
          external ('JNI_SetHeapOptions')
          returns ( type jint );


 dcl JNI_VERSION_1_1   fixed bin(31) value('00010001'xn);
 dcl JNI_VERSION_1_2   fixed bin(31) value('00010002'xn);

