 /* ++ BUILD Version: 0007                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1990 - 1998 Microsoft Corporation                       */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmbrowsr.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains information about browser stubbed versions   */
 /*   of the NetServer APIs.                                          */
 /*       Function Prototypes                                         */
 /*       Data Structures                                             */
 /*       Definition of special values                                */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMBROWSR_ char ext;
 %if #LMBROWSR_ = '' %then %do;
 %#LMBROWSR_ = 'Y';

 define structure
   1 BROWSER_STATISTICS,
     2 StatisticsStartTime                        type LARGE_INTEGER,
     2 NumberOfServerAnnouncements                type LARGE_INTEGER,
     2 NumberOfDomainAnnouncements                type LARGE_INTEGER,
     2 NumberOfElectionPackets                    type ULONG,
     2 NumberOfMailslotWrites                     type ULONG,
     2 NumberOfGetBrowserServerListRequests       type ULONG,
     2 NumberOfServerEnumerations                 type ULONG,
     2 NumberOfDomainEnumerations                 type ULONG,
     2 NumberOfOtherEnumerations                  type ULONG,
     2 NumberOfMissedServerAnnouncements          type ULONG,
     2 NumberOfMissedMailslotDatagrams            type ULONG,
     2 NumberOfMissedGetBrowserServerListRequests type ULONG,
     2 NumberOfFailedServerAnnounceAllocations    type ULONG,
     2 NumberOfFailedMailslotAllocations          type ULONG,
     2 NumberOfFailedMailslotReceives             type ULONG,
     2 NumberOfFailedMailslotWrites               type ULONG,
     2 NumberOfFailedMailslotOpens                type ULONG,
     2 NumberOfDuplicateMasterAnnouncements       type ULONG,
     2 NumberOfIllegalDatagrams                   type LARGE_INTEGER;
 define alias  PBROWSER_STATISTICS handle BROWSER_STATISTICS;
 define alias LPBROWSER_STATISTICS handle BROWSER_STATISTICS;

 define structure
   1 BROWSER_STATISTICS_100,
     2 StartTime                                  type LARGE_INTEGER,
     2 NumberOfServerAnnouncements                type LARGE_INTEGER,
     2 NumberOfDomainAnnouncements                type LARGE_INTEGER,
     2 NumberOfElectionPackets                    type ULONG,
     2 NumberOfMailslotWrites                     type ULONG,
     2 NumberOfGetBrowserServerListRequests       type ULONG,
     2 NumberOfIllegalDatagrams                   type LARGE_INTEGER;
 define alias PBROWSER_STATISTICS_100 handle BROWSER_STATISTICS_100;

 define structure
   1 BROWSER_STATISTICS_101,
     2 StartTime                                  type LARGE_INTEGER,
     2 NumberOfServerAnnouncements                type LARGE_INTEGER,
     2 NumberOfDomainAnnouncements                type LARGE_INTEGER,
     2 NumberOfElectionPackets                    type ULONG,
     2 NumberOfMailslotWrites                     type ULONG,
     2 NumberOfGetBrowserServerListRequests       type ULONG,
     2 NumberOfIllegalDatagrams                   type LARGE_INTEGER,
     2 NumberOfMissedServerAnnouncements          type ULONG,
     2 NumberOfMissedMailslotDatagrams            type ULONG,
     2 NumberOfMissedGetBrowserServerListRequests type ULONG,
     2 NumberOfFailedServerAnnounceAllocations    type ULONG,
     2 NumberOfFailedMailslotAllocations          type ULONG,
     2 NumberOfFailedMailslotReceives             type ULONG,
     2 NumberOfFailedMailslotWrites               type ULONG,
     2 NumberOfFailedMailslotOpens                type ULONG,
     2 NumberOfDuplicateMasterAnnouncements       type ULONG;
 define alias PBROWSER_STATISTICS_101 handle BROWSER_STATISTICS_101;


 define structure
   1 BROWSER_EMULATED_DOMAIN,
     2 DomainName                                 type LPWSTR,
     2 EmulatedServerName                         type LPWSTR,
     2 Role                                       type DWORD;
 define alias PBROWSER_EMULATED_DOMAIN handle BROWSER_EMULATED_DOMAIN;


 /* Function Prototypes - BROWSER */

 dcl I_BrowserServerEnum
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type LPDWORD,
            type LPDWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserServerEnum');

 dcl I_BrowserServerEnumEx
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserServerEnumEx');

 /* For the rest of the calls, MS do not say NET_API_FUNCTION. */
 /* Nor can I find the calls in the NT4 Platform SDK           */
 /* If the calls don't work, replace NET_API_FUNCTION with:    */
 /*   options (byvalue nodescriptor linkage(cdecl))            */
 /* - Mark Yudkin, 23/2/99 */

 dcl I_BrowserQueryOtherDomains
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type LPBYTE byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserQueryOtherDomains');

 dcl I_BrowserResetNetlogonState
     entry (WCHAR(*) varz byaddr nonasgn optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserResetNetlogonState');

 dcl I_BrowserSetNetlogonState
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserSetNetlogonState');

 dcl BROWSER_ROLE_PDC fixed bin(15) value('1'xn);
 dcl BROWSER_ROLE_BDC fixed bin(15) value('2'xn);

 dcl I_BrowserQueryEmulatedDomains
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type PBROWSER_EMULATED_DOMAIN byaddr,
            type LPDWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserQueryEmulatedDomains');

 dcl I_BrowserQueryStatistics
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type LPBROWSER_STATISTICS byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserQueryStatistics');

 dcl I_BrowserResetStatistics
     entry (WCHAR(*) varz byaddr nonasgn optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserResetStatistics');


 dcl I_BrowserServerEnumForXactsrv
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type ULONG,
            type USHORT,
            type PVOID,
            type WORD,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type WORD byaddr)
     returns (type WORD byvalue optional)
     NET_API_FUNCTION external('I_BrowserServerEnumForXactsrv');


 %dcl DBG fixed ext;
 %if DBG ^= 0 %then %do;
 dcl I_BrowserDebugTrace
     entry (type WCHAR(*) varz byaddr,
            type CHAR (*) varz byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_BrowserDebugTrace');
 %end;

 %end; /* _LMBROWSR_ */
