 /* ++ BUILD Version: 0002                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmsvc.cpy                                                       */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes, and         */
 /*   definitions for the NetService API.                             */
 /*                                                                   */
 /* [Environment:]                                                    */
 /*                                                                   */
 /*   User Mode -Win32                                                */
 /*                                                                   */
 /* [Notes:]                                                          */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMSVC_ char ext;
 %if #LMSVC_ = '' %then %do;
 %#LMSVC_ = 'Y';


 /* Include the file which contains all the service name strings. */

 %include lmsname;


 /*  Data Structures */


 define structure
   1 SERVICE_INFO_0,
     2 svci0_name type LPWSTR;
 define alias  PSERVICE_INFO_0 handle SERVICE_INFO_0;
 define alias LPSERVICE_INFO_0 handle SERVICE_INFO_0;

 define structure
   1 SERVICE_INFO_1,
     2 svci1_name   type LPWSTR,
     2 svci1_status type DWORD,
     2 svci1_code   type DWORD,
     2 svci1_pid    type DWORD;
 define alias  PSERVICE_INFO_1 handle SERVICE_INFO_1;
 define alias LPSERVICE_INFO_1 handle SERVICE_INFO_1;

 define structure
   1 SERVICE_INFO_2,
     2 svci2_name           type LPWSTR,
     2 svci2_status         type DWORD,
     2 svci2_code           type DWORD,
     2 svci2_pid            type DWORD,
     2 svci2_text           type LPWSTR,
     2 svci2_specific_error type DWORD,
     2 svci2_display_name   type LPWSTR;
 define alias  PSERVICE_INFO_2 handle SERVICE_INFO_2;
 define alias LPSERVICE_INFO_2 handle SERVICE_INFO_2;


 /* Function Prototypes */

 dcl NetServiceControl
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetServiceControl');

 dcl NetServiceEnum
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetServiceEnum');

 dcl NetServiceGetInfo
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetServiceGetInfo');

 dcl NetServiceInstall
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            (*) type LPCWSTR byaddr optional,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetServiceInstall');


 /* Special Values and Constants */


 /*  Bitmask and bit values for svci1_status, and svci2_status */
 /*  fields.  For each "subfield", there is a mask defined,    */
 /*  and a number of constants representing the value          */
 /*  obtained by doing (status & mask).                        */

 /* Bits 0,1 -- general status */

 dcl SERVICE_INSTALL_STATE         fixed bin(15) value('03'xn);
 dcl SERVICE_UNINSTALLED           fixed bin(15) value('00'xn);
 dcl SERVICE_INSTALL_PENDING       fixed bin(15) value('01'xn);
 dcl SERVICE_UNINSTALL_PENDING     fixed bin(15) value('02'xn);
 dcl SERVICE_INSTALLED             fixed bin(15) value('03'xn);

 /* Bits 2,3 -- paused/active status */

 dcl SERVICE_PAUSE_STATE           fixed bin(15) value('0C'xn);
 dcl LM20_SERVICE_ACTIVE           fixed bin(15) value('00'xn);
 dcl LM20_SERVICE_CONTINUE_PENDING fixed bin(15) value('04'xn);
 dcl LM20_SERVICE_PAUSE_PENDING    fixed bin(15) value('08'xn);
 dcl LM20_SERVICE_PAUSED           fixed bin(15) value('0C'xn);

 /* Bit 4 -- uninstallable indication */

 dcl SERVICE_NOT_UNINSTALLABLE     fixed bin(15) value('00'xn);
 dcl SERVICE_UNINSTALLABLE         fixed bin(15) value('10'xn);

 /* Bit 5 -- pausable indication */

 dcl SERVICE_NOT_PAUSABLE          fixed bin(15) value('00'xn);
 dcl SERVICE_PAUSABLE              fixed bin(15) value('20'xn);

 /* Workstation service only:                */
 /* Bits 8,9,10 -- redirection paused/active */

 dcl SERVICE_REDIR_PAUSED          fixed bin(15) value('700'xn);
 dcl SERVICE_REDIR_DISK_PAUSED     fixed bin(15) value('100'xn);
 dcl SERVICE_REDIR_PRINT_PAUSED    fixed bin(15) value('200'xn);
 dcl SERVICE_REDIR_COMM_PAUSED     fixed bin(15) value('400'xn);


 /* Additional standard LAN Manager for MS-DOS services */

 dcl SERVICE_DOS_ENCRYPTION WCHAR value('ENCRYPT');


 /* NetServiceControl opcodes. */

 dcl SERVICE_CTRL_INTERROGATE    fixed bin(31) value(0);
 dcl SERVICE_CTRL_PAUSE          fixed bin(31) value(1);
 dcl SERVICE_CTRL_CONTINUE       fixed bin(31) value(2);
 dcl SERVICE_CTRL_UNINSTALL      fixed bin(31) value(3);

 /* Workstation service only:  Bits used in the "arg" parameter */
 /* to NetServiceControl in conjunction with the opcode         */
 /* SERVICE_CTRL_PAUSE or SERVICE_CTRL_CONTINUE, to pause or    */
 /* continue redirection.                                       */

 dcl SERVICE_CTRL_REDIR_DISK     fixed bin(31) value('1'xn);
 dcl SERVICE_CTRL_REDIR_PRINT    fixed bin(31) value('2'xn);
 dcl SERVICE_CTRL_REDIR_COMM     fixed bin(31) value('4'xn);

 /* Values for svci1_code, and svci2_code when status of the service */
 /* is SERVICE_INSTALL_PENDING or SERVICE_UNINSTALL_PENDING.         */
 /* A service can optionally provide a hint to the installer         */
 /* that the install is proceeding and how long to wait              */
 /* (in 0.1 second increments) before querying status again.         */

 dcl SERVICE_IP_NO_HINT          fixed bin(31) value('0'xn);
 dcl SERVICE_CCP_NO_HINT         fixed bin(31) value('0'xn);

 dcl SERVICE_IP_QUERY_HINT       fixed bin(31) value('10000'xn);
 dcl SERVICE_CCP_QUERY_HINT      fixed bin(31) value('10000'xn);

 /* Mask for install proceeding checkpoint number */

 dcl SERVICE_IP_CHKPT_NUM        fixed bin(31) value('0FF'xn);
 dcl SERVICE_CCP_CHKPT_NUM       fixed bin(31) value('0FF'xn);

 /* Mask for wait time hint before querying again */

 dcl SERVICE_IP_WAIT_TIME        fixed bin(31) value('0FF00'xn);
 dcl SERVICE_CCP_WAIT_TIME       fixed bin(31) value('0FF00'xn);

 /* Shift count for building wait time _code values */

 dcl SERVICE_IP_WAITTIME_SHIFT   fixed bin(31) value(8);
 dcl SERVICE_NTIP_WAITTIME_SHIFT fixed bin(31) value(12);

 /* Mask used for upper and lower portions of wait hint time. */

 dcl UPPER_HINT_MASK             fixed bin(31) value('0000FF00'xn);
 dcl LOWER_HINT_MASK             fixed bin(31) value('000000FF'xn);
 dcl UPPER_GET_HINT_MASK         fixed bin(31) value('0FF00000'xn);
 dcl LOWER_GET_HINT_MASK         fixed bin(31) value('0000FF00'xn);
 dcl SERVICE_NT_MAXTIME          fixed bin(31) value('0000FFFF'xn);
 dcl SERVICE_RESRV_MASK          fixed bin(31) value('0001FFFF'xn);
 dcl SERVICE_MAXTIME             fixed bin(31) value('000000FF'xn);


 /*  SERVICE_BASE is the base of service error codes, */
 /*  chosen to avoid conflict with OS, redirector,    */
 /*  netapi, and errlog codes.                        */

 dcl SERVICE_BASE                fixed bin(31) value(3050);
 dcl SERVICE_UIC_NORMAL          fixed bin(31) value(0);
 /* Uninstall codes, to be used in high byte of 'code' on final */
 /* NetStatus, which sets the status to UNINSTALLED.            */

 dcl SERVICE_UIC_BADPARMVAL      fixed bin(31) value(SERVICE_BASE + 1);
 /* The Registry or the information you just typed includes an */
 /* illegal value for "%1".                                    */

 dcl SERVICE_UIC_MISSPARM        fixed bin(31) value(SERVICE_BASE + 2);
 /* The required parameter was not provided on the command */
 /* line or in the configuration file.                     */

 dcl SERVICE_UIC_UNKPARM         fixed bin(31) value(SERVICE_BASE + 3);
 /* LAN Manager does not recognize "%1" as a valid option. */

 dcl SERVICE_UIC_RESOURCE        fixed bin(31) value(SERVICE_BASE + 4);
 /* A request for resource could not be satisfied. */

 dcl SERVICE_UIC_CONFIG          fixed bin(31) value(SERVICE_BASE + 5);
 /* A problem exists with the system configuration. */

 dcl SERVICE_UIC_SYSTEM          fixed bin(31) value(SERVICE_BASE + 6);
 /* A system error has occurred. */

 dcl SERVICE_UIC_INTERNAL        fixed bin(31) value(SERVICE_BASE + 7);
 /* An internal consistency error has occurred. */

 dcl SERVICE_UIC_AMBIGPARM       fixed bin(31) value(SERVICE_BASE + 8);
 /* The configuration file or the command line */
 /* has an ambiguous option.                   */

 dcl SERVICE_UIC_DUPPARM         fixed bin(31) value(SERVICE_BASE + 9);
 /* The configuration file or the command line */
 /* has a duplicate parameter.                 */

 dcl SERVICE_UIC_KILL            fixed bin(31) value(SERVICE_BASE + 10);
 /* The service did not respond to control and was stopped with */
 /* the DosKillProc function. */

 dcl SERVICE_UIC_EXEC            fixed bin(31) value(SERVICE_BASE + 11);
 /* An error occurred when attempting to run the service program. */

 dcl SERVICE_UIC_SUBSERV         fixed bin(31) value(SERVICE_BASE + 12);
 /* The sub-service failed to start. */

 dcl SERVICE_UIC_CONFLPARM       fixed bin(31) value(SERVICE_BASE + 13);
 /* There is a conflict in the value or use of these options: %1. */

 dcl SERVICE_UIC_FILE            fixed bin(31) value(SERVICE_BASE + 14);
 /* There is a problem with the file. */


 /* The modifiers */

 /* General: */

 dcl SERVICE_UIC_M_NULL          fixed bin(31) value(0);


 /*  RESOURCE: */

 dcl SERVICE_UIC_M_MEMORY        fixed bin(31) value(SERVICE_BASE + 20);
     /* memory */
 dcl SERVICE_UIC_M_DISK          fixed bin(31) value(SERVICE_BASE + 21);
     /* disk space */
 dcl SERVICE_UIC_M_THREADS       fixed bin(31) value(SERVICE_BASE + 22);
     /* thread */
 dcl SERVICE_UIC_M_PROCESSES     fixed bin(31) value(SERVICE_BASE + 23);
     /* process */

 /*  CONFIG: */

 /* Security failure */

 dcl SERVICE_UIC_M_SECURITY      fixed bin(31) value(SERVICE_BASE + 24);
 /* Security Failure. %0 */

 dcl SERVICE_UIC_M_LANROOT       fixed bin(31) value(SERVICE_BASE + 25);
 /* Bad or missing LAN Manager root directory. */

 dcl SERVICE_UIC_M_REDIR         fixed bin(31) value(SERVICE_BASE + 26);
 /* The network software is not installed. */

 dcl SERVICE_UIC_M_SERVER        fixed bin(31) value(SERVICE_BASE + 27);
 /* The server is not started. */

 dcl SERVICE_UIC_M_SEC_FILE_ERR  fixed bin(31) value(SERVICE_BASE + 28);
 /* The server cannot access the user accounts database (NET.ACC). */

 dcl SERVICE_UIC_M_FILES         fixed bin(31) value(SERVICE_BASE + 29);
 /* Incompatible files are installed in the LANMAN tree. */

 dcl SERVICE_UIC_M_LOGS          fixed bin(31) value(SERVICE_BASE + 30);
 /* The LANMAN\LOGS directory is invalid. */

 dcl SERVICE_UIC_M_LANGROUP      fixed bin(31) value(SERVICE_BASE + 31);
 /* The domain specified could not be used. */

 dcl SERVICE_UIC_M_MSGNAME       fixed bin(31) value(SERVICE_BASE + 32);
 /* The computer name is being used as a message alias */
 /* on another computer.                               */

 dcl SERVICE_UIC_M_ANNOUNCE      fixed bin(31) value(SERVICE_BASE + 33);
 /* The announcement of the server name failed. */

 dcl SERVICE_UIC_M_UAS           fixed bin(31) value(SERVICE_BASE + 34);
 /* The user accounts database is not configured correctly. */

 dcl SERVICE_UIC_M_SERVER_SEC_ERR
                                 fixed bin(31) value(SERVICE_BASE + 35);
 /* The server is not running with user-level security. */

 dcl SERVICE_UIC_M_WKSTA         fixed bin(31) value(SERVICE_BASE + 37);
 /* The workstation is not configured properly. */

 dcl SERVICE_UIC_M_ERRLOG        fixed bin(31) value(SERVICE_BASE + 38);
 /* View your error log for details. */

 dcl SERVICE_UIC_M_FILE_UW       fixed bin(31) value(SERVICE_BASE + 39);
 /* Unable to write to this file. */

 dcl SERVICE_UIC_M_ADDPAK        fixed bin(31) value(SERVICE_BASE + 40);
 /* ADDPAK file is corrupted.  Delete LANMAN\NETPROG\ADDPAK.SER */
 /* and reapply all ADDPAKs. */

 dcl SERVICE_UIC_M_LAZY          fixed bin(31) value(SERVICE_BASE + 41);
 /* The LM386 server cannot be started because CACHE.EXE */
 /* is not running.                                      */

 dcl SERVICE_UIC_M_UAS_MACHINE_ACCT
                                 fixed bin(31) value(SERVICE_BASE + 42);
 /* There is no account for this computer in the security database. */

 dcl SERVICE_UIC_M_UAS_SERVERS_NMEMB
                                 fixed bin(31) value(SERVICE_BASE + 43);
 /* This computer is not a member of the group SERVERS. */

 dcl SERVICE_UIC_M_UAS_SERVERS_NOGRP
                                 fixed bin(31) value(SERVICE_BASE + 44);
 /* The group SERVERS is not present in the local security database. */

 dcl SERVICE_UIC_M_UAS_INVALID_ROLE
                                 fixed bin(31) value(SERVICE_BASE + 45);
 /* This Windows NT computer is configured as a member of a      */
 /* workgroup, not as a member of a domain. The Netlogon service */
 /* does not need to run in this configuration.                  */

 dcl SERVICE_UIC_M_NETLOGON_NO_DC
                                 fixed bin(31) value(SERVICE_BASE + 46);
 /* The Windows NT domain controller for this domain could not */
 /* be located.                                                */

 dcl SERVICE_UIC_M_NETLOGON_DC_CFLCT
                                 fixed bin(31) value(SERVICE_BASE + 47);
 /* A primary domain controller is already running in this domain. */

 dcl SERVICE_UIC_M_NETLOGON_AUTH fixed bin(31) value(SERVICE_BASE + 48);
 /* The service failed to authenticate with the primary */
 /* domain controller.                                  */

 dcl SERVICE_UIC_M_UAS_PROLOG    fixed bin(31) value(SERVICE_BASE + 49);
 /* There is a problem with the security database creation date */
 /* or serial number. */


 dcl SERVICE2_BASE               fixed bin(31) value(5600);
 /* new SEVICE_UIC messages go here */

 dcl SERVICE_UIC_M_NETLOGON_MPATH
                                 fixed bin(31) value(SERVICE2_BASE + 0);
 /* Could not share the User or Script path. */

 dcl SERVICE_UIC_M_LSA_MACHINE_ACCT
                                 fixed bin(31) value(SERVICE2_BASE + 1);
 /* The password for this computer is not found in the local security da
 tabase. */

 dcl SERVICE_UIC_M_DATABASE_ERROR
                                 fixed bin(31) value(SERVICE2_BASE + 2);
 /* An internal error occurred while accessing the computer's */
 /* local or network security database. */



 /*  End modifiers */

 /* Commonly used Macros: */


 SERVICE_IP_CODE: proc (tt, nn)
                  returns (fixed bin (31))
                  options (inline reorder) internal;
   dcl tt fixed bin (16) unsigned,
       nn fixed bin (31);
   dcl (ior, isll) builtin;

   return (ior (SERVICE_IP_QUERY_HINT, nn,
                isll (tt, SERVICE_IP_WAITTIME_SHIFT)));
 end SERVICE_IP_CODE;


 SERVICE_CCP_CODE: proc (tt, nn)
                   returns (fixed bin (31))
                   options (inline reorder) internal;
   dcl tt fixed bin (16) unsigned,
       nn fixed bin (31);
   dcl (ior, isll) builtin;

   return (ior (SERVICE_CCP_QUERY_HINT, nn,
                isll (tt, SERVICE_IP_WAITTIME_SHIFT)));
 end SERVICE_CCP_CODE;

 SERVICE_UIC_CODE: proc (cc, mm)
                   returns (fixed bin (31))
                   options (inline reorder) internal;
   dcl cc fixed bin (16) unsigned,
       mm fixed bin (16) unsigned;
   dcl (ior, isll) builtin;

   return (ior (isll (cc, 16), mm));
 end SERVICE_UIC_CODE;


 /* This macro takes a wait hint (tt) which can have a maximum value */
 /* of 0xFFFF and puts it into the service status code field.        */
 /* 0x0FF1FFnn  (where nn is the checkpoint information).            */

 SERVICE_NT_CCP_CODE: proc (tt, nn)
                      returns (fixed bin (31))
                      options (inline reorder) internal;
   dcl tt fixed bin (16) unsigned,
       nn fixed bin (31);
   dcl (iand, ior, isll) builtin;

   return (ior (SERVICE_CCP_QUERY_HINT, nn,
                isll (iand (tt, LOWER_HINT_MASK),
                      SERVICE_IP_WAITTIME_SHIFT),
                isll (iand (tt, UPPER_HINT_MASK),
                      SERVICE_NTIP_WAITTIME_SHIFT)));
 end SERVICE_NT_CCP_CODE;


 /* This macro takes a status code field, and strips out the wait */
 /* hint from the upper and lower sections.                       */
 /* 0x0FF1FFnn results in 0x0000FFFF.                             */

 SERVICE_NT_WAIT_GET: proc (code)
                      returns (fixed bin (16) unsigned)
                      options (inline reorder) internal;
   dcl code fixed bin (31);
   dcl (iand, ior, isrl) builtin;

    return (ior (isrl (iand (code, UPPER_GET_HINT_MASK),
                       SERVICE_NTIP_WAITTIME_SHIFT),
                 isrl (iand (code, LOWER_GET_HINT_MASK),
                       SERVICE_IP_WAITTIME_SHIFT)));
 end SERVICE_NT_WAIT_GET;

 %end; /* _LMSVC_ */
