 /*****************************************************************/
 /** ODBCTYPE.CPY - This include defines the types used in ODBC.  */
 /**              - ODBC V 3.0 Level                              */
 /**                                                              */
 /*****************************************************************/
 /*                                                               */
 /*  Licensed Materials - Property of IBM                         */
 /*  5639-A83, 5639-A24 (C) Copyright IBM Corp. 1998.             */
 /*  All Rights Reserved.                                         */
 /*   (C) Copyright IBM Corp. 1998. All Rights Reserved.          */
 /*   US Government Users Restricted Rights-- Use, duplication or */
 /*   disclosure restricted by GSA ADP Schedule Contract with     */
 /*   IBM Corp.                                                   */
 /*                                                               */
 /* DISCLAIMER OF WARRANTIES                                      */
 /*   The following enclosed code is sample code created by IBM */
 /*   Corporation. This sample code is not part of any standard   */
 /*   IBM product and is provided to you solely for the purpose of*/
 /*   assisting you in the development of your applications.  The */
 /*   code is provided "AS IS", without warranty of any kind.     */
 /*   IBM shall not be liable for any damages arising out of your */
 /*   use of the sample code, even if IBM has been advised of the */
 /*   possibility of such damages.                                */
 /*                                                               */
 /*****************************************************************/

 %dcl #_SQLTYPES char ext;
 %if #_SQLTYPES = '' %then %do;
   %#_SQLTYPES = 'Y';

 /* if ODBCVER is not defined, assume version 3.00 */
 %dcl ODBCVER char ext;
 %if ODBCVER = '' %then %do;
   %ODBCVER  = '0300'x;
 %end; /* ODBCVER */


 %dcl SQL_API char ext;
 %SQL_API='options(linkage(stdcall) byvalue nodescriptor)';

 /* API declaration data types */
 %dcl SQLCHAR char ext;
 %SQLCHAR = 'char';        /* usage:  dcl blah SQLCHAR (10) */

 %if ODBCVER >= '0300'x %then %do;
 define alias SQLDATE      char (10);  /* ??? */
 %dcl SQLDECIMAL char ext;
 %SQLDECIMAL = 'decimal';  /* usage:  dcl blah SQLDECIMAL (15,2) */
 define alias SQLDOUBLE    float bin (53);
 define alias SQLFLOAT     float bin (53);
 %end;
 define alias SQLINTEGER   fixed bin(31);
 %if ODBCVER >= '0300'x %then %do;
 %dcl SQLNUMERIC char ext;
 %SQLNUMERIC = 'decimal';  /* usage:  dcl blah SQLNUMERIC (15,2) */
 %end;
 define alias SQLPOINTER   pointer;
 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQLREAL      float bin (21);
 %end;
 define alias SQLSMALLINT  fixed bin(15);
 define alias SQLUSMALLINT unsigned fixed bin(16);
 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQLTIME      char (8);  /* ??? */
 define alias SQLTIMESTAMP char (19); /* ??? */
 %dcl SQLVARCHAR char ext;
 %SQLVARCHAR = 'var char'; /* usage:  dcl blah SQLVARCHAR (10) */
 %end;

 /* function return type */
 define alias SQLRETURN type SQLSMALLINT;

 /* generic data structures */
 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQLHANDLE pointer;
 define alias SQLHENV  type SQLHANDLE;
 define alias SQLHDBC  type SQLHANDLE;
 define alias SQLHSTMT type SQLHANDLE;
 define alias SQLHDESC type SQLHANDLE;
 %end; %else %do;
 define alias SQLHENV  pointer;
 define alias SQLHDBC  pointer;
 define alias SQLHSTMT pointer;
 %end; /* ODBCVER >= '0300'x */

 /* SQL portable types for C */
 %dcl BASETYPES char ext;
 %if BASETYPES = '' %then %do;
 %BASETYPES = 'Y';
 define alias ULONG    unsigned fixed bin(32);
 define alias USHORT   unsigned fixed bin(16);
 define alias UCHAR    char;
 %end;

 define alias SCHAR    signed fixed bin(7);
 define alias SQLSCHAR type SCHAR;
 define alias SDWORD   fixed bin(31);
 define alias SWORD    fixed bin(15);
 define alias UDWORD   unsigned fixed bin(32);
 define alias UWORD    unsigned fixed bin(16);
 define alias SQLUINTEGER type UDWORD;

 define alias SLONG    signed fixed bin(31);
 define alias SSHORT   signed fixed bin(15);
 define alias SDOUBLE  float bin (53);
 define alias LDOUBLE  float bin (53);
 define alias SFLOAT   float bin (21);

 %dcl #WCHAR_DEFINED char ext;
 %if #WCHAR_DEFINED = '' %then %do;
 %#WCHAR_DEFINED = 'Y';
 define alias LPWSTR   pointer;
 %end;

 %dcl #DWORD_DEFINED char ext;
 %if #DWORD_DEFINED = '' %then %do;
 %#DWORD_DEFINED = 'Y';
 define alias DWORD    fixed bin(32) unsigned;
 define alias BOOL     fixed bin(31);
 %end;

 define alias HENV  pointer;
 define alias HDBC  pointer;
 define alias HSTMT pointer;

 define alias RETCODE signed fixed bin(15);

 %dcl WIN32 char ext;
 %dcl OS2   char ext;
 %dcl UNIX  char ext;
 %if (WIN32^='') | (OS2^='') %then %do;
 define alias SQLHWND pointer; /* it will do */
 %end; %else %if (UNIX ^= '') %then %do;
 define alias SQLHWND type Widget;
 %end; %else  %do;
 /* placehold for future O/S GUI window handle definition */
 define alias SQLHWND type SQLPOINTER;
 %end;

 %dcl #_SQLDATE char ext;
 %if #_SQLDATE = '' %then %do;
 %#_SQLDATE = 'Y';
 /* transfer types for DATE, TIME, TIMESTAMP */
 define structure
   1 DATE_STRUCT,
     2 year  type SQLSMALLINT,
     2 month type SQLUSMALLINT,
     2 day   type SQLUSMALLINT;

 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQL_DATE_STRUCT type DATE_STRUCT;
 %end;  /* ODBCVER >= '0300'x */

 define structure
   1 TIME_STRUCT,
     2 hour   type SQLUSMALLINT,
     2 minute type SQLUSMALLINT,
     2 second type SQLUSMALLINT;

 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQL_TIME_STRUCT type TIME_STRUCT;
 %end; /* ODBCVER >= '0300'x */

 define structure
   1 TIMESTAMP_STRUCT,
     2 year     type SQLSMALLINT,
     2 month    type SQLUSMALLINT,
     2 day      type SQLUSMALLINT,
     2 hour     type SQLUSMALLINT,
     2 minute   type SQLUSMALLINT,
     2 second   type SQLUSMALLINT,
     2 fraction type SQLUINTEGER;

 %if (ODBCVER >= '0300'x) %then %do;
 define alias SQL_TIMESTAMP_STRUCT type TIMESTAMP_STRUCT;
 %end;  /* ODBCVER >= '0300'x */


 /** enumerations for DATETIME_INTERVAL_SUBCODE values for interval */
 /** data types these values are from SQL-92                        */

 %if (ODBCVER >= '0300'x) %then %do;
 define ordinal
   SQLINTERVAL
       ( SQL_IS_YEAR             value(1),
         SQL_IS_MONTH            value(2),
         SQL_IS_DAY              value(3),
         SQL_IS_HOUR             value(4),
         SQL_IS_MINUTE           value(5),
         SQL_IS_SECOND           value(6),
         SQL_IS_YEAR_TO_MONTH    value(7),
         SQL_IS_DAY_TO_HOUR      value(8),
         SQL_IS_DAY_TO_MINUTE    value(9),
         SQL_IS_DAY_TO_SECOND    value(10),
         SQL_IS_HOUR_TO_MINUTE   value(11),
         SQL_IS_HOUR_TO_SECOND   value(12),
         SQL_IS_MINUTE_TO_SECOND value(13)
       ) precision(31);
 %end; /* ODBCVER >= '0300'x */

 %if (ODBCVER >= '0300'x) %then %do;
 define structure
   1 SQL_YEAR_MONTH,
     2 year  type SQLUINTEGER,
     2 month type SQLUINTEGER;

 define alias SQL_YEAR_MONTH_STRUCT type SQL_YEAR_MONTH;

 define structure
   1 SQL_DAY_SECOND,
     2 day      type SQLUINTEGER,
     2 hour     type SQLUINTEGER,
     2 minute   type SQLUINTEGER,
     2 second   type SQLUINTEGER,
     2 fraction type SQLUINTEGER;

 define alias SQL_DAY_SECOND_STRUCT type SQL_DAY_SECOND;

 define structure
   1 SQL_INTERVAL_STRUCT,
    2 interval_type ordinal SQLINTERVAL,
    2 interval_sign type SQLSMALLINT,
    2 intval union,
      3 year_month  type SQL_YEAR_MONTH_STRUCT,
      3 day_second  type SQL_DAY_SECOND_STRUCT;

 %end; /* ODBCVER >= '0300'x */

 %end; /* __SQLDATE */

 /* the ODBC C types for SQL_C_SBIGINT and SQL_C_UBIGINT */
 %if (ODBCVER >= '0300'x) %then %do;
 define alias ODBCINT64 fixed bin (63);

 define alias SQLBIGINT  type ODBCINT64;
 define alias SQLUBIGINT unsigned fixed bin (64);
 %end; /* ODBCVER >= '0300'x */

 /* internal representation of numeric data type */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_MAX_NUMERIC_LEN fixed bin(31) value(16);
 define structure
   1 SQL_NUMERIC_STRUCT,
    2 precision fixed bin (8) unsigned,
    2 scale     fixed bin (8) unsigned,
    2 sign      fixed bin (8) unsigned,/* 1 if positive, 0 if negative*/
    2 val       char(SQL_MAX_NUMERIC_LEN-1) varz;
 %end; /* ODBCVER >= '0300'x */

 define alias BOOKMARK unsigned fixed bin(32);

 %dcl SQLWCHAR char ext;
 %SQLWCHAR = 'WIDECHAR';

 %dcl SQLTCHAR char ext;
 %dcl UNICODE char ext;
 %if UNICODE ^= '' %then %do;
 %SQLTCHAR = SQLWCHAR;
 %end;  %else  %do;
 %SQLTCHAR = SQLCHAR;
 %end; /* UNICODE */

 %end; /* #ifndef __SQLTYPES */
