 /*++                                                                 */
 /*                                                                   */
 /* Copyright (c) 1991-1998 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   rpc.cpy                                                         */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   Master include file for RPC applications.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl RPC_NO_WINDOWS_H  char ext;
 %if RPC_NO_WINDOWS_H = '' %then %do;
  %dcl #WINBASE_ char ext;
  %if #WINBASE_ = '' %then %do;
   %include winbase;
  %end;
 %end; %else %do;

 %dcl #WCHAR_DEFINED char ext;
 %if #WCHAR_DEFINED = '' %then %do;
 %#WCHAR_DEFINED = 'Y';
 /* UNICODE (Wide Character) types */
 /* %dcl WCHAR char;     */
 /* %WCHAR = 'WIDECHAR'; */
 %end;

 %end; /* RPC_NO_WINDOWS_H */

 %dcl #_RPC_H__ char ext;
 %if #_RPC_H__ = '' %then %do;
 %#_RPC_H__ = 'Y';

 /*------------------------------------------------------------- */
 /* platform specific defines */
 /*------------------------------------------------------------- */


 %dcl #BASETSD_H_ char ext;
 %if #BASETSD_H_ = '' %then %do;
 %include basetsd;
 %end;

 %dcl #_RPC_WIN32__ char ext;
 %#_RPC_WIN32__ = '';

 define alias I_RPC_HANDLE pointer;
 define alias RPC_STATUS   fixed bin(31);

 %dcl RPC_UNICODE_SUPPORTED char ext;
 %RPC_UNICODE_SUPPORTED = 'Y';

 %dcl #_RPC_API char ext;
 %#_RPC_API  = 'options (byvalue linkage(stdcall) nodescriptor)';

 %dcl #_RPC_USER char ext;
 %#_RPC_USER = 'options (byvalue linkage(stdcall) nodescriptor)';
 %dcl #_RPC_STUB char ext;
 %#_RPC_STUB = 'options (byvalue linkage(stdcall) nodescriptor)';
 %dcl RPC_ENTRY char ext;
 %RPC_ENTRY  = 'options (byvalue linkage(stdcall) nodescriptor)';

 %dcl RPCRTAPI char ext;
 %RPCRTAPI = '';

 %dcl RPCNSAPI char ext;
 %RPCNSAPI = '';


 %dcl #WINERROR_ char ext;
 %if #WINERROR_ = '' %then %do;
 %include winerror;
 %end;

 %include rpcdce;
 %include rpcnsi;
 %include rpcnterr;

 /* Exception handling macros mapping to __try, __except and */
 /* __finally removed as PL/I uses different mechanism       */

 /* Definitions which depend on windows.h */
 %dcl RPC_NO_WINDOWS_H  char ext;
 %if RPC_NO_WINDOWS_H = '' %then %do;
   %include rpcasync;
 %end; /* RPC_NO_WINDOWS_H */


 %end; /* __RPC_H__ */

