 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1997-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   sddl.cpy                                                        */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the support and conversions routines        */
 /*   necessary for SDDL.                                             */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #_SDDL_H__ char ext;
 %if #_SDDL_H__ = '' %then %do;
 %#_SDDL_H__ = 'Y';

 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
 %include winbase;
 %end;

 %dcl #WIN32_WINNT   fixed ext; /* 1024 = NT4, 1280 = Windows 2000 */
 %dcl UNICODE char ext;


 /* SDDL Version information */

 dcl SDDL_REVISION_1 fixed bin(31) value(1);
 dcl SDDL_REVISION   fixed bin(31) value(SDDL_REVISION_1);


 /* SDDL Component tags */

 dcl SDDL_OWNER                 TCHAR value('O');  /* Owner tag */
 dcl SDDL_GROUP                 TCHAR value('G');  /* Group tag */
 dcl SDDL_DACL                  TCHAR value('D');  /* DACL tag */
 dcl SDDL_SACL                  TCHAR value('S');  /* SACL tag */


 /* SDDL Security descriptor controls */

 dcl SDDL_PROTECTED             TCHAR value('P');
                                /* DACL or SACL Protected */
 dcl SDDL_AUTO_INHERIT_REQ      TCHAR value('AR');
                                /* Auto inherit request */
 dcl SDDL_AUTO_INHERITED        TCHAR value('AI');
                                /* DACL/SACL are auto inherited */

 /* SDDL Ace types */

 dcl SDDL_ACCESS_ALLOWED        TCHAR value('A');  /* Access allowed */
 dcl SDDL_ACCESS_DENIED         TCHAR value('D');  /* Access denied */
 dcl SDDL_OBJECT_ACCESS_ALLOWED TCHAR value('OA');
                                /* Object access allowed */
 dcl SDDL_OBJECT_ACCESS_DENIED  TCHAR value('OD');
                                /* Object access denied */
 dcl SDDL_AUDIT                 TCHAR value('AU'); /* Audit */
 dcl SDDL_ALARM                 TCHAR value('AL'); /* Alarm */
 dcl SDDL_OBJECT_AUDIT          TCHAR value('OU'); /* Object audit */
 dcl SDDL_OBJECT_ALARM          TCHAR value('OL'); /* Object alarm */


 /* SDDL Ace flags */

 dcl SDDL_CONTAINER_INHERIT     TCHAR value('CI');
                                /* Container inherit */
 dcl SDDL_OBJECT_INHERIT        TCHAR value('OI'); /* Object inherit */
 dcl SDDL_NO_PROPAGATE          TCHAR value('NP');
                                /* Inherit no propagate */
 dcl SDDL_INHERIT_ONLY          TCHAR value('IO'); /* Inherit only */
 dcl SDDL_INHERITED             TCHAR value('ID'); /* Inherited */
 dcl SDDL_AUDIT_SUCCESS         TCHAR value('SA'); /* Audit success */
 dcl SDDL_AUDIT_FAILURE         TCHAR value('FA'); /* Audit failure */


 /* SDDL Rights */

 dcl SDDL_READ_PROPERTY         TCHAR value('RP');
 dcl SDDL_WRITE_PROPERTY        TCHAR value('WP');
 dcl SDDL_CREATE_CHILD          TCHAR value('CC');
 dcl SDDL_DELETE_CHILD          TCHAR value('DC');
 dcl SDDL_LIST_CHILDREN         TCHAR value('LC');
 dcl SDDL_SELF_WRITE            TCHAR value('SW');
 dcl SDDL_LIST_OBJECT           TCHAR value('LO');
 dcl SDDL_DELETE_TREE           TCHAR value('DT');
 dcl SDDL_CONTROL_ACCESS        TCHAR value('CR');
 dcl SDDL_READ_CONTROL          TCHAR value('RC');
 dcl SDDL_WRITE_DAC             TCHAR value('WD');
 dcl SDDL_WRITE_OWNER           TCHAR value('WO');
 dcl SDDL_STANDARD_DELETE       TCHAR value('SD');
 dcl SDDL_GENERIC_ALL           TCHAR value('GA');
 dcl SDDL_GENERIC_READ          TCHAR value('GR');
 dcl SDDL_GENERIC_WRITE         TCHAR value('GW');
 dcl SDDL_GENERIC_EXECUTE       TCHAR value('GX');
 dcl SDDL_FILE_ALL              TCHAR value('FA');
 dcl SDDL_FILE_READ             TCHAR value('FR');
 dcl SDDL_FILE_WRITE            TCHAR value('FW');
 dcl SDDL_FILE_EXECUTE          TCHAR value('FX');
 dcl SDDL_KEY_ALL               TCHAR value('KA');
 dcl SDDL_KEY_READ              TCHAR value('KR');
 dcl SDDL_KEY_WRITE             TCHAR value('KW');
 dcl SDDL_KEY_EXECUTE           TCHAR value('KX');


 /* SDDL User aliases */

 dcl SDDL_DOMAIN_ADMINISTRATORS         TCHAR value('DA');
     /* Domain admins */
 dcl SDDL_DOMAIN_GUESTS                 TCHAR value('DG');
     /* Domain guests */
 dcl SDDL_DOMAIN_USERS                  TCHAR value('DU');
     /* Domain users */
 dcl SDDL_ENTERPRISE_DOMAIN_CONTROLLERS TCHAR value('ED');
     /* Enterprise domain controllers */
 dcl SDDL_DOMAIN_DOMAIN_CONTROLLERS     TCHAR value('DD');
     /* Domain domain controllers */
 dcl SDDL_DOMAIN_COMPUTERS              TCHAR value('DC');
     /* Domain computers */
 dcl SDDL_BUILTIN_ADMINISTRATORS        TCHAR value('BA');
     /* Builtin (local ) administrators */
 dcl SDDL_BUILTIN_GUESTS                TCHAR value('BG');
     /* Builtin (local ) guests */
 dcl SDDL_BUILTIN_USERS                 TCHAR value('BU');
     /* Builtin (local ) users */
 dcl SDDL_LOCAL_ADMIN                   TCHAR value('LA');
     /* Local administrator account */
 dcl SDDL_LOCAL_GUEST                   TCHAR value('LG');
     /* Local group account */
 dcl SDDL_ACCOUNT_OPERATORS             TCHAR value('AO');
     /* Account operators */
 dcl SDDL_BACKUP_OPERATORS              TCHAR value('BO');
     /* Backup operators */
 dcl SDDL_PRINTER_OPERATORS             TCHAR value('PO');
     /* Printer operators */
 dcl SDDL_SERVER_OPERATORS              TCHAR value('SO');
     /* Server operators */
 dcl SDDL_AUTHENTICATED_USERS           TCHAR value('AU');
     /* Authenticated users */
 dcl SDDL_PERSONAL_SELF                 TCHAR value('PS');
     /* Personal self */
 dcl SDDL_CREATOR_OWNER                 TCHAR value('CO');
     /* Creator owner */
 dcl SDDL_CREATOR_GROUP                 TCHAR value('CG');
     /* Creator group */
 dcl SDDL_LOCAL_SYSTEM                  TCHAR value('SY');
     /* Local system */
 dcl SDDL_POWER_USERS                   TCHAR value('PU');
     /* Power users */
 dcl SDDL_EVERYONE                      TCHAR value('WD');
     /* Everyone ( World ) */
 dcl SDDL_REPLICATOR                    TCHAR value('RE');
     /* Replicator */
 dcl SDDL_INTERACTIVE                   TCHAR value('IU');
     /* Interactive logon user */
 dcl SDDL_NETWORK                       TCHAR value('NU');
     /* Nework logon user */
 dcl SDDL_SERVICE                       TCHAR value('SU');
     /* Service logon user */
 dcl SDDL_RESTRICTED_CODE               TCHAR value('RC');
     /* Restricted code */
 dcl SDDL_SCHEMA_ADMINISTRATORS         TCHAR value('SA');
     /* Schema Administrators */
 dcl SDDL_CERT_SERV_ADMINISTRATORS      TCHAR value('CA');
     /* Certificate Server Administrators */
 dcl SDDL_RAS_SERVERS                   TCHAR value('RS');
     /* RAS servers group */
 dcl SDDL_ENTERPRISE_ADMINS             TCHAR value('EA');
     /* Enterprise administrators */
 dcl SDDL_GROUP_POLICY_ADMINS           TCHAR value('PA');
     /* Group Policy administrators*/
 dcl SDDL_ALIAS_PREW2KCOMPACC           TCHAR value('RU');
     /* alias to allow previous windows 2000 */


 /* SDDL Seperators */

 dcl SDDL_SEPERATORC   TCHAR value(';');
 dcl SDDL_DELIMINATORC TCHAR value(':');
 dcl SDDL_ACE_BEGINC   TCHAR value('(');
 dcl SDDL_ACE_ENDC     TCHAR value(')');


 %if (#WIN32_WINNT >= 1280) %then %do;

 dcl ConvertSidToStringSidA
     entry (type PSID,
            type LPSTR byaddr)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI external('ConvertSidToStringSidA');

 dcl ConvertSidToStringSidW
     entry (type PSID,
            type LPWSTR byaddr)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI external('ConvertSidToStringSidW');
 %dcl ConvertSidToStringSid char ext;
 %if UNICODE ^= '' %then %do;
   %ConvertSidToStringSid='ConvertSidToStringSidW';
 %end; %else %do;
   %ConvertSidToStringSid='ConvertSidToStringSidA';
 %end; /* !UNICODE */

 dcl ConvertStringSidToSidA
     entry (char(*) varz byaddr nonasgn,
            type PSID byaddr)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI external('ConvertStringSidToSidA');

 dcl ConvertStringSidToSidW
     entry (WCHAR(*) varz byaddr nonasgn,
            type PSID byaddr)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI external('ConvertStringSidToSidW');

 %dcl ConvertStringSidToSid char ext;
 %if UNICODE ^= '' %then %do;
   %ConvertStringSidToSid='ConvertStringSidToSidW';
 %end; %else %do;
   %ConvertStringSidToSid='ConvertStringSidToSidA';
 %end; /* !UNICODE */

 dcl ConvertStringSecurityDescriptorToSecurityDescriptorA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type PSECURITY_DESCRIPTOR byaddr,
            type ULONG byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI
     external('ConvertStringSecurityDescriptorToSecurityDescriptorA');
 dcl ConvertStringSecurityDescriptorToSecurityDescriptorW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type PSECURITY_DESCRIPTOR byaddr,
            type ULONG byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI
     external('ConvertStringSecurityDescriptorToSecurityDescriptorW');

 %dcl ConvertStringSecurityDescriptorToSecurityDescriptor char ext;
 %if UNICODE ^= '' %then %do;
   %ConvertStringSecurityDescriptorToSecurityDescriptor
     ='ConvertStringSecurityDescriptorToSecurityDescriptorW';
 %end; %else %do;
   %ConvertStringSecurityDescriptorToSecurityDescriptor
     ='ConvertStringSecurityDescriptorToSecurityDescriptorA';
 %end; /* !UNICODE */

 dcl ConvertSecurityDescriptorToStringSecurityDescriptorA
     entry (type PSECURITY_DESCRIPTOR,
            type DWORD,
            type SECURITY_INFORMATION,
            type LPSTR byaddr optional,
            type ULONG byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI
     external('ConvertSecurityDescriptorToStringSecurityDescriptorA');
 dcl ConvertSecurityDescriptorToStringSecurityDescriptorW
     entry (type PSECURITY_DESCRIPTOR,
            type DWORD,
            type SECURITY_INFORMATION,
            type LPWSTR byaddr optional,
            type ULONG byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI WINADVAPI
     external('ConvertSecurityDescriptorToStringSecurityDescriptorW');
 %dcl ConvertSecurityDescriptorToStringSecurityDescriptor char ext;
 %if UNICODE ^= '' %then %do;
   %ConvertSecurityDescriptorToStringSecurityDescriptor
     ='ConvertSecurityDescriptorToStringSecurityDescriptorW';
 %end; %else %do;
   %ConvertSecurityDescriptorToStringSecurityDescriptor
     ='ConvertSecurityDescriptorToStringSecurityDescriptorA';
 %end; /* !UNICODE */

 %end; /* _WIN32_WINNT >=  0x0500 */

 %end;  /* endif __SDDL_H__ */


