 /* tkDecls.cpy --                                                    */
 /*                                                                   */
 /*	Declarations of functions in the platform independent public Tcl  */
 /* (Tk) API.                                                         */
 /*                                                                   */
 /* Copyright (c) 1998-1999 by Scriptics Corporation.                 */
 /* Copyright (c) 1998-2000 Mark Yudkin (PL/I translation)            */

 %dcl #TKDECLS char ext;
 %if #TKDECLS = '' %then %do;
 %#TKDECLS = 'Y';

 %dcl TK_ENTRY_API     char;
 %TK_ENTRY_API      = 'options (byvalue nodescriptor linkage(cdecl))';

 %dcl USE_TK_STUBS      char;
 %dcl USE_TK_STUB_PROCS char;

 %if USE_TK_STUBS = '' | USE_TK_STUB_PROCS ^= '' %then %do;

 dcl Tk_3DBorderColor
     entry (type Tk_3DBorder)
     returns (handle XColor byvalue)
     TK_ENTRY_API
     external('Tk_3DBorderColor');

 dcl Tk_3DBorderGC
     entry (type Tk_Window,
            type Tk_3DBorder,
            fixed bin (31))
     returns (type GC byvalue optional)
     TK_ENTRY_API
     external('Tk_3DBorderGC');

 dcl Tk_3DHorizontalBevel
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_3DHorizontalBevel');

 dcl Tk_3DVerticalBevel
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_3DVerticalBevel');

 dcl Tk_AddOption
     entry (type Tk_Window,
            char (*) varz byaddr,
            char (*) varz byaddr,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_AddOption');

 dcl Tk_AllocBitmapFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (type Pixmap byvalue optional)
     TK_ENTRY_API
     external('Tk_AllocBitmapFromObj');

 dcl Tk_Alloc3DBorderFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_3DBorder byvalue optional)
     TK_ENTRY_API
     external('Tk_Alloc3DBorderFromObj');

 dcl Tk_AllocColorFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (handle XColor byvalue optional)
     TK_ENTRY_API
     external('Tk_AllocColorFromObj');

 dcl Tk_AllocCursorFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_3DBorder byvalue optional)
     TK_ENTRY_API
     external('Tk_AllocCursorFromObj');

 dcl Tk_AllocFontFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_Font byvalue optional)
     TK_ENTRY_API
     external('Tk_AllocFontFromObj');

 dcl Tk_BindEvent
     entry (type Tk_BindingTable,
            handle XEvent,
            type Tk_Window,
            fixed bin (31),
            type ClientData byaddr)
     TK_ENTRY_API
     external('Tk_BindEvent');

 dcl Tk_CanvasDrawableCoords
     entry (type Tk_Canvas,
            float bin (53),
            float bin (53),
            fixed bin (16) unsigned byaddr,
            fixed bin (16) unsigned byaddr)
     TK_ENTRY_API
     external('Tk_CanvasDrawableCoords');

 dcl Tk_CanvasEventuallyRedraw
     entry (type Tk_Canvas,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_CanvasEventuallyRedraw');

 dcl Tk_CanvasGetCoord
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            char (*) varz byaddr,
            float bin (53) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasGetCoord');

 dcl Tk_CanvasGetCoordFromObj
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            handle Tcl_Obj,
            float bin (53) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasGetCoordFromObj');


 dcl Tk_CanvasGetTextInfo
     entry (type Tk_Canvas)
     returns (handle Tk_CanvasTextInfo byvalue)
     TK_ENTRY_API
     external('Tk_CanvasGetTextInfo');

 dcl Tk_CanvasPsBitmap
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            type Pixmap,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsBitmap');

 dcl Tk_CanvasPsColor
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            type Xcolor byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsColor');

 dcl Tk_CanvasPsFont
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            type Tk_Font)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsFont');

 dcl Tk_CanvasPsOutline
     entry (type Tk_Canvas,
            type Tk_Item byaddr,
            type Tk_Outline byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsOutline');

 dcl Tk_CanvasPsPath
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            float bin (53) byaddr,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_CanvasPsPath');

 dcl Tk_CanvasPsStipple
     entry (handle Tcl_Interp,
            type Tk_Canvas,
            type Pixmap)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsStipple');

 dcl Tk_CanvasPsY
     entry (type Tk_Canvas,
            float bin (53))
     returns (float bin (53) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasPsY');

 dcl Tk_CanvasSetOffset
     entry (type Tk_Canvas,
            type GC,
            type Tk_TSOffset byaddr)
     TK_ENTRY_API
     external('Tk_CanvasSetOffset');

 dcl Tk_CanvasSetStippleOrigin
     entry (type Tk_Canvas,
            type GC)
     TK_ENTRY_API
     external('Tk_CanvasSetStippleOrigin');

 dcl Tk_CanvasTagsParseProc
     entry (type ClientData,
            handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            pointer, /* to a widget record */
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasTagsParseProc');

 dcl Tk_CanvasTagsPrintProc
     entry (type ClientData,
            type Tk_Window,
            pointer, /* to a widget record */
            fixed bin (31),
            type Tcl_FreeProc byaddr)
     returns (pointer byvalue) /* to something, undocumented */
     TK_ENTRY_API
     external('Tk_CanvasTagsPrintProc');

 dcl Tk_CanvasTkwin
     entry (type Tk_Canvas)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_CanvasTkwin');

 dcl Tk_CanvasWindowCoords
     entry (type Tk_Canvas,
            float bin (53),
            float bin (53),
            fixed bin (16) unsigned byaddr,
            fixed bin (16) unsigned byaddr)
     TK_ENTRY_API
     external('Tk_CanvasWindowCoords');

 dcl Tk_ChangeOutlineGC
     entry (type Tk_Canvas,
            type Tk_Item byaddr,
            type Tk_Outline byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ChangeOutlineGC');

 dcl Tk_ChangeWindowAttributes
     entry (type Tk_Window,
            fixed bin (32) unsigned,
            type XSetWindowAttributes byaddr)
     TK_ENTRY_API
     external('Tk_ChangeWindowAttributes');

 dcl Tk_CharBbox
     entry (type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31) byaddr,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CharBbox');

 dcl Tk_ClearSelection
     entry (type Tk_Window,
            type XAtom)
     TK_ENTRY_API
     external('Tk_ClearSelection');

 dcl Tk_ClipboardAppend
     entry (handle Tcl_Interp,
            type Tk_Window,
            type XAtom,
            type XAtom,
            char (*) varz byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ClipboardAppend');

 dcl Tk_ClipboardClear
     entry (handle Tcl_Interp,
            type Tk_Window)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ClipboardClear');

 dcl Tk_ConfigOutlineGC
     entry (type XGCValues byaddr,
            type Tk_Canvas,
            type Tk_Item byaddr,
            type Tk_Outline byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ConfigOutlineGC');

 dcl Tk_ConfigureInfo
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_ConfigSpec byaddr,
            pointer, /* to a widget record */
            char (*) varz byaddr optional,
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ConfigureInfo');

 dcl Tk_ConfigureValue
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_ConfigSpec byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ConfigureValue');

 dcl Tk_ConfigureWidget
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_ConfigSpec byaddr,
            fixed bin (31),
            (*) pointer byaddr, /* each to char (*) varz */
            pointer, /* to a widget record */
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ConfigureWidget');

 dcl Tk_ConfigureWindow
     entry (type Tk_Window,
            fixed bin (32) unsigned,
            type XWindowChanges byaddr)
     TK_ENTRY_API
     external('Tk_ConfigureWindow');

 dcl Tk_ComputeTextLayout
     entry (type Tk_Font,
            char (*) varz nonasgn byaddr,
            fixed bin (31),
            fixed bin (31),
            type Tk_Justify,
            fixed bin (31),
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     returns (type Tk_TextLayout byvalue optional)
     TK_ENTRY_API
     external('Tk_ComputeTextLayout');

 dcl Tk_CoordsToWindow
     entry (fixed bin (31),
            fixed bin (31),
            type Tk_Window)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_CoordsToWindow');

 dcl Tk_CreateBinding
     entry (handle Tcl_Interp,
            type Tk_BindingTable,
            type ClientData,
            char (*) varz byaddr,
            char (*) varz byaddr,
            fixed bin (31))
     returns (fixed bin (32) unsigned byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateBinding');

 dcl Tk_CreateBindingTable
     entry (handle Tcl_Interp)
     returns (type Tk_BindingTable byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateBindingTable');

 dcl Tk_CreateClientMessageHandler
     entry (type Tk_ClientMessageProc)
     TK_ENTRY_API
     external('Tk_CreateClientMessageHandler');

 dcl Tk_CreateErrorHandler
     entry (handle Display,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            type Tk_ErrorProc,
            type ClientData)
     returns (type Tk_ErrorHandler byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateErrorHandler');

 dcl Tk_CreateEventHandler
     entry (type Tk_Window,
            fixed bin (32) unsigned,
            type Tk_EventProc,
            type ClientData)
     TK_ENTRY_API
     external('Tk_CreateEventHandler');

 dcl Tk_CreateConsoleWindow
     entry (handle Tcl_Interp)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateConsoleWindow');

 dcl Tk_CreateGenericHandler
     entry (type Tk_GenericProc,
            type ClientData)
     TK_ENTRY_API
     external('Tk_CreateGenericHandler');

 %if USE_OLD_IMAGE ^= '' %then %do;
 dcl Tk_CreateImageType
     entry (type Tk_ImageType byaddr)
     TK_ENTRY_API
     external('Tk_CreateImageType');
 %end;

 dcl Tk_CreateItemType
     entry (type Tk_ItemType byaddr)
     TK_ENTRY_API
     external('Tk_CreateItemType');

 dcl Tk_CreateOptionTable
     entry (handle Tcl_Interp,
            type Tk_OptionSpec byaddr nonasgn)
     returns (type Tk_OptionTable byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateOptionTable');

 dcl Tk_CreateOutline
     entry (type Tk_Outline byaddr)
     TK_ENTRY_API
     external('Tk_CreateOutline');

 %if USE_OLD_IMAGE ^= '' %then %do;
 dcl Tk_CreatePhotoImageFormat
     entry (type Tk_PhotoImageFormat byaddr)
     TK_ENTRY_API
     external('Tk_CreatePhotoImageFormat');
 %end;

 dcl Tk_CreateSelHandler
     entry (type Tk_Window,
            type XAtom,
            type XAtom,
            type Tk_SelectionProc,
            type ClientData,
            type XAtom)
     TK_ENTRY_API
     external('Tk_CreateSelHandler');

 dcl Tk_CreateSmoothMethod
     entry (handle Tcl_Interp,
            type Tk_SmoothMethod byaddr)
     TK_ENTRY_API
     external('Tk_CreateSmoothMethod');

 dcl Tk_CreateWindow
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            char (*) varz byaddr)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateWindow');

 dcl Tk_CreateWindowFromPath
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            char (*) varz byaddr)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_CreateWindowFromPath');

 dcl Tk_DefineBitmap
     entry (handle Tcl_Interp,
            type Tk_Uid,
            pointer, /* to bitmap data in static storage */
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_DefineBitmap');

 dcl Tk_DefineCursor
     entry (type Tk_Window,
            type Tk_Cursor)
     TK_ENTRY_API
     external('Tk_DefineCursor');

 dcl Tk_DeleteAllBindings
     entry (type Tk_BindingTable,
            type ClientData)
     TK_ENTRY_API
     external('Tk_DeleteAllBindings');

 dcl Tk_DeleteBinding
     entry (handle Tcl_Interp,
            type Tk_BindingTable,
            type ClientData,
            char (*) varz byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_DeleteBinding');

 dcl Tk_DeleteBindingTable
     entry (type Tk_BindingTable)
     TK_ENTRY_API
     external('Tk_DeleteBindingTable');

 dcl Tk_DeleteClientMessageHandler
     entry (type Tk_ClientMessageProc)
     TK_ENTRY_API
     external('Tk_DeleteClientMessageHandler');

 dcl Tk_DeleteErrorHandler
     entry (type Tk_ErrorHandler)
     TK_ENTRY_API
     external('Tk_DeleteErrorHandler');

 dcl Tk_DeleteEventHandler
     entry (type Tk_Window,
            fixed bin (32) unsigned,
            type Tk_EventProc,
            type ClientData)
     TK_ENTRY_API
     external('Tk_DeleteEventHandler');

 dcl Tk_DeleteGenericHandler
     entry (type Tk_GenericProc,
            type ClientData)
     TK_ENTRY_API
     external('Tk_DeleteGenericHandler');

 dcl Tk_DeleteImage
     entry (handle Tcl_Interp,
            char (*) varz byaddr)
     TK_ENTRY_API
     external('Tk_DeleteImage');

 dcl Tk_DeleteOptionTable
     entry (type Tk_OptionTable)
     TK_ENTRY_API
     external('Tk_DeleteOptionTable');

 dcl Tk_DeleteOutline
     entry (handle Display,
            type Tk_Outline byaddr)
     TK_ENTRY_API
     external('Tk_DeleteOutline');

 dcl Tk_DeleteSelHandler
     entry (type Tk_Window,
            type XAtom,
            type XAtom)
     TK_ENTRY_API
     external('Tk_DeleteSelHandler');

 dcl Tk_DestroyWindow
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_DestroyWindow');

 dcl Tk_DisplayName
     entry (type Tk_Window)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_DisplayName');

 dcl Tk_DistanceToTextLayout
     entry (type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_DistanceToTextLayout');

 dcl Tk_DitherPhoto
     entry (type Tk_PhotoHandle,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_DitherPhoto');

 dcl Tk_Draw3DPolygon
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            type XPoint byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_Draw3DPolygon');

 dcl Tk_Draw3DRectangle
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_Draw3DRectangle');

 dcl Tk_DrawChars
     entry (handle Display,
            type Drawable,
            type GC,
            type Tk_Font,
            char (*) varz nonasgn byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_DrawChars');

 dcl Tk_DrawFocusHighlight
     entry (type Tk_Window,
            type GC,
            fixed bin (31),
            type Drawable)
     TK_ENTRY_API
     external('Tk_DrawFocusHighlight');

 dcl Tk_DrawTextLayout
     entry (handle Display,
            type Drawable,
            type GC,
            type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_DrawTextLayout');

 dcl Tk_Fill3DPolygon
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            type XPoint byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_Fill3DPolygon');

 dcl Tk_Fill3DRectangle
     entry (type Tk_Window,
            type Drawable,
            type Tk_3DBorder,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_Fill3DRectangle');

 dcl Tk_FindPhoto
     entry (handle Tcl_Interp,
            char (*) varz byaddr)
     returns (type Tk_PhotoHandle byvalue optional)
     TK_ENTRY_API
     external('Tk_FindPhoto');

 dcl Tk_FontId
     entry (type Tk_Font)
     returns (type Font byvalue optional)
     TK_ENTRY_API
     external('Tk_FontId');

 dcl Tk_Free3DBorder
     entry (type Tk_3DBorder)
     TK_ENTRY_API
     external('Tk_Free3DBorder');

 dcl Tk_Free3DBorderFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     TK_ENTRY_API
     external('Tk_Free3DBorderFromObj');

 dcl Tk_FreeBitmap
     entry (handle Display,
            type Pixmap)
     TK_ENTRY_API
     external('Tk_FreeBitmap');

 dcl Tk_FreeBitmapFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     TK_ENTRY_API
     external('Tk_FreeBitmapFromObj');

 dcl Tk_FreeColor
     entry (type Xcolor byaddr)
     TK_ENTRY_API
     external('Tk_FreeColor');

 dcl Tk_FreeColorFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     TK_ENTRY_API
     external('Tk_FreeColorFromObj');

 dcl Tk_FreeColormap
     entry (handle Display,
            type XColormap)
     TK_ENTRY_API
     external('Tk_FreeColormap');

 dcl Tk_FreeConfigOptions
     entry (pointer,
            type Tk_OptionTable,
            type Tk_Window)
     TK_ENTRY_API
     external('Tk_FreeConfigOptions');

 dcl Tk_FreeCursor
     entry (handle Display,
            type Tk_Cursor)
     TK_ENTRY_API
     external('Tk_FreeCursor');

 dcl Tk_FreeCursorFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     TK_ENTRY_API
     external('Tk_FreeCursorFromObj');

 dcl Tk_FreeFont
     entry (type Tk_Font)
     TK_ENTRY_API
     external('Tk_FreeFont');

 dcl Tk_FreeFontFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     TK_ENTRY_API
     external('Tk_FreeFontFromObj');

 dcl Tk_FreeGC
     entry (handle Display,
            type GC)
     TK_ENTRY_API
     external('Tk_FreeGC');

 dcl Tk_FreeImage
     entry (type Tk_Image)
     TK_ENTRY_API
     external('Tk_FreeImage');

 dcl Tk_FreeOptions
     entry (type Tk_ConfigSpec byaddr,
            pointer, /* to a widget record */
            handle Display,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_FreeOptions');

 dcl Tk_FreePixmap
     entry (handle Display,
            type Pixmap)
     TK_ENTRY_API
     external('Tk_FreePixmap');

 dcl Tk_FreeSavedOptions
     entry (type Tk_SavedOptions byaddr)
     TK_ENTRY_API
     external('Tk_FreeSavedOptions');

 dcl Tk_FreeTextLayout
     entry (type Tk_TextLayout)
     TK_ENTRY_API
     external('Tk_FreeTextLayout');

 dcl Tk_FreeXId
     entry (handle Display,
            type XID)
     TK_ENTRY_API
     external('Tk_FreeXId');

 dcl Tk_GCForColor
     entry (type Xcolor byaddr,
            type Drawable)
     returns (type GC byvalue optional)
     TK_ENTRY_API
     external('Tk_GCForColor');

 dcl Tk_GeometryRequest
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_GeometryRequest');

 dcl Tk_Get3DBorder
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_Uid)
     returns (type Tk_3DBorder byvalue optional)
     TK_ENTRY_API
     external('Tk_Get3DBorder');

 dcl Tk_Get3DBorderFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_3DBorder byvalue optional)
     TK_ENTRY_API
     external('Tk_Get3DBorderFromObj');

 dcl Tk_GetAllBindings
     entry (handle Tcl_Interp,
            type Tk_BindingTable,
            type ClientData)
     TK_ENTRY_API
     external('Tk_GetAllBindings');

 dcl Tk_GetAnchor
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            type Tk_Anchor byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetAnchor');

 dcl Tk_GetAnchorFromObj
     entry (type Tk_Window,
            handle Tcl_Obj,
            type TK_Anchor byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetAnchorFromObj');

 dcl Tk_GetAtomName
     entry (type Tk_Window,
            type XAtom)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_GetAtomName');

 dcl Tk_GetBinding
     entry (handle Tcl_Interp,
            type Tk_BindingTable,
            type ClientData,
            char (*) varz byaddr)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_GetBinding');

 dcl Tk_GetBitmap
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_Uid)
     returns (type Pixmap byvalue optional)
     TK_ENTRY_API
     external('Tk_GetBitmap');

 dcl Tk_GetBitmapFromData
     entry (handle Tcl_Interp,
            type Tk_Window,
            pointer, /* to bitmap data */
            fixed bin (31),
            fixed bin (31))
     returns (type Pixmap byvalue optional)
     TK_ENTRY_API
     external('Tk_GetBitmapFromData');

 dcl Tk_GetBitmapFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     returns (type Pixmap byvalue optional)
     TK_ENTRY_API
     external('Tk_GetBitmapFromObj');

 dcl Tk_GetCapStyle
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetCapStyle');

 dcl Tk_GetColor
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_Uid)
     returns (handle XColor byvalue)
     TK_ENTRY_API
     external('Tk_GetColor');

 dcl Tk_GetColorByValue
     entry (type Tk_Window,
            type Xcolor byaddr)
     returns (handle XColor byvalue)
     TK_ENTRY_API
     external('Tk_GetColorByValue');

 dcl Tk_GetColorFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     returns (handle XColor byvalue)
     TK_ENTRY_API
     external('Tk_GetColorFromObj');

 dcl Tk_GetColormap
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr)
     returns (type XColormap byvalue optional)
     TK_ENTRY_API
     external('Tk_GetColormap');

 dcl Tk_GetCursor
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_Uid)
     returns (type Tk_Cursor byvalue optional)
     TK_ENTRY_API
     external('Tk_GetCursor');

 dcl Tk_GetCursorFromData
     entry (handle Tcl_Interp,
            type Tk_Window,
            pointer, /* to bitmap data */
            pointer, /* to mask data */
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            type Tk_Uid,
            type Tk_Uid)
     returns (type Tk_Cursor byvalue optional)
     TK_ENTRY_API
     external('Tk_GetCursorFromData');

 dcl Tk_GetCursorFromObj
     entry (type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_Cursor byvalue optional)
     TK_ENTRY_API
     external('Tk_GetCursorFromObj');

 dcl Tk_GetDash
     entry (handle Tcl_Interp,
            char (*) varz byaddr nonasgn,
            type Tk_Dash  byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetDash');

 dcl Tk_GetFont
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz nonasgn byaddr)
     returns (type Tk_Font byvalue optional)
     TK_ENTRY_API
     external('Tk_GetFont');

 dcl Tk_GetFontFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj)
     returns (type Tk_Font byvalue optional)
     TK_ENTRY_API
     external('Tk_GetFontFromObj');

 dcl Tk_GetFontMetrics
     entry (type Tk_Font,
            type Tk_FontMetrics byaddr)
     TK_ENTRY_API
     external('Tk_GetFontMetrics');

 dcl Tk_GetGC
     entry (type Tk_Window,
            fixed bin (32) unsigned,
            type XGCValues byaddr)
     returns (type GC byvalue optional)
     TK_ENTRY_API
     external('Tk_GetGC');

 dcl Tk_GetImage
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            type Tk_ImageChangedProc,
            type ClientData)
     returns (type Tk_Image byvalue optional)
     TK_ENTRY_API
     external('Tk_GetImage');

 dcl Tk_GetImageMasterData
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            handle Tk_ImageType byaddr)
     returns (type ClientData byvalue optional)
     TK_ENTRY_API
     external('Tk_GetImageMasterData');

 dcl Tk_GetItemTypes
     entry ()
     returns (handle Tk_ItemType byvalue)
     TK_ENTRY_API
     external('Tk_GetItemTypes');

 dcl Tk_GetJoinStyle
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetJoinStyle');

 dcl Tk_GetJustify
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            type Tk_Justify byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetJustify');

 dcl Tk_GetJustifyFromObj
     entry (handle Tcl_Interp,
            handle Tcl_Obj,
            type Tk_Justify byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetJustifyFromObj');

 dcl Tk_GetMMFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj,
            float bin(53) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetMMFromObj');

 dcl Tk_GetNumMainWindows
     entry ()
     returns (fixed bin (31) byvalue)
     TK_ENTRY_API
     external('Tk_GetNumMainWindows');

 dcl Tk_GetOption
     entry (type Tk_Window,
            char (*) varz byaddr,
            char (*) varz byaddr optional)
     returns (type Tk_Uid byvalue optional)
     TK_ENTRY_API
     external('Tk_GetOption');

 dcl Tk_GetOptionInfo
     entry (handle Tcl_Interp,
            pointer,
            type Tk_OptionTable,
            handle Tcl_Obj,
            type Tk_Window)
     returns (handle Tcl_Obj byvalue optional)
     TK_ENTRY_API
     external('Tk_GetOptionInfo');

 dcl Tk_GetOptionValue
     entry (handle Tcl_Interp,
            pointer,
            type Tk_OptionTable,
            handle Tcl_Obj,
            type Tk_Window)
     returns (handle Tcl_Obj byvalue optional)
     TK_ENTRY_API
     external('Tk_GetOptionValue');

 dcl Tk_GetPixels
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue)
     TK_ENTRY_API
     external('Tk_GetPixels');

 dcl Tk_GetPixelsFromObj
     entry (handle Tcl_Interp,
            type Tk_Window,
            handle Tcl_Obj,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue)
     TK_ENTRY_API
     external('Tk_GetPixelsFromObj');

 dcl Tk_GetPixmap
     entry (handle Display,
            type Drawable,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     returns (type Pixmap byvalue optional)
     TK_ENTRY_API
     external('Tk_GetPixmap');

 dcl Tk_GetRelief
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetRelief');

 dcl Tk_GetReliefFromObj
     entry (handle Tcl_Interp,
            handle Tcl_Obj,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetReliefFromObj');

 dcl Tk_GetRootCoords
     entry (type Tk_Window,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     TK_ENTRY_API
     external('Tk_GetRootCoords');

 dcl Tk_GetScrollInfo
     entry (handle Tcl_Interp,
            fixed bin (31),
            (*) pointer byaddr, /* each to char (*) varz */
            float bin (53) byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetScrollInfo');

 dcl Tk_GetScrollInfoObj
     entry (handle Tcl_Interp,
            fixed bin (31),
            (*) handle Tcl_Obj byaddr nonasgn,
            float bin (53) byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetScrollInfoObj');

 dcl Tk_GetScreenMM
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            float bin (53) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_GetScreenMM');

 dcl Tk_GetSelection
     entry (handle Tcl_Interp,
            type Tk_Window,
            type XAtom,
            type XAtom,
            type Tk_GetSelProc,
            type ClientData)
     returns (fixed bin (31) byvalue)
     TK_ENTRY_API
     external('Tk_GetSelection');

 dcl Tk_GetUid
     entry (char (*) varz nonasgn byaddr)
     returns (type Tk_Uid byvalue optional)
     TK_ENTRY_API
     external('Tk_GetUid');

 dcl Tk_GetVisual
     entry (handle Tcl_Interp,
            type Tk_Window,
            char (*) varz byaddr,
            fixed bin (31) byaddr,
            type XColormap byaddr optional)
     returns (handle Visual byvalue)
     TK_ENTRY_API
     external('Tk_GetVisual');

 dcl Tk_GetVRootGeometry
     entry (type Tk_Window,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     TK_ENTRY_API
     external('Tk_GetVRootGeometry');

 dcl Tk_Grab
     entry (handle Tcl_Interp,
            type Tk_Window,
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_Grab');

 dcl Tk_HandleEvent
     entry (handle XEvent)
     TK_ENTRY_API
     external('Tk_HandleEvent');

 dcl Tk_IdToWindow
     entry (handle Display,
            type Window)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_IdToWindow');

 dcl Tk_ImageChanged
     entry (type Tk_ImageMaster,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_ImageChanged');

 dcl Tk_Init
     entry (handle Tcl_Interp)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_Init');

 dcl Tk_InitConsoleChannels
     entry (handle Tcl_Interp)
     TK_ENTRY_API
     external('Tk_InitConsoleChannels');

 dcl Tk_InitOptions
     entry (handle Tcl_Interp,
            pointer,
            type Tk_OptionTable,
            type Tk_Window)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_InitOptions');

 dcl Tk_InternAtom
     entry (type Tk_Window,
            char (*) varz byaddr)
     returns (type XAtom byvalue optional)
     TK_ENTRY_API
     external('Tk_InternAtom');

 dcl Tk_IntersectTextLayout
     entry (type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_IntersectTextLayout');

 dcl Tk_MainEx
     entry (fixed bin (31),
            (*) pointer byaddr, /* each to char (*) varz */
            type Tcl_AppInitProc,
            handle Tcl_Interp)
     TK_ENTRY_API
     external('Tk_Main');

 dcl Tk_MainLoop
     entry ()
     TK_ENTRY_API
     external('Tk_MainLoop');

 dcl Tk_MaintainGeometry
     entry (type Tk_Window,
            type Tk_Window,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_MaintainGeometry');

 dcl Tk_MainWindow
     entry (handle Tcl_Interp)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_MainWindow');

 dcl Tk_MakeWindowExist
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_MakeWindowExist');

 dcl Tk_ManageGeometry
     entry (type Tk_Window,
            type Tk_GeomMgr byaddr,
            type ClientData)
     TK_ENTRY_API
     external('Tk_ManageGeometry');

 dcl Tk_MapWindow
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_MapWindow');

 dcl Tk_MeasureChars
     entry (type Tk_Font,
            char (*) varz nonasgn byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_MeasureChars');

 dcl Tk_MoveResizeWindow
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_MoveResizeWindow');

 dcl Tk_MoveWindow
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_MoveWindow');

 dcl Tk_MoveToplevelWindow
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_MoveToplevelWindow');

 dcl Tk_NameOf3DBorder
     entry (type Tk_3DBorder)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOf3DBorder');

 dcl Tk_NameOfAnchor
     entry (type Tk_Anchor)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfAnchor');

 dcl Tk_NameOfBitmap
     entry (handle Display,
            type Pixmap)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfBitmap');

 dcl Tk_NameOfCapStyle
     entry (fixed bin (31))
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfCapStyle');

 dcl Tk_NameOfColor
     entry (type Xcolor byaddr)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfColor');

 dcl Tk_NameOfCursor
     entry (handle Display,
            type Tk_Cursor)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfCursor');

 dcl Tk_NameOfFont
     entry (type Tk_Font)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfFont');

 dcl Tk_NameOfImage
     entry (type Tk_ImageMaster)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfImage');

 dcl Tk_NameOfJoinStyle
     entry (fixed bin (31))
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfJoinStyle');

 dcl Tk_NameOfJustify
     entry (type Tk_Justify)
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfJustify');

 dcl Tk_NameOfRelief
     entry (fixed bin (31))
     returns (pointer byvalue) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_NameOfRelief');

 dcl Tk_NameToWindow
     entry (handle Tcl_Interp,
            char (*) varz byaddr,
            type Tk_Window)
     returns (type Tk_Window byvalue optional)
     TK_ENTRY_API
     external('Tk_NameToWindow');

 dcl Tk_OwnSelection
     entry (type Tk_Window,
            type XAtom,
            type Tk_LostSelProc,
            type ClientData)
     TK_ENTRY_API
     external('Tk_OwnSelection');

 dcl Tk_ParseArgv
     entry (handle Tcl_Interp,
            type Tk_Window,
            fixed bin (31) byaddr,
            (*) pointer byaddr, /* each to char (*) varz */
            (*) type Tk_ArgvInfo byaddr,
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ParseArgv');

 dcl Tk_PhotoPutBlock
     entry (type Tk_PhotoHandle,
            type Tk_PhotoImageBlock byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_PhotoPutBlock');

 dcl Tk_PhotoPutZoomedBlock
     entry (type Tk_PhotoHandle,
            type Tk_PhotoImageBlock byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_PhotoPutZoomedBlock');

 dcl Tk_PhotoGetImage
     entry (type Tk_PhotoHandle,
            type Tk_PhotoImageBlock byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PhotoGetImage');

 dcl Tk_PhotoBlank
     entry (type Tk_PhotoHandle)
     TK_ENTRY_API
     external('Tk_PhotoBlank');

 dcl Tk_PhotoExpand
     entry (type Tk_PhotoHandle,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_PhotoExpand');

 dcl Tk_PhotoGetSize
     entry (type Tk_PhotoHandle,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     TK_ENTRY_API
     external('Tk_PhotoGetSize');

 dcl Tk_PhotoSetSize
     entry (type Tk_PhotoHandle,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_PhotoSetSize');

 dcl Tk_PointToChar
     entry (type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PointToChar');

 dcl Tk_PostscriptBitmap
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_PostscriptInfo,
            type Pixmap,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptBitmap');

 dcl Tk_PostscriptColor
     entry (handle Tcl_Interp,
				  type Tk_PostscriptInfo,
            type XColor byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptColor');

 dcl Tk_PreserveColormap
     entry (handle Display,
            type XColormap)
     TK_ENTRY_API
     external('Tk_PreserveColormap');

 dcl Tk_PostscriptFont
     entry (handle Tcl_Interp,
            type Tk_PostscriptInfo,
            type Tk_Font)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptFont');

 dcl Tk_PostscriptFontName
     entry (type Tk_Font,
            type Tcl_Dstring byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptFontName');

 dcl Tk_PostscriptImage
     entry (type Tk_Image,
            handle Tcl_Interp,
            type Tk_Window,
            type Tk_PostscriptInfo,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptImage');

 dcl Tk_PostscriptPath
     entry (handle Tcl_Interp,
            type Tk_PostscriptInfo,
            (*) float bin (53) byaddr,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_PostscriptPath');

 dcl Tk_PostscriptPhoto
     entry (handle Tcl_Interp,
            type Tk_PhotoImageBlock byaddr,
            type Tk_PostscriptInfo,
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptImage');

 dcl Tk_PostscriptStipple
     entry (handle Tcl_Interp,
            type Tk_Window,
            type Tk_PostscriptInfo,
            type Pixmap)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptStipple');

 dcl Tk_PostscriptY
     entry (float bin (53),
            type Tk_PostscriptInfo)
     returns (float bin (53) byvalue optional)
     TK_ENTRY_API
     external('Tk_PostscriptY');

 dcl Tk_QueueWindowEvent
     entry (handle XEvent,
            type Tcl_QueuePosition)
     TK_ENTRY_API
     external('Tk_QueueWindowEvent');

 dcl Tk_RedrawImage
     entry (type Tk_Image,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            type Drawable,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_RedrawImage');

 dcl Tk_ResetOutlineGC
     entry (type Tk_Canvas,
            type Tk_Item byaddr,
            type Tk_Outline byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_ResetOutlineGC');

 dcl Tk_ResizeWindow
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_ResizeWindow');

 dcl Tk_RestackWindow
     entry (type Tk_Window,
            fixed bin (31),
            type Tk_Window)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_RestackWindow');

 dcl Tk_RestoreSavedOptions
     entry (type Tk_SavedOptions byaddr)
     TK_ENTRY_API
     external('Tk_RestoreSavedOptions');

 dcl Tk_RestrictEvents
     entry (type Tk_RestrictProc,
            type ClientData,
            type ClientData byaddr)
     returns (type Tk_RestrictProc byvalue optional)
     TK_ENTRY_API
     external('Tk_RestrictEvents');

 dcl Tk_SafeInit
     entry (handle Tcl_Interp)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_SafeInit');

 dcl Tk_SetAppName
     entry (type Tk_Window,
            char (*) varz byaddr)
     returns (pointer byvalue optional) /* to char (*) varz */
     TK_ENTRY_API
     external('Tk_SetAppName');

 dcl Tk_SetBackgroundFromBorder
     entry (type Tk_Window,
            type Tk_3DBorder)
     TK_ENTRY_API
     external('Tk_SetBackgroundFromBorder');

 dcl Tk_SetClass
     entry (type Tk_Window,
            char (*) varz byaddr)
     TK_ENTRY_API
     external('Tk_SetClass');

 dcl Tk_SetGrid
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_SetGrid');

 dcl Tk_SetInternalBorder
     entry (type Tk_Window,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_SetInternalBorder');

 dcl Tk_SetOptions
     entry (handle Tcl_Interp,
            pointer,
            type Tk_OptionTable,
            fixed bin (31),
            (*) handle Tcl_Obj byaddr nonasgn,
            type Tk_Window,
            type Tk_SavedOptions byaddr,
            fixed bin (31) byaddr)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_SetOptions');

 dcl Tk_SetTSOrigin
     entry (type Tk_Window,
            type GC,
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_SetTSOrigin');

 dcl Tk_SetWindowBackground
     entry (type Tk_Window,
            fixed bin (32) unsigned)
     TK_ENTRY_API
     external('Tk_SetWindowBackground');

 dcl Tk_SetWindowBackgroundPixmap
     entry (type Tk_Window,
            type Pixmap)
     TK_ENTRY_API
     external('Tk_SetWindowBackgroundPixmap');

 dcl Tk_SetWindowBorder
     entry (type Tk_Window,
            fixed bin (32) unsigned)
     TK_ENTRY_API
     external('Tk_SetWindowBorder');

 dcl Tk_SetWindowBorderWidth
     entry (type Tk_Window,
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_SetWindowBorderWidth');

 dcl Tk_SetWindowBorderPixmap
     entry (type Tk_Window,
            type Pixmap)
     TK_ENTRY_API
     external('Tk_SetWindowBorderPixmap');

 dcl Tk_SetWindowColormap
     entry (type Tk_Window,
            type XColormap)
     TK_ENTRY_API
     external('Tk_SetWindowColormap');

 dcl Tk_SetWindowVisual
     entry (type Tk_Window,
            handle Visual,
            fixed bin (31),
            type XColormap)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_SetWindowVisual');

 dcl Tk_SizeOfBitmap
     entry (handle Display,
            type Pixmap,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     TK_ENTRY_API
     external('Tk_SizeOfBitmap');

 dcl Tk_SizeOfImage
     entry (type Tk_Image,
            fixed bin (31) byaddr,
            fixed bin (31) byaddr)
     TK_ENTRY_API
     external('Tk_SizeOfImage');

 dcl Tk_StrictMotif
     entry (type Tk_Window)
     returns (fixed bin (31) byvalue optional)
     TK_ENTRY_API
     external('Tk_StrictMotif');

 dcl Tk_TextLayoutToPostscript
     entry (handle Tcl_Interp,
            type Tk_TextLayout)
     TK_ENTRY_API
     external('Tk_TextLayoutToPostscript');

 dcl Tk_TextWidth
     entry (type Tk_Font,
            char (*) varz nonasgn byaddr,
            fixed bin (31))
     returns (fixed bin (31) byvalue)
     TK_ENTRY_API
     external('Tk_TextWidth');

 dcl Tk_UndefineCursor
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_UndefineCursor');

 dcl Tk_UnderlineChars
     entry (handle Display,
            type Drawable,
            type GC,
            type Tk_Font,
            char (*) varz byaddr,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_UnderlineChars');

 dcl Tk_UnderlineTextLayout
     entry (handle Display,
            type Drawable,
            type GC,
            type Tk_TextLayout,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_UnderlineTextLayout');

 dcl Tk_Ungrab
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_Ungrab');

 dcl Tk_UnmaintainGeometry
     entry (type Tk_Window,
            type Tk_Window)
     TK_ENTRY_API
     external('Tk_UnmaintainGeometry');

 dcl Tk_UnmapWindow
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_UnmapWindow');

 dcl Tk_UnsetGrid
     entry (type Tk_Window)
     TK_ENTRY_API
     external('Tk_UnsetGrid');

 dcl Tk_UpdatePointer
     entry (type Tk_Window,
            fixed bin (31),
            fixed bin (31),
            fixed bin (31))
     TK_ENTRY_API
     external('Tk_UpdatePointer');

 %end; %else %do;  /* USE_TK_STUBS ^= '' & USE_TK_STUB_PROCS = '' */

 %dcl TK_STUB_API     char;
 %TK_STUB_API      = TK_ENTRY_API || ' limited';

 define structure
   1 TkStubHooks,
     2 tkPlatStubs     pointer,
     2 tkIntStubs      pointer,
     2 tkIntPlatStubs  pointer,
     2 tkIntXlibStubs  pointer;

 dcl
   1 TkStubs           based (tkStubsPtr),
     2 magic           fixed bin (31),
     2 hooks           handle TkStubHooks,
     2 (
 /*   0 */ tk_MainLoop        entry ()
                              TK_STUB_API,
 /*   1 */ tk_3DBorderColor   entry (type Tk_3DBorder)
                              returns (handle XColor byvalue)
                              TK_STUB_API,
 /*   2 */ tk_3DBorderGC      entry (type Tk_Window,
                                     type Tk_3DBorder,
                                     fixed bin (31))
                              returns (type GC optional byvalue)
                              TK_STUB_API,
 /*   3 */ tk_3DHorizontalBevel entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*   4 */ tk_3DVerticalBevel entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*   5 */ tk_AddOption       entry (type Tk_Window,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr,
                                     fixed bin (31))
                              TK_STUB_API,
 /*   6 */ tk_BindEvent       entry (type Tk_BindingTable,
                                     handle XEvent,
                                     type Tk_Window,
                                     fixed bin (31),
                                     type ClientData byaddr)
                              TK_STUB_API,
 /*   7 */ tk_CanvasDrawableCoords entry (type Tk_Canvas,
                                     float bin (53),
                                     float bin (53),
                                     fixed bin (16) unsigned byaddr,
                                     fixed bin (16) unsigned byaddr)
                              TK_STUB_API,
 /*   8 */ tk_CanvasEventuallyRedraw entry (type Tk_Canvas,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*   9 */ tk_CanvasGetCoord  entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     char (*) varz byaddr,
                                     float bin (53) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  10 */ tk_CanvasGetTextInfo entry (type Tk_Canvas)
                              returns (handle Tk_CanvasTextInfo byvalue)
                              TK_STUB_API,
 /*  11 */ tk_CanvasPsBitmap  entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     type Pixmap,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  12 */ tk_CanvasPsColor   entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     type Xcolor byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  13 */ tk_CanvasPsFont    entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     type Tk_Font)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  14 */ tk_CanvasPsPath    entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     float bin (53) byaddr,
                                     fixed bin (31))
                              TK_STUB_API,
 /*  15 */ tk_CanvasPsStipple entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     type Pixmap)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  16 */ tk_CanvasPsY       entry (type Tk_Canvas,
                                     float bin (53))
                              returns (float bin (53) byvalue optional)
                              TK_STUB_API,
 /*  17 */ tk_CanvasSetStippleOrigin entry (type Tk_Canvas,
                                     type GC)
                              TK_STUB_API,
 /*  18 */ tk_CanvasTagsParseProc entry (type ClientData,
                                     HANDLE TCL_INTERP,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     pointer, /* to a widget record */
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  19 */ tk_CanvasTagsPrintProc entry (type ClientData,
                                     type Tk_Window,
                                     pointer, /* to a widget record */
                                     fixed bin (31),
                                     type Tcl_FreeProc byaddr)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /*  20 */ tk_CanvasTkwin     entry (type Tk_Canvas)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /*  21 */ tk_CanvasWindowCoords entry (type Tk_Canvas,
                                     float bin (53),
                                     float bin (53),
                                     fixed bin (16) unsigned byaddr,
                                     fixed bin (16) unsigned byaddr)
                              TK_STUB_API,
 /*  22 */ tk_ChangeWindowAttributes entry (type Tk_Window,
                                     fixed bin (32) unsigned,
                                     type XSetWindowAttributes byaddr)
                              TK_STUB_API,
 /*  23 */ tk_CharBbox        entry (type Tk_TextLayout,
                                     fixed bin (31),
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  24 */ tk_ClearSelection  entry (type Tk_Window,
                                     type XAtom)
                              TK_STUB_API,
 /*  25 */ tk_ClipboardAppend entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type XAtom,
                                     type XAtom,
                                     char (*) varz byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  26 */ tk_ClipboardClear  entry (handle Tcl_Interp,
                                     type Tk_Window)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  27 */ tk_ConfigureInfo   entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_ConfigSpec byaddr,
                                     pointer, /* to a widget record */
                                     char (*) varz byaddr optional,
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  28 */ tk_ConfigureValue  entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_ConfigSpec byaddr,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr,
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  29 */ tk_ConfigureWidget entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_ConfigSpec byaddr,
                                     fixed bin (31),
                                     (*) pointer byaddr,
                                     pointer, /* to a widget record */
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  30 */ tk_ConfigureWindow entry (type Tk_Window,
                                     fixed bin (32) unsigned,
                                     type XWindowChanges byaddr)
                              TK_STUB_API,
 /*  31 */ tk_ComputeTextLayout entry (type Tk_Font,
                                     char (*) varz nonasgn byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     type Tk_Justify,
                                     fixed bin (31),
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                           returns (type Tk_TextLayout byvalue optional)
                              TK_STUB_API,
 /*  32 */ tk_CoordsToWindow  entry (fixed bin (31),
                                     fixed bin (31),
                                     type Tk_Window)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /*  33 */ tk_CreateBinding   entry (handle Tcl_Interp,
                                     type Tk_BindingTable,
                                     type ClientData,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr,
                                     fixed bin (31))
                      returns (fixed bin (32) unsigned byvalue optional)
                              TK_STUB_API,
 /*  34 */ tk_CreateBindingTable entry (handle Tcl_Interp)
                         returns (type Tk_BindingTable byvalue optional)
                              TK_STUB_API,
 /*  35 */ tk_CreateErrorHandler entry (handle Display,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     type Tk_ErrorProc,
                                     type ClientData)
                         returns (type Tk_ErrorHandler byvalue optional)
                              TK_STUB_API,
 /*  36 */ tk_CreateEventHandler entry (type Tk_Window,
                                     fixed bin (32) unsigned,
                                     type Tk_EventProc,
                                     type ClientData)
                              TK_STUB_API,
 /*  37 */ tk_CreateGenericHandler entry (type Tk_GenericProc,
                                     type ClientData)
                              TK_STUB_API,
 /*  38 */ tk_CreateImageType entry (type Tk_ImageType byaddr)
                              TK_STUB_API,
 /*  39 */ tk_CreateItemType  entry (type Tk_ItemType byaddr)
                              TK_STUB_API,
 /*  40 */ tk_CreatePhotoImageFormat
                              entry (type Tk_PhotoImageFormat byaddr)
                              TK_STUB_API,
 /*  41 */ tk_CreateSelHandler entry (type Tk_Window,
                                     type XAtom,
                                     type XAtom,
                                     type Tk_SelectionProc,
                                     type ClientData,
                                     type XAtom)
                              TK_STUB_API,
 /*  42 */ tk_CreateWindow    entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /*  43 */ tk_CreateWindowFromPath entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /*  44 */ tk_DefineBitmap    entry (handle Tcl_Interp,
                                     type Tk_Uid,
                                     pointer,
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  45 */ tk_DefineCursor    entry (type Tk_Window,
                                     type Tk_Cursor)
                              TK_STUB_API,
 /*  46 */ tk_DeleteAllBindings entry (type Tk_BindingTable,
                                     type ClientData)
                              TK_STUB_API,
 /*  47 */ tk_DeleteBinding   entry (handle Tcl_Interp,
                                     type Tk_BindingTable,
                                     type ClientData,
                                     char (*) varz byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  48 */ tk_DeleteBindingTable entry (type Tk_BindingTable)
                              TK_STUB_API,
 /*  49 */ tk_DeleteErrorHandler entry (type Tk_ErrorHandler)
                              TK_STUB_API,
 /*  50 */ tk_DeleteEventHandler entry (type Tk_Window,
                                     fixed bin (32) unsigned,
                                     type Tk_EventProc,
                                     type ClientData)
                              TK_STUB_API,
 /*  51 */ tk_DeleteGenericHandler entry (type Tk_GenericProc,
                                     type ClientData)
                              TK_STUB_API,
 /*  52 */ tk_DeleteImage     entry (handle Tcl_Interp,
                                     char (*) varz byaddr)
                              TK_STUB_API,
 /*  53 */ tk_DeleteSelHandler entry (type Tk_Window,
                                     type XAtom,
                                     type XAtom)
                              TK_STUB_API,
 /*  54 */ tk_DestroyWindow   entry (type Tk_Window)
                              TK_STUB_API,
 /*  55 */ tk_DisplayName     entry (type Tk_Window)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /*  56 */ tk_DistanceToTextLayout entry (type Tk_TextLayout,
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  57 */ tk_Draw3DPolygon   entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     type XPoint byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  58 */ tk_Draw3DRectangle entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  59 */ tk_DrawChars       entry (handle Display,
                                     type Drawable,
                                     type GC,
                                     type Tk_Font,
                                     char (*) varz nonasgn byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  60 */ tk_DrawFocusHighlight entry (type Tk_Window,
                                     type GC,
                                     fixed bin (31),
                                     type Drawable)
                              TK_STUB_API,
 /*  61 */ tk_DrawTextLayout  entry (handle Display,
                                     type Drawable,
                                     type GC,
                                     type Tk_TextLayout,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  62 */ tk_Fill3DPolygon   entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     type XPoint byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  63 */ tk_Fill3DRectangle entry (type Tk_Window,
                                     type Drawable,
                                     type Tk_3DBorder,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  64 */ tk_FindPhoto       entry (handle Tcl_Interp,
                                    char (*) varz byaddr)
                          returns (type Tk_PhotoHandle byvalue optional)
                              TK_STUB_API,
 /*  65 */ tk_FontId          entry (type Tk_Font)
                              returns (type Font byvalue optional)
                              TK_STUB_API,
 /*  66 */ tk_Free3DBorder    entry (type Tk_3DBorder)
                              TK_STUB_API,
 /*  67 */ tk_FreeBitmap      entry (handle Display,
                                     type Pixmap)
                              TK_STUB_API,
 /*  68 */ tk_FreeColor       entry (type Xcolor byaddr)
                              TK_STUB_API,
 /*  69 */ tk_FreeColormap    entry (handle Display,
                                     type XColormap)
                              TK_STUB_API,
 /*  70 */ tk_FreeCursor      entry (handle Display,
                                     type Tk_Cursor)
                              TK_STUB_API,
 /*  71 */ tk_FreeFont        entry (type Tk_Font)
                              TK_STUB_API,
 /*  72 */ tk_FreeGC          entry (handle Display,
                                     type GC)
                              TK_STUB_API,
 /*  73 */ tk_FreeImage       entry (type Tk_Image)
                              TK_STUB_API,
 /*  74 */ tk_FreeOptions     entry (type Tk_ConfigSpec byaddr,
                                     pointer, /* to a widget record */
                                     handle Display,
                                     fixed bin (31))
                              TK_STUB_API,
 /*  75 */ tk_FreePixmap      entry (handle Display,
                                     type Pixmap)
                              TK_STUB_API,
 /*  76 */ tk_FreeTextLayout  entry (type Tk_TextLayout)
                              TK_STUB_API,
 /*  77 */ tk_FreeXId         entry (handle Display,
                                     type XID)
                              TK_STUB_API,
 /*  78 */ tk_GCForColor      entry (type Xcolor byaddr,
                                     type Drawable)
                              returns (type GC byvalue optional)
                              TK_STUB_API,
 /*  79 */ tk_GeometryRequest entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /*  80 */ tk_Get3DBorder     entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_Uid)
                             returns (type Tk_3DBorder byvalue optional)
                              TK_STUB_API,
 /*  81 */ tk_GetAllBindings  entry (handle Tcl_Interp,
                                     type Tk_BindingTable,
                                     type ClientData)
                              TK_STUB_API,
 /*  82 */ tk_GetAnchor       entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     type Tk_Anchor byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  83 */ tk_GetAtomName     entry (type Tk_Window,
                                     type XAtom)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /*  84 */ tk_GetBinding      entry (handle Tcl_Interp,
                                     type Tk_BindingTable,
                                     type ClientData,
                                     char (*) varz byaddr)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /*  85 */ tk_GetBitmap       entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_Uid)
                              returns (type Pixmap byvalue optional)
                              TK_STUB_API,
 /*  86 */ tk_GetBitmapFromData entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     pointer, /* to bitmap data */
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (type Pixmap byvalue optional)
                              TK_STUB_API,
 /*  87 */ tk_GetCapStyle     entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /*  88 */ tk_GetColor        entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_Uid)
                              returns (handle XColor byvalue)
                              TK_STUB_API,
 /*  89 */ tk_GetColorByValue entry (type Tk_Window,
                                     type Xcolor byaddr)
                              returns (handle XColor byvalue)
                              TK_STUB_API,
 /*  90 */ tk_GetColormap     entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr)
                              returns (type XColormap byvalue optional)
                              TK_STUB_API,
 /*  91 */ tk_GetCursor       entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_Uid)
                              returns (type Tk_Cursor byvalue optional)
                              TK_STUB_API,
 /*  92 */ tk_GetCursorFromData entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     pointer, /* to bitmap data */
                                     pointer, /* to mask data */
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     type Tk_Uid,
                                     type Tk_Uid)
                              returns (type Tk_Cursor byvalue optional)
                              TK_STUB_API,
 /*  93 */ tk_GetFont         entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz nonasgn byaddr)
                              returns (type Tk_Font byvalue optional)
                              TK_STUB_API,
 /*  94 */ tk_GetFontFromObj  entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                              returns (type Tk_Font byvalue optional)
                              TK_STUB_API,
 /*  95 */ tk_GetFontMetrics  entry (type Tk_Font,
                                     type Tk_FontMetrics byaddr)
                              TK_STUB_API,
 /*  96 */ tk_GetGC           entry (type Tk_Window,
                                     fixed bin (32) unsigned,
                                     type XGCValues byaddr)
                              returns (type GC byvalue optional)
                              TK_STUB_API,
 /*  97 */ tk_GetImage        entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     type Tk_ImageChangedProc,
                                     type ClientData)
                              returns (type Tk_Image byvalue optional)
                              TK_STUB_API,
 /*  98 */ tk_GetImageMasterData entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     handle Tk_ImageType byaddr)
                              returns (type ClientData byvalue optional)
                              TK_STUB_API,
 /*  99 */ tk_GetItemTypes    entry ()
                              returns (handle Tk_ItemType byvalue)
                              TK_STUB_API,
 /* 100 */ tk_GetJoinStyle    entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 101 */ tk_GetJustify      entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     type Tk_Justify byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 102 */ tk_GetNumMainWindows entry ()
                              returns (fixed bin (31) byvalue)
                              TK_STUB_API,
 /* 103 */ tk_GetOption       entry (type Tk_Window,
                                     char (*) varz byaddr,
                                     char (*) varz byaddr optional)
                              returns (type Tk_Uid byvalue optional)
                              TK_STUB_API,
 /* 104 */ tk_GetPixels       entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue)
                              TK_STUB_API,
 /* 105 */ tk_GetPixmap       entry (handle Display,
                                     type Drawable,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (type Pixmap byvalue optional)
                              TK_STUB_API,
 /* 106 */ tk_GetRelief       entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 107 */ tk_GetRootCoords   entry (type Tk_Window,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              TK_STUB_API,
 /* 108 */ tk_GetScrollInfo   entry (handle Tcl_Interp,
                                     fixed bin (31),
                                     (*) pointer byaddr,
                                     float bin (53) byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 109 */ tk_GetScreenMM     entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     float bin (53) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 110 */ tk_GetSelection    entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type XAtom,
                                     type XAtom,
                                     type Tk_GetSelProc,
                                     type ClientData)
                              returns (fixed bin (31) byvalue)
                              TK_STUB_API,
 /* 111 */ tk_GetUid          entry (char (*) varz nonasgn byaddr)
                              returns (type Tk_Uid byvalue optional)
                              TK_STUB_API,
 /* 112 */ tk_GetVisual       entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     char (*) varz byaddr,
                                     fixed bin (31) byaddr,
                                     type XColormap byaddr optional)
                              returns (handle Visual byvalue)
                              TK_STUB_API,
 /* 113 */ tk_GetVRootGeometry entry (type Tk_Window,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              TK_STUB_API,
 /* 114 */ tk_Grab            entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 115 */ tk_HandleEvent     entry (handle XEvent)
                              TK_STUB_API,
 /* 116 */ tk_IdToWindow      entry (handle Display,
                                     type Window)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /* 117 */ tk_ImageChanged    entry (type Tk_ImageMaster,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 118 */ tk_Init            entry (handle Tcl_Interp)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 119 */ tk_InternAtom      entry (type Tk_Window,
                                     char (*) varz byaddr)
                              returns (type XAtom byvalue optional)
                              TK_STUB_API,
 /* 120 */ tk_IntersectTextLayout entry (type Tk_TextLayout,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 121 */ tk_MaintainGeometry entry (type Tk_Window,
                                     type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 122 */ tk_MainWindow      entry (handle Tcl_Interp)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /* 123 */ tk_MakeWindowExist entry (type Tk_Window)
                              TK_STUB_API,
 /* 124 */ tk_ManageGeometry  entry (type Tk_Window,
                                     type Tk_GeomMgr byaddr,
                                     type ClientData)
                              TK_STUB_API,
 /* 125 */ tk_MapWindow       entry (type Tk_Window)
                              TK_STUB_API,
 /* 126 */ tk_MeasureChars    entry (type Tk_Font,
                                     char (*) varz nonasgn byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 127 */ tk_MoveResizeWindow entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 128 */ tk_MoveWindow      entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 129 */ tk_MoveToplevelWindow entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 130 */ tk_NameOf3DBorder  entry (type Tk_3DBorder)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 131 */ tk_NameOfAnchor    entry (type Tk_Anchor)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 132 */ tk_NameOfBitmap    entry (handle Display,
                                     type Pixmap)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 133 */ tk_NameOfCapStyle  entry (fixed bin (31))
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 134 */ tk_NameOfColor     entry (type Xcolor byaddr)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 135 */ tk_NameOfCursor    entry (handle Display,
                                     type Tk_Cursor)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 136 */ tk_NameOfFont      entry (type Tk_Font)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 137 */ tk_NameOfImage     entry (type Tk_ImageMaster)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 138 */ tk_NameOfJoinStyle entry (fixed bin (31))
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 139 */ tk_NameOfJustify   entry (type Tk_Justify)
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 140 */ tk_NameOfRelief    entry (fixed bin (31))
                              returns (pointer byvalue)
                              TK_STUB_API,
 /* 141 */ tk_NameToWindow    entry (handle Tcl_Interp,
                                     char (*) varz byaddr,
                                     type Tk_Window)
                              returns (type Tk_Window byvalue optional)
                              TK_STUB_API,
 /* 142 */ tk_OwnSelection    entry (type Tk_Window,
                                     type XAtom,
                                     type Tk_LostSelProc,
                                     type ClientData)
                              TK_STUB_API,
 /* 143 */ tk_ParseArgv       entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     fixed bin (31) byaddr,
                                     (*) pointer byaddr,
                                     (*) type Tk_ArgvInfo byaddr,
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 144 */ tk_PhotoPutBlock   entry (type Tk_PhotoHandle,
                                     type Tk_PhotoImageBlock byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 145 */ tk_PhotoPutZoomedBlock entry (type Tk_PhotoHandle,
                                     type Tk_PhotoImageBlock byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 146 */ tk_PhotoGetImage   entry (type Tk_PhotoHandle,
                                     type Tk_PhotoImageBlock byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 147 */ tk_PhotoBlank      entry (type Tk_PhotoHandle)
                              TK_STUB_API,
 /* 148 */ tk_PhotoExpand     entry (type Tk_PhotoHandle,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 149 */ tk_PhotoGetSize    entry (type Tk_PhotoHandle,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              TK_STUB_API,
 /* 150 */ tk_PhotoSetSize    entry (type Tk_PhotoHandle,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 151 */ tk_PointToChar     entry (type Tk_TextLayout,
                                      fixed bin (31),
                                      fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 152 */ tk_PostscriptFontName entry (type Tk_Font,
                                      type Tcl_Dstring byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 153 */ tk_PreserveColormap entry (handle Display,
                                     type XColormap)
                              TK_STUB_API,
 /* 154 */ tk_QueueWindowEvent entry (handle XEvent,
                                     type Tcl_QueuePosition)
                              TK_STUB_API,
 /* 155 */ tk_RedrawImage     entry (type Tk_Image,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     type Drawable,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 156 */ tk_ResizeWindow    entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 157 */ tk_RestackWindow   entry (type Tk_Window,
                                     fixed bin (31),
                                     type Tk_Window)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 158 */ tk_RestrictEvents  entry (type Tk_RestrictProc,
                                     type ClientData,
                                     type ClientData byaddr)
                         returns (type Tk_RestrictProc byvalue optional)
                              TK_STUB_API,
 /* 159 */ tk_SafeInit        entry (handle Tcl_Interp)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 160 */ tk_SetAppName      entry (type Tk_Window,
                                     char (*) varz byaddr)
                              returns (pointer byvalue optional)
                              TK_STUB_API,
 /* 161 */ tk_SetBackgroundFromBorder entry (type Tk_Window,
                                     type Tk_3DBorder)
                              TK_STUB_API,
 /* 162 */ tk_SetClass        entry (type Tk_Window,
                                     char (*) varz byaddr)
                              TK_STUB_API,
 /* 163 */ tk_SetGrid         entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 164 */ tk_SetInternalBorder entry (type Tk_Window,
                                     fixed bin (31))
                              TK_STUB_API,
 /* 165 */ tk_SetWindowBackground entry (type Tk_Window,
                                     fixed bin (32) unsigned)
                              TK_STUB_API,
 /* 166 */ tk_SetWindowBackgroundPixmap entry (type Tk_Window,
                                     type Pixmap)
                              TK_STUB_API,
 /* 167 */ tk_SetWindowBorder entry (type Tk_Window,
                                     fixed bin (32) unsigned)
                              TK_STUB_API,
 /* 168 */ tk_SetWindowBorderWidth entry (type Tk_Window,
                                     fixed bin (31))
                              TK_STUB_API,
 /* 169 */ tk_SetWindowBorderPixmap entry (type Tk_Window,
                                     type Pixmap)
                              TK_STUB_API,
 /* 170 */ tk_SetWindowColormap entry (type Tk_Window,
                                     type XColormap)
                              TK_STUB_API,
 /* 171 */ tk_SetWindowVisual entry (type Tk_Window,
                                     handle Visual,
                                     fixed bin (31),
                                     type XColormap)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 172 */ tk_SizeOfBitmap    entry (handle Display,
                                     type Pixmap,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              TK_STUB_API,
 /* 173 */ tk_SizeOfImage     entry (type Tk_Image,
                                     fixed bin (31) byaddr,
                                     fixed bin (31) byaddr)
                              TK_STUB_API,
 /* 174 */ tk_StrictMotif     entry (type Tk_Window)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 175 */ tk_TextLayoutToPostscript entry (handle Tcl_Interp,
                                     type Tk_TextLayout)
                              TK_STUB_API,
 /* 176 */ tk_TextWidth       entry (type Tk_Font,
                                     char (*) varz nonasgn byaddr,
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue)
                              TK_STUB_API,
 /* 177 */ tk_UndefineCursor  entry (type Tk_Window)
                              TK_STUB_API,
 /* 178 */ tk_UnderlineChars  entry (handle Display,
                                     type Drawable,
                                     type GC,
                                     type Tk_Font,
                                     char (*) varz byaddr,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 179 */ tk_UnderlineTextLayout entry (handle Display,
                                     type Drawable,
                                     type GC,
                                     type Tk_TextLayout,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 180 */ tk_Ungrab          entry (type Tk_Window)
                              TK_STUB_API,
 /* 181 */ tk_UnmaintainGeometry entry (type Tk_Window,
                                     type Tk_Window)
                              TK_STUB_API,
 /* 182 */ tk_UnmapWindow     entry (type Tk_Window)
                              TK_STUB_API,
 /* 183 */ tk_UnsetGrid       entry (type Tk_Window)
                              TK_STUB_API,
 /* 184 */ tk_UpdatePointer   entry (type Tk_Window,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 185 */ tk_AllocBitmapFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                              returns (type Pixmap byvalue optional)
                              TK_STUB_API,
 /* 186 */ tk_Alloc3DBorderFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                             returns (type Tk_3DBorder byvalue optional)
                              TK_STUB_API,
 /* 187 */ tk_AllocColorFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                              returns (handle XColor byvalue optional)
                              TK_STUB_API,
 /* 188 */ tk_AllocCursorFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                             returns (type Tk_3DBorder byvalue optional)
                              TK_STUB_API,
 /* 189 */ tk_AllocFontFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj)
                              returns (type Tk_Font byvalue optional)
                              TK_STUB_API,
 /* 190 */ tk_CreateOptionTable entry (handle Tcl_Interp,
                                     type Tk_OptionSpec byaddr nonasgn)
                          returns (type Tk_OptionTable byvalue optional)
                              TK_STUB_API,
 /* 191 */ tk_DeleteOptionTable entry (type Tk_OptionTable)
                              TK_STUB_API,
 /* 192 */ tk_Free3DBorderFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              TK_STUB_API,
 /* 193 */ tk_FreeBitmapFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              TK_STUB_API,
 /* 194 */ tk_FreeColorFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              TK_STUB_API,
 /* 195 */ tk_FreeConfigOptions entry (pointer,
                                     type Tk_OptionTable,
                                     type Tk_Window)
                              TK_STUB_API,
 /* 196 */ tk_FreeSavedOptions entry (type Tk_SavedOptions byaddr)
                              TK_STUB_API,
 /* 197 */ tk_FreeCursorFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              TK_STUB_API,
 /* 198 */ tk_FreeFontFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              TK_STUB_API,
 /* 199 */ tk_Get3DBorderFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                             returns (type Tk_3DBorder byvalue optional)
                              TK_STUB_API,
 /* 200 */ tk_GetAnchorFromObj entry (type Tk_Window,
                                     handle Tcl_Obj,
                                     type TK_Anchor byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 201 */ tk_GetBitmapFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              returns (type Pixmap byvalue optional)
                              TK_STUB_API,
 /* 202 */ tk_GetColorFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              returns (handle XColor byvalue)
                              TK_STUB_API,
 /* 203 */ tk_GetCursorFromObj entry (type Tk_Window,
                                     handle Tcl_Obj)
                              returns (type Tk_Cursor byvalue optional)
                              TK_STUB_API,
 /* 204 */ tk_GetOptionInfo   entry (handle Tcl_Interp,
                                     pointer,
                                     type Tk_OptionTable,
                                     handle Tcl_Obj,
                                     type Tk_Window)
                              returns (handle Tcl_Obj byvalue optional)
                              TK_STUB_API,
 /* 205 */ tk_GetOptionValue  entry (handle Tcl_Interp,
                                     pointer,
                                     type Tk_OptionTable,
                                     handle Tcl_Obj,
                                     type Tk_Window)
                              returns (handle Tcl_Obj byvalue optional)
                              TK_STUB_API,
 /* 206 */ tk_GetJustifyFromObj entry (handle Tcl_Interp,
                                     handle Tcl_Obj,
                                     type Tk_Justify byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 207 */ tk_GetMMFromObj    entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj,
                                     float bin(53) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 208 */ tk_GetPixelsFromObj entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     handle Tcl_Obj,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue)
                              TK_STUB_API,
 /* 209 */ tk_GetReliefFromObj entry (handle Tcl_Interp,
                                     handle Tcl_Obj,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 210 */ tk_GetScrollInfoObj entry (handle Tcl_Interp,
                                     fixed bin (31),
                                     (*) handle Tcl_Obj byaddr nonasgn,
                                     float bin (53) byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 211 */ tk_InitOptions     entry (handle Tcl_Interp,
                                     pointer,
                                     type Tk_OptionTable,
                                     type Tk_Window)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 212 */ tk_MainEx          entry (fixed bin (31),
                                     (*) pointer byaddr,
                                     type Tcl_AppInitProc,
                                     handle Tcl_Interp)
                              TK_STUB_API,
 /* 213 */ tk_RestoreSavedOptions entry (type Tk_SavedOptions byaddr)
                              TK_STUB_API,
 /* 214 */ tk_SetOptions      entry (handle Tcl_Interp,
                                     pointer,
                                     type Tk_OptionTable,
                                     fixed bin (31),
                                     (*) handle Tcl_Obj byaddr nonasgn,
                                     type Tk_Window,
                                     type Tk_SavedOptions byaddr,
                                     fixed bin (31) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 215 */ tk_InitConsoleChannels entry (handle Tcl_Interp)
                              TK_STUB_API,
 /* 216 */ tk_CreateConsoleWindow entry (handle Tcl_Interp)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 217 */ tk_CreateSmoothMethod entry (handle Tcl_Interp,
                                     type Tk_SmoothMethod byaddr)
                              TK_STUB_API,
 /* 218 */ reserved218        pointer,
 /* 219 */ reserved219        pointer,
 /* 220 */ tk_GetDash         entry (handle Tcl_Interp,
                                     char (*) varz byaddr nonasgn,
                                     type Tk_Dash  byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 221 */ tk_CreateOutline   entry (type Tk_Outline byaddr)
                              TK_STUB_API,
 /* 222 */ tk_DeleteOutline   entry (handle Display,
                                     type Tk_Outline byaddr)
                              TK_STUB_API,
 /* 223 */ tk_ConfigOutlineGC entry (type XGCValues byaddr,
                                     type Tk_Canvas,
                                     type Tk_Item byaddr,
                                     type Tk_Outline byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 224 */ tk_ChangeOutlineGC entry (type Tk_Canvas,
                                     type Tk_Item byaddr,
                                     type Tk_Outline byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 225 */ tk_ResetOutlineGC  entry (type Tk_Canvas,
                                     type Tk_Item byaddr,
                                     type Tk_Outline byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 226 */ tk_CanvasPsOutline entry (type Tk_Canvas,
                                     type Tk_Item byaddr,
                                     type Tk_Outline byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 227 */ tk_SetTSOrigin     entry (type Tk_Window,
                                     type GC,
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 228 */ tk_CanvasGetCoordFromObj entry (handle Tcl_Interp,
                                     type Tk_Canvas,
                                     handle Tcl_Obj,
                                     float bin (53) byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 229 */ tk_CanvasSetOffset entry (type Tk_Canvas,
                                     type GC,
                                     type Tk_TSOffset byaddr)
                              TK_STUB_API,
 /* 230 */ tk_DitherPhoto     entry (type Tk_PhotoHandle,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              TK_STUB_API,
 /* 231 */ tk_PostscriptBitmap entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_PostscriptInfo,
                                     type Pixmap,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 232 */ tk_PostscriptColor entry (handle Tcl_Interp,
                         				  type Tk_PostscriptInfo,
                                     type XColor byaddr)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 233 */ tk_PostscriptFont  entry (handle Tcl_Interp,
                                     type Tk_PostscriptInfo,
                                     type Tk_Font)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 234 */ tk_PostscriptImage entry (type Tk_Image,
                                     handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_PostscriptInfo,
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 235 */ tk_PostscriptPath  entry (handle Tcl_Interp,
                                     type Tk_PostscriptInfo,
                                     (*) float bin (53) byaddr,
                                     fixed bin (31))
                              TK_STUB_API,
 /* 236 */ tk_PostscriptStipple entry (handle Tcl_Interp,
                                     type Tk_Window,
                                     type Tk_PostscriptInfo,
                                     type Pixmap)
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 237 */ tk_PostscriptY          entry (float bin (53),
                                      type Tk_PostscriptInfo)
                              returns (float bin (53) byvalue optional)
                              TK_STUB_API,
 /* 238 */ tk_PostscriptPhoto entry (handle Tcl_Interp,
                                     type Tk_PhotoImageBlock byaddr,
                                     type Tk_PostscriptInfo,
                                     fixed bin (31),
                                     fixed bin (31))
                              returns (fixed bin (31) byvalue optional)
                              TK_STUB_API,
 /* 239 */ tk_CreateClientMessageHandler
                              entry (type Tk_ClientMessageProc)
                              TK_STUB_API,
 /* 240 */ tk_DeleteClientMessageHandler
                              entry (type Tk_ClientMessageProc)
                              TK_STUB_API
       );
 %end; /* USE_TK_STUBS ^= '' & USE_TK_STUB_PROCS = '' */

 dcl tkStubsPtr pointer reserved(imported) external('_tkStubsPtr');

 %end; /* #TKDECLS */

