 /*********************************************************************/
 /* Copyright (c) 1990-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     WinSpool.cpy                                                  */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Header file for Print APIs                                    */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /*********************************************************************/

 %dcl #WINSPOOL_ char ext;
 %if #WINSPOOL_ = '' %then %do;
   %#WINSPOOL_ = 'Y';

 %dcl UNICODE char ext;

 %dcl #WINGDI_ char ext;
 %if #WINGDI_ = '' %then %do;
 %include WinGDI;
 %end;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include WinUser;
 %end;

 %dcl #PRSHT_H_ char ext;
 %if #PRSHT_H_ = '' %then %do;
 %include prsht;
 %end;

 define structure
   1 PRINTER_INFO_1A,
     2 Flags        type DWORD,
     2 pDescription type LPSTR,
     2 pName        type LPSTR,
     2 pComment     type LPSTR;
 define alias  PPRINTER_INFO_1A handle PRINTER_INFO_1A;
 define alias LPPRINTER_INFO_1A handle PRINTER_INFO_1A;

 define structure
   1 PRINTER_INFO_1W,
     2 Flags        type DWORD,
     2 pDescription type LPWSTR,
     2 pName        type LPWSTR,
     2 pComment     type LPWSTR;
 define alias  PPRINTER_INFO_1W handle PRINTER_INFO_1W;
 define alias LPPRINTER_INFO_1W handle PRINTER_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_1 type   PRINTER_INFO_1W;
 define alias  PPRINTER_INFO_1 type  PPRINTER_INFO_1W;
 define alias LPPRINTER_INFO_1 type LPPRINTER_INFO_1W;
 %end; %else %do;
 define alias   PRINTER_INFO_1 type   PRINTER_INFO_1A;
 define alias  PPRINTER_INFO_1 type  PPRINTER_INFO_1A;
 define alias LPPRINTER_INFO_1 type LPPRINTER_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_INFO_2A,
     2 pServerName         type LPSTR,
     2 pPrinterName        type LPSTR,
     2 pShareName          type LPSTR,
     2 pPortName           type LPSTR,
     2 pDriverName         type LPSTR,
     2 pComment            type LPSTR,
     2 pLocation           type LPSTR,
     2 pDevMode            type LPDEVMODEA,
     2 pSepFile            type LPSTR,
     2 pPrintProcessor     type LPSTR,
     2 pDatatype           type LPSTR,
     2 pParameters         type LPSTR,
     2 pSecurityDescriptor type PSECURITY_DESCRIPTOR,
     2 Attributes          type DWORD,
     2 Priority            type DWORD,
     2 DefaultPriority     type DWORD,
     2 StartTime           type DWORD,
     2 UntilTime           type DWORD,
     2 Status              type DWORD,
     2 cJobs               type DWORD,
     2 AveragePPM          type DWORD;
 define alias  PPRINTER_INFO_2A handle PRINTER_INFO_2A;
 define alias LPPRINTER_INFO_2A handle PRINTER_INFO_2A;

 define structure
   1 PRINTER_INFO_2W,
     2 pServerName         type LPWSTR,
     2 pPrinterName        type LPWSTR,
     2 pShareName          type LPWSTR,
     2 pPortName           type LPWSTR,
     2 pDriverName         type LPWSTR,
     2 pComment            type LPWSTR,
     2 pLocation           type LPWSTR,
     2 pDevMode            type LPDEVMODEW,
     2 pSepFile            type LPWSTR,
     2 pPrintProcessor     type LPWSTR,
     2 pDatatype           type LPWSTR,
     2 pParameters         type LPWSTR,
     2 pSecurityDescriptor type PSECURITY_DESCRIPTOR,
     2 Attributes          type DWORD,
     2 Priority            type DWORD,
     2 DefaultPriority     type DWORD,
     2 StartTime           type DWORD,
     2 UntilTime           type DWORD,
     2 Status              type DWORD,
     2 cJobs               type DWORD,
     2 AveragePPM          type DWORD;
 define alias  PPRINTER_INFO_2W handle PRINTER_INFO_2W;
 define alias LPPRINTER_INFO_2W handle PRINTER_INFO_2W;

 %if UNICODE ^= '' %then  %do;
 define alias   PRINTER_INFO_2 type   PRINTER_INFO_2W;
 define alias  PPRINTER_INFO_2 type  PPRINTER_INFO_2W;
 define alias LPPRINTER_INFO_2 type LPPRINTER_INFO_2W;
 %end; %else %do;
 define alias   PRINTER_INFO_2 type   PRINTER_INFO_2A;
 define alias  PPRINTER_INFO_2 type  PPRINTER_INFO_2A;
 define alias LPPRINTER_INFO_2 type LPPRINTER_INFO_2A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_INFO_3,
     2 pSecurityDescriptor type PSECURITY_DESCRIPTOR;
 define alias  PPRINTER_INFO_3 handle PRINTER_INFO_3;
 define alias LPPRINTER_INFO_3 handle PRINTER_INFO_3;

 define structure
   1 PRINTER_INFO_4A,
     2 pPrinterName type LPSTR,
     2 pServerName  type LPSTR,
     2 Attributes   type DWORD;
 define alias  PPRINTER_INFO_4A handle PRINTER_INFO_4A;
 define alias LPPRINTER_INFO_4A handle PRINTER_INFO_4A;

 define structure
   1 PRINTER_INFO_4W,
     2 pPrinterName type LPWSTR,
     2 pServerName  type LPWSTR,
     2 Attributes   type DWORD;
 define alias  PPRINTER_INFO_4W handle PRINTER_INFO_4W;
 define alias LPPRINTER_INFO_4W handle PRINTER_INFO_4W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_4 type   PRINTER_INFO_4W;
 define alias  PPRINTER_INFO_4 type  PPRINTER_INFO_4W;
 define alias LPPRINTER_INFO_4 type LPPRINTER_INFO_4W;
 %end; %else %do;
 define alias   PRINTER_INFO_4 type   PRINTER_INFO_4A;
 define alias  PPRINTER_INFO_4 type  PPRINTER_INFO_4A;
 define alias LPPRINTER_INFO_4 type LPPRINTER_INFO_4A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_INFO_5A,
     2 pPrinterName             type LPSTR,
     2 pPortName                type LPSTR,
     2 Attributes               type DWORD,
     2 DeviceNotSelectedTimeout type DWORD,
     2 TransmissionRetryTimeout type DWORD;
 define alias  PPRINTER_INFO_5A handle PRINTER_INFO_5A;
 define alias LPPRINTER_INFO_5A handle PRINTER_INFO_5A;

 define structure
   1 PRINTER_INFO_5W,
     2 pPrinterName             type LPWSTR,
     2 pPortName                type LPWSTR,
     2 Attributes               type DWORD,
     2 DeviceNotSelectedTimeout type DWORD,
     2 TransmissionRetryTimeout type DWORD;
 define alias  PPRINTER_INFO_5W handle PRINTER_INFO_5W;
 define alias LPPRINTER_INFO_5W handle PRINTER_INFO_5W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_5 type   PRINTER_INFO_5W;
 define alias  PPRINTER_INFO_5 type  PPRINTER_INFO_5W;
 define alias LPPRINTER_INFO_5 type LPPRINTER_INFO_5W;
 %end; %else %do;
 define alias   PRINTER_INFO_5 type   PRINTER_INFO_5A;
 define alias  PPRINTER_INFO_5 type  PPRINTER_INFO_5A;
 define alias LPPRINTER_INFO_5 type LPPRINTER_INFO_5A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_INFO_6,
     2 dwStatus type DWORD;
 define alias  PPRINTER_INFO_6 handle PRINTER_INFO_6;
 define alias LPPRINTER_INFO_6 handle PRINTER_INFO_6;


 define structure
   1 PRINTER_INFO_7A,
     2 pszObjectGUID type LPSTR,
     2 dwAction      type DWORD;
 define alias  PPRINTER_INFO_7A handle PRINTER_INFO_7A;
 define alias LPPRINTER_INFO_7A handle PRINTER_INFO_7A;

 define structure
   1 PRINTER_INFO_7W,
     2 pszObjectGUID type LPWSTR,
     2 dwAction      type DWORD;
 define alias  PPRINTER_INFO_7W handle PRINTER_INFO_7W;
 define alias LPPRINTER_INFO_7W handle PRINTER_INFO_7W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_7 type   PRINTER_INFO_7W;
 define alias  PPRINTER_INFO_7 type  PPRINTER_INFO_7W;
 define alias LPPRINTER_INFO_7 type LPPRINTER_INFO_7W;
 %end; %else %do;
 define alias   PRINTER_INFO_7 type   PRINTER_INFO_7A;
 define alias  PPRINTER_INFO_7 type  PPRINTER_INFO_7A;
 define alias LPPRINTER_INFO_7 type LPPRINTER_INFO_7A;
 %end; /* UNICODE */

 dcl DSPRINT_PUBLISH   type DWORD value('00000001'xu);
 dcl DSPRINT_UPDATE    type DWORD value('00000002'xu);
 dcl DSPRINT_UNPUBLISH type DWORD value('00000004'xu);
 dcl DSPRINT_REPUBLISH type DWORD value('00000008'xu);
 dcl DSPRINT_PENDING   type DWORD value('80000000'xu);

 define structure
   1 PRINTER_INFO_8A,
     2 pDevMode type LPDEVMODEA;
 define alias  PPRINTER_INFO_8A handle PRINTER_INFO_8A;
 define alias LPPRINTER_INFO_8A handle PRINTER_INFO_8A;

 define structure
   1 PRINTER_INFO_8W,
     2 pDevMode type LPDEVMODEW;
 define alias  PPRINTER_INFO_8W handle PRINTER_INFO_8W;
 define alias LPPRINTER_INFO_8W handle PRINTER_INFO_8W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_8 type   PRINTER_INFO_8W;
 define alias  PPRINTER_INFO_8 type  PPRINTER_INFO_8W;
 define alias LPPRINTER_INFO_8 type LPPRINTER_INFO_8W;
 %end; %else %do;
 define alias   PRINTER_INFO_8 type   PRINTER_INFO_8A;
 define alias  PPRINTER_INFO_8 type  PPRINTER_INFO_8A;
 define alias LPPRINTER_INFO_8 type LPPRINTER_INFO_8A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_INFO_9A,
     2 pDevMode type LPDEVMODEA;
 define alias  PPRINTER_INFO_9A handle PRINTER_INFO_9A;
 define alias LPPRINTER_INFO_9A handle PRINTER_INFO_9A;

 define structure
   1 PRINTER_INFO_9W,
     2 pDevMode type LPDEVMODEW;
 define alias  PPRINTER_INFO_9W handle PRINTER_INFO_9W;
 define alias LPPRINTER_INFO_9W handle PRINTER_INFO_9W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_INFO_9 type   PRINTER_INFO_9W;
 define alias  PPRINTER_INFO_9 type  PPRINTER_INFO_9W;
 define alias LPPRINTER_INFO_9 type LPPRINTER_INFO_9W;
 %end; %else %do;
 define alias   PRINTER_INFO_9 type   PRINTER_INFO_9A;
 define alias  PPRINTER_INFO_9 type  PPRINTER_INFO_9A;
 define alias LPPRINTER_INFO_9 type LPPRINTER_INFO_9A;
 %end; /* UNICODE */


 dcl PRINTER_CONTROL_PAUSE               type DWORD value(1);
 dcl PRINTER_CONTROL_RESUME              type DWORD value(2);
 dcl PRINTER_CONTROL_PURGE               type DWORD value(3);
 dcl PRINTER_CONTROL_SET_STATUS          type DWORD value(4);

 dcl PRINTER_STATUS_PAUSED               type DWORD value('00000001'xu);
 dcl PRINTER_STATUS_ERROR                type DWORD value('00000002'xu);
 dcl PRINTER_STATUS_PENDING_DELETION     type DWORD value('00000004'xu);
 dcl PRINTER_STATUS_PAPER_JAM            type DWORD value('00000008'xu);
 dcl PRINTER_STATUS_PAPER_OUT            type DWORD value('00000010'xu);
 dcl PRINTER_STATUS_MANUAL_FEED          type DWORD value('00000020'xu);
 dcl PRINTER_STATUS_PAPER_PROBLEM        type DWORD value('00000040'xu);
 dcl PRINTER_STATUS_OFFLINE              type DWORD value('00000080'xu);
 dcl PRINTER_STATUS_IO_ACTIVE            type DWORD value('00000100'xu);
 dcl PRINTER_STATUS_BUSY                 type DWORD value('00000200'xu);
 dcl PRINTER_STATUS_PRINTING             type DWORD value('00000400'xu);
 dcl PRINTER_STATUS_OUTPUT_BIN_FULL      type DWORD value('00000800'xu);
 dcl PRINTER_STATUS_NOT_AVAILABLE        type DWORD value('00001000'xu);
 dcl PRINTER_STATUS_WAITING              type DWORD value('00002000'xu);
 dcl PRINTER_STATUS_PROCESSING           type DWORD value('00004000'xu);
 dcl PRINTER_STATUS_INITIALIZING         type DWORD value('00008000'xu);
 dcl PRINTER_STATUS_WARMING_UP           type DWORD value('00010000'xu);
 dcl PRINTER_STATUS_TONER_LOW            type DWORD value('00020000'xu);
 dcl PRINTER_STATUS_NO_TONER             type DWORD value('00040000'xu);
 dcl PRINTER_STATUS_PAGE_PUNT            type DWORD value('00080000'xu);
 dcl PRINTER_STATUS_USER_INTERVENTION    type DWORD value('00100000'xu);
 dcl PRINTER_STATUS_OUT_OF_MEMORY        type DWORD value('00200000'xu);
 dcl PRINTER_STATUS_DOOR_OPEN            type DWORD value('00400000'xu);
 dcl PRINTER_STATUS_SERVER_UNKNOWN       type DWORD value('00800000'xu);
 dcl PRINTER_STATUS_POWER_SAVE           type DWORD value('01000000'xu);


 dcl PRINTER_ATTRIBUTE_QUEUED            type DWORD value('00000001'xu);
 dcl PRINTER_ATTRIBUTE_DIRECT            type DWORD value('00000002'xu);
 dcl PRINTER_ATTRIBUTE_DEFAULT           type DWORD value('00000004'xu);
 dcl PRINTER_ATTRIBUTE_SHARED            type DWORD value('00000008'xu);
 dcl PRINTER_ATTRIBUTE_NETWORK           type DWORD value('00000010'xu);
 dcl PRINTER_ATTRIBUTE_HIDDEN            type DWORD value('00000020'xu);
 dcl PRINTER_ATTRIBUTE_LOCAL             type DWORD value('00000040'xu);
 dcl PRINTER_ATTRIBUTE_ENABLE_DEVQ       type DWORD value('00000080'xu);
 dcl PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS   type DWORD value('00000100'xu);
 dcl PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST type DWORD value('00000200'xu);
 dcl PRINTER_ATTRIBUTE_WORK_OFFLINE      type DWORD value('00000400'xu);
 dcl PRINTER_ATTRIBUTE_ENABLE_BIDI       type DWORD value('00000800'xu);
 dcl PRINTER_ATTRIBUTE_RAW_ONLY          type DWORD value('00001000'xu);
 dcl PRINTER_ATTRIBUTE_PUBLISHED         type DWORD value('00002000'xu);


 dcl NO_PRIORITY                         type DWORD value(0);
 dcl MAX_PRIORITY                        type DWORD value(99);
 dcl MIN_PRIORITY                        type DWORD value(1);
 dcl DEF_PRIORITY                        type DWORD value(1);

 define structure
   1 JOB_INFO_1A,
     2 JobId        type DWORD,
     2 pPrinterName type LPSTR,
     2 pMachineName type LPSTR,
     2 pUserName    type LPSTR,
     2 pDocument    type LPSTR,
     2 pDatatype    type LPSTR,
     2 pStatus      type LPSTR,
     2 Status       type DWORD,
     2 Priority     type DWORD,
     2 Position     type DWORD,
     2 TotalPages   type DWORD,
     2 PagesPrinted type DWORD,
     2 Submitted    type SYSTEMTIME;
 define alias  PJOB_INFO_1A handle JOB_INFO_1A;
 define alias LPJOB_INFO_1A handle JOB_INFO_1A;

 define structure
   1 JOB_INFO_1W,
     2 JobId        type DWORD,
     2 pPrinterName type LPWSTR,
     2 pMachineName type LPWSTR,
     2 pUserName    type LPWSTR,
     2 pDocument    type LPWSTR,
     2 pDatatype    type LPWSTR,
     2 pStatus      type LPWSTR,
     2 Status       type DWORD,
     2 Priority     type DWORD,
     2 Position     type DWORD,
     2 TotalPages   type DWORD,
     2 PagesPrinted type DWORD,
     2 Submitted    type SYSTEMTIME;
 define alias  PJOB_INFO_1W handle JOB_INFO_1W;
 define alias LPJOB_INFO_1W handle JOB_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   JOB_INFO_1 type JOB_INFO_1W;
 define alias  PJOB_INFO_1 type PJOB_INFO_1W;
 define alias LPJOB_INFO_1 type LPJOB_INFO_1W;
 %end; %else %do;
 define alias   JOB_INFO_1 type JOB_INFO_1A;
 define alias  PJOB_INFO_1 type PJOB_INFO_1A;
 define alias LPJOB_INFO_1 type LPJOB_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 JOB_INFO_2A,
     2 JobId               type DWORD,
     2 pPrinterName        type LPSTR,
     2 pMachineName        type LPSTR,
     2 pUserName           type LPSTR,
     2 pDocument           type LPSTR,
     2 pNotifyName         type LPSTR,
     2 pDatatype           type LPSTR,
     2 pPrintProcessor     type LPSTR,
     2 pParameters         type LPSTR,
     2 pDriverName         type LPSTR,
     2 pDevMode            type LPDEVMODEA,
     2 pStatus             type LPSTR,
     2 pSecurityDescriptor type PSECURITY_DESCRIPTOR,
     2 Status              type DWORD,
     2 Priority            type DWORD,
     2 Position            type DWORD,
     2 StartTime           type DWORD,
     2 UntilTime           type DWORD,
     2 TotalPages          type DWORD,
     2 Size                type DWORD,
     2 Submitted           type SYSTEMTIME,/* Time the job was spooled*/
     2 Time                type DWORD,     /* How many seconds the job*/
                                           /* has been printing */
     2 PagesPrinted        type DWORD;
 define alias  PJOB_INFO_2A handle JOB_INFO_2A;
 define alias LPJOB_INFO_2A handle JOB_INFO_2A;

 define structure
   1 JOB_INFO_2W,
     2 JobId               type DWORD,
     2 pPrinterName        type LPWSTR,
     2 pMachineName        type LPWSTR,
     2 pUserName           type LPWSTR,
     2 pDocument           type LPWSTR,
     2 pNotifyName         type LPWSTR,
     2 pDatatype           type LPWSTR,
     2 pPrintProcessor     type LPWSTR,
     2 pParameters         type LPWSTR,
     2 pDriverName         type LPWSTR,
     2 pDevMode            type LPDEVMODEW,
     2 pStatus             type LPWSTR,
     2 pSecurityDescriptor type PSECURITY_DESCRIPTOR,
     2 Status              type DWORD,
     2 Priority            type DWORD,
     2 Position            type DWORD,
     2 StartTime           type DWORD,
     2 UntilTime           type DWORD,
     2 TotalPages          type DWORD,
     2 Size                type DWORD,
     2 Submitted           type SYSTEMTIME,/* Time the job was spooled*/
     2 Time                type DWORD,     /* How many seconds the job*/
                                           /* has been printing */
     2 PagesPrinted        type DWORD;
 define alias  PJOB_INFO_2W handle JOB_INFO_2W;
 define alias LPJOB_INFO_2W handle JOB_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   JOB_INFO_2 type   JOB_INFO_2W;
 define alias  PJOB_INFO_2 type  PJOB_INFO_2W;
 define alias LPJOB_INFO_2 type LPJOB_INFO_2W;
 %end; %else %do;
 define alias   JOB_INFO_2 type   JOB_INFO_2A;
 define alias  PJOB_INFO_2 type  PJOB_INFO_2A;
 define alias LPJOB_INFO_2 type LPJOB_INFO_2A;
 %end; /* UNICODE */

 define structure
   1 JOB_INFO_3,
     2 JobId     type DWORD,
     2 NextJobId type DWORD,
     2 Reserved  type DWORD;
 define alias  PJOB_INFO_3 handle JOB_INFO_3;
 define alias LPJOB_INFO_3 handle JOB_INFO_3;

 dcl JOB_CONTROL_PAUSE             type DWORD value(1);
 dcl JOB_CONTROL_RESUME            type DWORD value(2);
 dcl JOB_CONTROL_CANCEL            type DWORD value(3);
 dcl JOB_CONTROL_RESTART           type DWORD value(4);
 dcl JOB_CONTROL_DELETE            type DWORD value(5);
 dcl JOB_CONTROL_SENT_TO_PRINTER   type DWORD value(6);
 dcl JOB_CONTROL_LAST_PAGE_EJECTED type DWORD value(7);

 dcl JOB_STATUS_PAUSED             type DWORD value('00000001'xu);
 dcl JOB_STATUS_ERROR              type DWORD value('00000002'xu);
 dcl JOB_STATUS_DELETING           type DWORD value('00000004'xu);
 dcl JOB_STATUS_SPOOLING           type DWORD value('00000008'xu);
 dcl JOB_STATUS_PRINTING           type DWORD value('00000010'xu);
 dcl JOB_STATUS_OFFLINE            type DWORD value('00000020'xu);
 dcl JOB_STATUS_PAPEROUT           type DWORD value('00000040'xu);
 dcl JOB_STATUS_PRINTED            type DWORD value('00000080'xu);
 dcl JOB_STATUS_DELETED            type DWORD value('00000100'xu);
 dcl JOB_STATUS_BLOCKED_DEVQ       type DWORD value('00000200'xu);
 dcl JOB_STATUS_USER_INTERVENTION  type DWORD value('00000400'xu);
 dcl JOB_STATUS_RESTART            type DWORD value('00000800'xu);

 dcl JOB_POSITION_UNSPECIFIED      fixed bin(31) value(0);

 define structure
   1  ADDJOB_INFO_1A,
     2 Path  type LPSTR,
     2 JobId type DWORD;
 define alias  PADDJOB_INFO_1A handle ADDJOB_INFO_1A;
 define alias LPADDJOB_INFO_1A handle ADDJOB_INFO_1A;

 define structure
   1 ADDJOB_INFO_1W,
     2 Path  type LPWSTR,
     2 JobId type DWORD;
 define alias  PADDJOB_INFO_1W handle ADDJOB_INFO_1W;
 define alias LPADDJOB_INFO_1W handle ADDJOB_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   ADDJOB_INFO_1 type   ADDJOB_INFO_1W;
 define alias  PADDJOB_INFO_1 type  PADDJOB_INFO_1W;
 define alias LPADDJOB_INFO_1 type LPADDJOB_INFO_1W;
 %end; %else %do;
 define alias   ADDJOB_INFO_1 type   ADDJOB_INFO_1A;
 define alias  PADDJOB_INFO_1 type  PADDJOB_INFO_1A;
 define alias LPADDJOB_INFO_1 type LPADDJOB_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 DRIVER_INFO_1A,
     2 pName type LPSTR; /* QMS 810 */
 define alias  PDRIVER_INFO_1A handle DRIVER_INFO_1A;
 define alias LPDRIVER_INFO_1A handle DRIVER_INFO_1A;

 define structure
   1 DRIVER_INFO_1W,
     2 pName type LPWSTR;/* QMS 810 */
 define alias  PDRIVER_INFO_1W handle DRIVER_INFO_1W;
 define alias LPDRIVER_INFO_1W handle DRIVER_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   DRIVER_INFO_1 type   DRIVER_INFO_1W;
 define alias  PDRIVER_INFO_1 type  PDRIVER_INFO_1W;
 define alias LPDRIVER_INFO_1 type LPDRIVER_INFO_1W;
 %end; %else %do;
 define alias   DRIVER_INFO_1 type   DRIVER_INFO_1A;
 define alias  PDRIVER_INFO_1 type  PDRIVER_INFO_1A;
 define alias LPDRIVER_INFO_1 type LPDRIVER_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 DRIVER_INFO_2A,
     2 cVersion     type DWORD,
     2 pName        type LPSTR, /* QMS 810 */
     2 pEnvironment type LPSTR, /* Win32 x86 */
     2 pDriverPath  type LPSTR, /* c:\drivers\pscript.dll */
     2 pDataFile    type LPSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile  type LPSTR; /* c:\drivers\PSCRPTUI.DLL */
 define alias  PDRIVER_INFO_2A handle DRIVER_INFO_2A;
 define alias LPDRIVER_INFO_2A handle DRIVER_INFO_2A;

 define structure
   1 DRIVER_INFO_2W,
     2 cVersion     type DWORD,
     2 pName        type LPWSTR, /* QMS 810 */
     2 pEnvironment type LPWSTR, /* Win32 x86 */
     2 pDriverPath  type LPWSTR, /* c:\drivers\pscript.dll */
     2 pDataFile    type LPWSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile  type LPWSTR; /* c:\drivers\PSCRPTUI.DLL */
 define alias  PDRIVER_INFO_2W handle DRIVER_INFO_2W;
 define alias LPDRIVER_INFO_2W handle DRIVER_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   DRIVER_INFO_2 type   DRIVER_INFO_2W;
 define alias  PDRIVER_INFO_2 type  PDRIVER_INFO_2W;
 define alias LPDRIVER_INFO_2 type LPDRIVER_INFO_2W;
 %end; %else %do;
 define alias   DRIVER_INFO_2 type   DRIVER_INFO_2A;
 define alias  PDRIVER_INFO_2 type  PDRIVER_INFO_2A;
 define alias LPDRIVER_INFO_2 type LPDRIVER_INFO_2A;
 %end; /* UNICODE */

 define structure
   1 DRIVER_INFO_3A,
     2 cVersion         type DWORD,
     2 pName            type LPSTR, /* QMS 810 */
     2 pEnvironment     type LPSTR, /* Win32 x86 */
     2 pDriverPath      type LPSTR, /* c:\drivers\pscript.dll */
     2 pDataFile        type LPSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile      type LPSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 pHelpFile        type LPSTR, /* c:\drivers\PSCRPTUI.HLP */
     2 pDependentFiles  type LPSTR, /* PSCRIPT.DLL\0QMS810.PPD\0 */
                 /* PSCRIPTUI.DLL\0PSCRIPTUI.HLP\0PSTEST.TXT\0\0 */
     2 pMonitorName     type LPSTR, /* 'PJL monitor' */
     2 pDefaultDataType type LPSTR; /* 'EMF' */
 define alias  PDRIVER_INFO_3A handle DRIVER_INFO_3A;
 define alias LPDRIVER_INFO_3A handle DRIVER_INFO_3A;

 define structure
   1 DRIVER_INFO_3W,
     2 cVersion         type DWORD,
     2 pName            type LPWSTR, /* QMS 810 */
     2 pEnvironment     type LPWSTR, /* Win32 x86 */
     2 pDriverPath      type LPWSTR, /* c:\drivers\pscript.dll */
     2 pDataFile        type LPWSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile      type LPWSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 pHelpFile        type LPWSTR, /* c:\drivers\PSCRPTUI.HLP */
     2 pDependentFiles  type LPWSTR, /* PSCRIPT.DLL\0QMS810.PPD\0 */
                 /* PSCRIPTUI.DLL\0PSCRIPTUI.HLP\0PSTEST.TXT\0\0 */
     2 pMonitorName     type LPWSTR, /* 'PJL monitor' */
     2 pDefaultDataType type LPWSTR; /* 'EMF' */
 define alias  PDRIVER_INFO_3W handle DRIVER_INFO_3W;
 define alias LPDRIVER_INFO_3W handle DRIVER_INFO_3W;

 %if UNICODE ^= '' %then %do;
 define alias   DRIVER_INFO_3 type   DRIVER_INFO_3W;
 define alias  PDRIVER_INFO_3 type  PDRIVER_INFO_3W;
 define alias LPDRIVER_INFO_3 type LPDRIVER_INFO_3W;
 %end; %else %do;
 define alias   DRIVER_INFO_3 type   DRIVER_INFO_3A;
 define alias  PDRIVER_INFO_3 type  PDRIVER_INFO_3A;
 define alias LPDRIVER_INFO_3 type LPDRIVER_INFO_3A;
 %end; /* UNICODE */

 define structure
   1 DRIVER_INFO_4A,
     2 cVersion          type DWORD,
     2 pName             type LPSTR, /* QMS 810 */
     2 pEnvironment      type LPSTR, /* Win32 x86 */
     2 pDriverPath       type LPSTR, /* c:\drivers\pscript.dll */
     2 pDataFile         type LPSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile       type LPSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 pHelpFile         type LPSTR, /* c:\drivers\PSCRPTUI.HLP */
     2 pDependentFiles   type LPSTR, /* PSCRIPT.DLL\0QMS810.PPD\0 */
                 /* PSCRIPTUI.DLL\0PSCRIPTUI.HLP\0PSTEST.TXT\0\0 */
     2 pMonitorName      type LPSTR, /* 'PJL monitor' */
     2 pDefaultDataType  type LPSTR, /* 'EMF' */
     2 pszzPreviousNames type LPSTR; /* "OldName1\0OldName2\0\0 */
 define alias  PDRIVER_INFO_4A handle DRIVER_INFO_4A;
 define alias LPDRIVER_INFO_4A handle DRIVER_INFO_4A;

 define structure
   1 DRIVER_INFO_4W,
     2 cVersion          type DWORD,
     2 pName             type LPWSTR, /* QMS 810 */
     2 pEnvironment      type LPWSTR, /* Win32 x86 */
     2 pDriverPath       type LPWSTR, /* c:\drivers\pscript.dll */
     2 pDataFile         type LPWSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile       type LPWSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 pHelpFile         type LPWSTR, /* c:\drivers\PSCRPTUI.HLP */
     2 pDependentFiles   type LPWSTR, /* PSCRIPT.DLL\0QMS810.PPD\0 */
                 /* PSCRIPTUI.DLL\0PSCRIPTUI.HLP\0PSTEST.TXT\0\0 */
     2 pMonitorName      type LPWSTR, /* 'PJL monitor' */
     2 pDefaultDataType  type LPWSTR, /* 'EMF' */
     2 pszzPreviousNames type LPWSTR; /* "OldName1\0OldName2\0\0 */
 define alias  PDRIVER_INFO_4W handle DRIVER_INFO_4W;
 define alias LPDRIVER_INFO_4W handle DRIVER_INFO_4W;

 %if UNICODE ^= '' %then %do;
 define alias   DRIVER_INFO_4 type   DRIVER_INFO_4W;
 define alias  PDRIVER_INFO_4 type  PDRIVER_INFO_4W;
 define alias LPDRIVER_INFO_4 type LPDRIVER_INFO_4W;
 %end; %else %do;
 define alias   DRIVER_INFO_4 type   DRIVER_INFO_4A;
 define alias  PDRIVER_INFO_4 type  PDRIVER_INFO_4A;
 define alias LPDRIVER_INFO_4 type LPDRIVER_INFO_4A;
 %end; /* UNICODE */

 define structure
   1 DRIVER_INFO_5A,
     2 cVersion           type DWORD,
     2 pName              type LPSTR, /* QMS 810 */
     2 pEnvironment       type LPSTR, /* Win32 x86 */
     2 pDriverPath        type LPSTR, /* c:\drivers\pscript.dll */
     2 pDataFile          type LPSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile        type LPSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 dwDriverAttributes type DWORD,
       /* driver attributes (like UMPD/KMPD) */
     2 dwConfigVersion    type DWORD,
       /* version number of the config file since reboot */
     2 dwDriverVersion    type DWORD;
       /* version number of the driver file since reboot */
 define alias  PDRIVER_INFO_5A handle DRIVER_INFO_5A;
 define alias LPDRIVER_INFO_5A handle DRIVER_INFO_5A;

 define structure
   1 DRIVER_INFO_5W,
     2 cVersion           type DWORD,
     2 pName              type LPWSTR, /* QMS 810 */
     2 pEnvironment       type LPWSTR, /* Win32 x86 */
     2 pDriverPath        type LPWSTR, /* c:\drivers\pscript.dll */
     2 pDataFile          type LPWSTR, /* c:\drivers\QMS810.PPD */
     2 pConfigFile        type LPWSTR, /* c:\drivers\PSCRPTUI.DLL */
     2 dwDriverAttributes type DWORD,
       /* driver attributes (like UMPD/KMPD) */
     2 dwConfigVersion    type DWORD,
       /* version number of the config file since reboot */
     2 dwDriverVersion    type DWORD;
       /* version number of the driver file since reboot */
 define alias  PDRIVER_INFO_5W handle DRIVER_INFO_5W;
 define alias LPDRIVER_INFO_5W handle DRIVER_INFO_5W;

 %if UNICODE ^= '' %then %do;
 define alias   DRIVER_INFO_5 type   DRIVER_INFO_5W;
 define alias  PDRIVER_INFO_5 type  PDRIVER_INFO_5W;
 define alias LPDRIVER_INFO_5 type LPDRIVER_INFO_5W;
 %end; %else %do;
 define alias   DRIVER_INFO_5 type   DRIVER_INFO_5A;
 define alias  PDRIVER_INFO_5 type  PDRIVER_INFO_5A;
 define alias LPDRIVER_INFO_5 type LPDRIVER_INFO_5A;
 %end; /* UNICODE */

 /* FLAGS for dwDriverAttributes */
 dcl DRIVER_KERNELMODE           type DWORD value('00000001'xu);
 dcl DRIVER_USERMODE             type DWORD value('00000002'xu);

 /* FLAGS for DeletePrinterDriverEx. */
 dcl DPD_DELETE_UNUSED_FILES     type DWORD value('00000001'xu);
 dcl DPD_DELETE_SPECIFIC_VERSION type DWORD value('00000002'xu);
 dcl DPD_DELETE_ALL_FILES        type DWORD value('00000004'xu);

 /* FLAGS for AddPrinterDriverEx. */
 dcl APD_STRICT_UPGRADE          type DWORD value('00000001'xu);
 dcl APD_STRICT_DOWNGRADE        type DWORD value('00000002'xu);
 dcl APD_COPY_ALL_FILES          type DWORD value('00000004'xu);
 dcl APD_COPY_NEW_FILES          type DWORD value('00000008'xu);

 define structure
   1 DOC_INFO_1A,
     2 pDocName    type LPSTR,
     2 pOutputFile type LPSTR,
     2 pDatatype   type LPSTR;
 define alias  PDOC_INFO_1A handle DOC_INFO_1A;
 define alias LPDOC_INFO_1A handle DOC_INFO_1A;

 define structure
   1 DOC_INFO_1W,
     2 pDocName    type LPWSTR,
     2 pOutputFile type LPWSTR,
     2 pDatatype   type LPWSTR;
 define alias  PDOC_INFO_1W handle DOC_INFO_1W;
 define alias LPDOC_INFO_1W handle DOC_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias  PDOC_INFO_1 type  PDOC_INFO_1W;
 define alias LPDOC_INFO_1 type LPDOC_INFO_1W;
 %end; %else %do;
 define alias  PDOC_INFO_1 type  PDOC_INFO_1A;
 define alias LPDOC_INFO_1 type LPDOC_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 FORM_INFO_1A,
     2 Flags         type DWORD,
     2 pName         type LPSTR,
     2 Size          type SIZEL,
     2 ImageableArea type RECTL;
 define alias  PFORM_INFO_1A handle FORM_INFO_1A;
 define alias LPFORM_INFO_1A handle FORM_INFO_1A;
 define structure
   1 FORM_INFO_1W,
     2 Flags         type DWORD,
     2 pName         type LPWSTR,
     2 Size          type SIZEL,
     2 ImageableArea type RECTL;
 define alias  PFORM_INFO_1W handle FORM_INFO_1W;
 define alias LPFORM_INFO_1W handle FORM_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   FORM_INFO_1 type   FORM_INFO_1W;
 define alias  PFORM_INFO_1 type  PFORM_INFO_1W;
 define alias LPFORM_INFO_1 type LPFORM_INFO_1W;
 %end; %else %do;
 define alias   FORM_INFO_1 type   FORM_INFO_1A;
 define alias  PFORM_INFO_1 type  PFORM_INFO_1A;
 define alias LPFORM_INFO_1 type LPFORM_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 DOC_INFO_2A,
     2 pDocName    type LPSTR,
     2 pOutputFile type LPSTR,
     2 pDatatype   type LPSTR,
     2 dwMode      type DWORD,
     2 JobId       type DWORD;
 define alias  PDOC_INFO_2A handle DOC_INFO_2A;
 define alias LPDOC_INFO_2A handle DOC_INFO_2A;

 define structure
   1 DOC_INFO_2W,
     2 pDocName    type LPWSTR,
     2 pOutputFile type LPWSTR,
     2 pDatatype   type LPWSTR,
     2 dwMode      type DWORD,
     2 JobId       type DWORD;
 define alias  PDOC_INFO_2W handle DOC_INFO_2W;
 define alias LPDOC_INFO_2W handle DOC_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   DOC_INFO_2 type   DOC_INFO_2W;
 define alias  PDOC_INFO_2 type  PDOC_INFO_2W;
 define alias LPDOC_INFO_2 type LPDOC_INFO_2W;
 %end; %else %do;
 define alias   DOC_INFO_2 type   DOC_INFO_2A;
 define alias  PDOC_INFO_2 type  PDOC_INFO_2A;
 define alias LPDOC_INFO_2 type LPDOC_INFO_2A;
 %end; /* UNICODE */

 dcl DI_CHANNEL        fixed bin(31) value(1);
     /* start direct read/write channel, */

 dcl DI_READ_SPOOL_JOB fixed bin(31) value(3);

 define structure
   1 DOC_INFO_3A,
     2 pDocName    type LPSTR,
     2 pOutputFile type LPSTR,
     2 pDatatype   type LPSTR,
     2 dwFlags     type DWORD;
 define alias  PDOC_INFO_3A handle DOC_INFO_3A;
 define alias LPDOC_INFO_3A handle DOC_INFO_3A;

 define structure
   1 DOC_INFO_3W,
     2 pDocName    type LPWSTR,
     2 pOutputFile type LPWSTR,
     2 pDatatype   type LPWSTR,
     2 dwFlags     type DWORD;
 define alias  PDOC_INFO_3W handle DOC_INFO_3W;
 define alias LPDOC_INFO_3W handle DOC_INFO_3W;

 %if UNICODE ^= '' %then %do;
 define alias   DOC_INFO_3 type   DOC_INFO_3W;
 define alias  PDOC_INFO_3 type  PDOC_INFO_3W;
 define alias LPDOC_INFO_3 type LPDOC_INFO_3W;
 %end; %else %do;
 define alias   DOC_INFO_3 type   DOC_INFO_3A;
 define alias  PDOC_INFO_3 type  PDOC_INFO_3A;
 define alias LPDOC_INFO_3 type LPDOC_INFO_3A;
 %end; /* UNICODE */


 dcl DI_MEMORYMAP_WRITE type DWORD value('00000001'xu);

 dcl FORM_USER          type DWORD value('00000000'xu);
 dcl FORM_BUILTIN       type DWORD value('00000001'xu);
 dcl FORM_PRINTER       type DWORD value('00000002'xu);

 define structure
   1 PRINTPROCESSOR_INFO_1A,
     2 pName type LPSTR;
 define alias  PPRINTPROCESSOR_INFO_1A handle PRINTPROCESSOR_INFO_1A;
 define alias LPPRINTPROCESSOR_INFO_1A handle PRINTPROCESSOR_INFO_1A;

 define structure
   1 PRINTPROCESSOR_INFO_1W,
     2 pName type LPWSTR;
 define alias  PPRINTPROCESSOR_INFO_1W handle PRINTPROCESSOR_INFO_1W;
 define alias LPPRINTPROCESSOR_INFO_1W handle PRINTPROCESSOR_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTPROCESSOR_INFO_1 type   PRINTPROCESSOR_INFO_1W;
 define alias  PPRINTPROCESSOR_INFO_1 type  PPRINTPROCESSOR_INFO_1W;
 define alias LPPRINTPROCESSOR_INFO_1 type LPPRINTPROCESSOR_INFO_1W;
 %end; %else %do;
 define alias   PRINTPROCESSOR_INFO_1 type   PRINTPROCESSOR_INFO_1A;
 define alias  PPRINTPROCESSOR_INFO_1 type  PPRINTPROCESSOR_INFO_1A;
 define alias LPPRINTPROCESSOR_INFO_1 type LPPRINTPROCESSOR_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 PRINTPROCESSOR_CAPS_1,
     2 dwLevel          type DWORD,
     2 dwNupOptions     type DWORD,
     2 dwPageOrderFlags type DWORD,
     2 dwNumberOfCopies type DWORD;
 define alias PPRINTPROCESSOR_CAPS_1 handle PRINTPROCESSOR_CAPS_1;

 define structure
   1 PORT_INFO_1A,
     2 pName type LPSTR;
 define alias  PPORT_INFO_1A handle PORT_INFO_1A;
 define alias LPPORT_INFO_1A handle PORT_INFO_1A;

 define structure
   1 PORT_INFO_1W,
     2 pName type LPWSTR;
 define alias  PPORT_INFO_1W handle PORT_INFO_1W;
 define alias LPPORT_INFO_1W handle PORT_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   PORT_INFO_1 type   PORT_INFO_1W;
 define alias  PPORT_INFO_1 type  PPORT_INFO_1W;
 define alias LPPORT_INFO_1 type LPPORT_INFO_1W;
 %end; %else %do;
 define alias   PORT_INFO_1 type   PORT_INFO_1A;
 define alias  PPORT_INFO_1 type  PPORT_INFO_1A;
 define alias LPPORT_INFO_1 type LPPORT_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 PORT_INFO_2A,
     2 pPortName    type LPSTR,
     2 pMonitorName type LPSTR,
     2 pDescription type LPSTR,
     2 fPortType    type DWORD,
     2 Reserved     type DWORD;
 define alias  PPORT_INFO_2A handle PORT_INFO_2A;
 define alias LPPORT_INFO_2A handle PORT_INFO_2A;

 define structure
   1 PORT_INFO_2W,
     2 pPortName    type LPWSTR,
     2 pMonitorName type LPWSTR,
     2 pDescription type LPWSTR,
     2 fPortType    type DWORD,
     2 Reserved     type DWORD;
 define alias  PPORT_INFO_2W handle PORT_INFO_2W;
 define alias LPPORT_INFO_2W handle PORT_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   PORT_INFO_2 type   PORT_INFO_2W;
 define alias  PPORT_INFO_2 type  PPORT_INFO_2W;
 define alias LPPORT_INFO_2 type LPPORT_INFO_2W;
 %end; %else %do;
 define alias   PORT_INFO_2 type   PORT_INFO_2A;
 define alias  PPORT_INFO_2 type  PPORT_INFO_2A;
 define alias LPPORT_INFO_2 type LPPORT_INFO_2A;
 %end; /* UNICODE */

 dcl PORT_TYPE_WRITE        type DWORD value('0001'xu);
 dcl PORT_TYPE_READ         type DWORD value('0002'xu);
 dcl PORT_TYPE_REDIRECTED   type DWORD value('0004'xu);
 dcl PORT_TYPE_NET_ATTACHED type DWORD value('0008'xu);

 define structure
   1 PORT_INFO_3A,
     2 dwStatus   type DWORD,
     2 pszStatus  type LPSTR,
     2 dwSeverity type DWORD;
 define alias  PPORT_INFO_3A handle PORT_INFO_3A;
 define alias LPPORT_INFO_3A handle PORT_INFO_3A;

 define structure
   1 PORT_INFO_3W,
     2 dwStatus   type DWORD,
     2 pszStatus  type LPWSTR,
     2 dwSeverity type DWORD;
 define alias  PPORT_INFO_3W handle PORT_INFO_3W;
 define alias LPPORT_INFO_3W handle PORT_INFO_3W;

 %if UNICODE ^= '' %then %do;
 define alias   PORT_INFO_3 type   PORT_INFO_3W;
 define alias  PPORT_INFO_3 type  PPORT_INFO_3W;
 define alias LPPORT_INFO_3 type LPPORT_INFO_3W;
 %end; %else %do;
 define alias   PORT_INFO_3 type   PORT_INFO_3A;
 define alias  PPORT_INFO_3 type  PPORT_INFO_3A;
 define alias LPPORT_INFO_3 type LPPORT_INFO_3A;
 %end; /* UNICODE */

 dcl PORT_STATUS_TYPE_ERROR        type DWORD value(1);
 dcl PORT_STATUS_TYPE_WARNING      type DWORD value(2);
 dcl PORT_STATUS_TYPE_INFO         type DWORD value(3);

 dcl PORT_STATUS_OFFLINE           type DWORD value(1);
 dcl PORT_STATUS_PAPER_JAM         type DWORD value(2);
 dcl PORT_STATUS_PAPER_OUT         type DWORD value(3);
 dcl PORT_STATUS_OUTPUT_BIN_FULL   type DWORD value(4);
 dcl PORT_STATUS_PAPER_PROBLEM     type DWORD value(5);
 dcl PORT_STATUS_NO_TONER          type DWORD value(6);
 dcl PORT_STATUS_DOOR_OPEN         type DWORD value(7);
 dcl PORT_STATUS_USER_INTERVENTION type DWORD value(8);
 dcl PORT_STATUS_OUT_OF_MEMORY     type DWORD value(9);

 dcl PORT_STATUS_TONER_LOW         type DWORD value(10);

 dcl PORT_STATUS_WARMING_UP        type DWORD value(11);
 dcl PORT_STATUS_POWER_SAVE        type DWORD value(12);


 define structure
   1 MONITOR_INFO_1A,
     2 pName type LPSTR;
 define alias  PMONITOR_INFO_1A handle MONITOR_INFO_1A;
 define alias LPMONITOR_INFO_1A handle MONITOR_INFO_1A;

 define structure
   1 MONITOR_INFO_1W,
     2 pName type LPWSTR;
 define alias  PMONITOR_INFO_1W handle MONITOR_INFO_1W;
 define alias LPMONITOR_INFO_1W handle MONITOR_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   MONITOR_INFO_1 type   MONITOR_INFO_1W;
 define alias  PMONITOR_INFO_1 type  PMONITOR_INFO_1W;
 define alias LPMONITOR_INFO_1 type LPMONITOR_INFO_1W;
 %end; %else %do;
 define alias   MONITOR_INFO_1 type   MONITOR_INFO_1A;
 define alias  PMONITOR_INFO_1 type  PMONITOR_INFO_1A;
 define alias LPMONITOR_INFO_1 type LPMONITOR_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 MONITOR_INFO_2A,
     2 pName        type LPSTR,
     2 pEnvironment type LPSTR,
     2 pDLLName     type LPSTR;
 define alias  PMONITOR_INFO_2A handle MONITOR_INFO_2A;
 define alias LPMONITOR_INFO_2A handle MONITOR_INFO_2A;

 define structure
   1 MONITOR_INFO_2W,
     2 pName        type LPWSTR,
     2 pEnvironment type LPWSTR,
     2 pDLLName     type LPWSTR;
 define alias  PMONITOR_INFO_2W handle MONITOR_INFO_2W;
 define alias LPMONITOR_INFO_2W handle MONITOR_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   MONITOR_INFO_2 type   MONITOR_INFO_2W;
 define alias  PMONITOR_INFO_2 type  PMONITOR_INFO_2W;
 define alias LPMONITOR_INFO_2 type LPMONITOR_INFO_2W;
 %end; %else %do;
 define alias   MONITOR_INFO_2 type   MONITOR_INFO_2A;
 define alias  PMONITOR_INFO_2 type  PMONITOR_INFO_2A;
 define alias LPMONITOR_INFO_2 type LPMONITOR_INFO_2A;
 %end; /* UNICODE */

 define structure
   1 DATATYPES_INFO_1A,
     2 pName type LPSTR;
 define alias  PDATATYPES_INFO_1A handle DATATYPES_INFO_1A;
 define alias LPDATATYPES_INFO_1A handle DATATYPES_INFO_1A;

 define structure
   1 DATATYPES_INFO_1W,
     2 pName type LPWSTR;
 define alias  PDATATYPES_INFO_1W handle DATATYPES_INFO_1W;
 define alias LPDATATYPES_INFO_1W handle DATATYPES_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   DATATYPES_INFO_1 type   DATATYPES_INFO_1W;
 define alias  PDATATYPES_INFO_1 type  PDATATYPES_INFO_1W;
 define alias LPDATATYPES_INFO_1 type LPDATATYPES_INFO_1W;
 %end; %else %do;
 define alias   DATATYPES_INFO_1 type   DATATYPES_INFO_1A;
 define alias  PDATATYPES_INFO_1 type  PDATATYPES_INFO_1A;
 define alias LPDATATYPES_INFO_1 type LPDATATYPES_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 PRINTER_DEFAULTSA,
     2 pDatatype     type LPSTR,
     2 pDevMode      type LPDEVMODEA,
     2 DesiredAccess type ACCESS_MASK;
 define alias  PPRINTER_DEFAULTSA handle PRINTER_DEFAULTSA;
 define alias LPPRINTER_DEFAULTSA handle PRINTER_DEFAULTSA;

 define structure
   1 PRINTER_DEFAULTSW,
     2 pDatatype     type LPWSTR,
     2 pDevMode      type LPDEVMODEW,
     2 DesiredAccess type ACCESS_MASK;
 define alias  PPRINTER_DEFAULTSW handle PRINTER_DEFAULTSW;
 define alias LPPRINTER_DEFAULTSW handle PRINTER_DEFAULTSW;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_DEFAULTS type   PRINTER_DEFAULTSW;
 define alias  PPRINTER_DEFAULTS type  PPRINTER_DEFAULTSW;
 define alias LPPRINTER_DEFAULTS type LPPRINTER_DEFAULTSW;
 %end; %else %do;
 define alias   PRINTER_DEFAULTS type   PRINTER_DEFAULTSA;
 define alias  PPRINTER_DEFAULTS type  PPRINTER_DEFAULTSA;
 define alias LPPRINTER_DEFAULTS type LPPRINTER_DEFAULTSA;
 %end; /* UNICODE */

 define structure
   1 PRINTER_ENUM_VALUESA,
     2 pValueName  type LPSTR,
     2 cbValueName type DWORD,
     2 dwType      type DWORD,
     2 pData       type LPBYTE,
     2 cbData      type DWORD;
 define alias  PPRINTER_ENUM_VALUESA handle PRINTER_ENUM_VALUESA;
 define alias LPPRINTER_ENUM_VALUESA handle PRINTER_ENUM_VALUESA;

 define structure
   1 PRINTER_ENUM_VALUESW,
     2 pValueName  type LPWSTR,
     2 cbValueName type DWORD,
     2 dwType      type DWORD,
     2 pData       type LPBYTE,
     2 cbData      type DWORD;
 define alias  PPRINTER_ENUM_VALUESW handle PRINTER_ENUM_VALUESW;
 define alias LPPRINTER_ENUM_VALUESW handle PRINTER_ENUM_VALUESW;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTER_ENUM_VALUES type   PRINTER_ENUM_VALUESW;
 define alias  PPRINTER_ENUM_VALUES type  PPRINTER_ENUM_VALUESW;
 define alias LPPRINTER_ENUM_VALUES type LPPRINTER_ENUM_VALUESW;
 %end; %else %do;
 define alias   PRINTER_ENUM_VALUES type   PRINTER_ENUM_VALUESA;
 define alias  PPRINTER_ENUM_VALUES type  PPRINTER_ENUM_VALUESA;
 define alias LPPRINTER_ENUM_VALUES type LPPRINTER_ENUM_VALUESA;
 %end; /* UNICODE */

 dcl EnumPrintersA
     entry (type DWORD,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintersA');
 dcl EnumPrintersW
     entry (type DWORD,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintersW');

 %dcl EnumPrinters char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrinters='EnumPrintersW';
 %end; %else %do;
   %EnumPrinters='EnumPrintersA';
 %end; /* !UNICODE */

 dcl ( PRINTER_ENUM_DEFAULT      value('00000001'xu),
       PRINTER_ENUM_LOCAL        value('00000002'xu),
       PRINTER_ENUM_CONNECTIONS  value('00000004'xu),
       PRINTER_ENUM_FAVORITE     value('00000004'xu),
       PRINTER_ENUM_NAME         value('00000008'xu),
       PRINTER_ENUM_REMOTE       value('00000010'xu),
       PRINTER_ENUM_SHARED       value('00000020'xu),
       PRINTER_ENUM_NETWORK      value('00000040'xu),

       PRINTER_ENUM_EXPAND       value('00004000'xu),
       PRINTER_ENUM_CONTAINER    value('00008000'xu),

       PRINTER_ENUM_ICONMASK     value('00ff0000'xu),
       PRINTER_ENUM_ICON1        value('00010000'xu),
       PRINTER_ENUM_ICON2        value('00020000'xu),
       PRINTER_ENUM_ICON3        value('00040000'xu),
       PRINTER_ENUM_ICON4        value('00080000'xu),
       PRINTER_ENUM_ICON5        value('00100000'xu),
       PRINTER_ENUM_ICON6        value('00200000'xu),
       PRINTER_ENUM_ICON7        value('00400000'xu),
       PRINTER_ENUM_ICON8        value('00800000'xu),
       PRINTER_ENUM_HIDE         value('01000000'xu)
     ) type DWORD;

 define structure
   1 SPOOL_FILE_INFO_1,
     2 dwVersion    type DWORD,
     2 hSpoolFile   type HANDLE,
     2 dwAttributes type DWORD;
 define alias PSPOOL_FILE_INFO_1 handle SPOOL_FILE_INFO_1;

 dcl SPOOL_FILE_PERSISTENT    type DWORD value('00000001'xu);
 dcl SPOOL_FILE_TEMPORARY     type DWORD value('00000002'xu);

 dcl GetSpoolFileHandle
     entry (type HANDLE)
     returns (type HANDLE byvalue optional)
     WINAPI external ('GetSpoolFileHandle');

 dcl CommitSpoolData
     entry (type HANDLE,
            type HANDLE,
            type DWORD)
     returns (type HANDLE byvalue optional)
     WINAPI external ('CommitSpoolData');

 dcl CloseSpoolFileHandle
     entry (type HANDLE,
            type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('CloseSpoolFileHandle');

 dcl OpenPrinterA
     entry (char (*) varz byaddr,
            type HANDLE byaddr,
            type PRINTER_DEFAULTSA byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI external ('OpenPrinterA');
 dcl OpenPrinterW
     entry (WCHAR (*) varz byaddr,
            type HANDLE byaddr,
            type PRINTER_DEFAULTSW byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI external ('OpenPrinterW');

 %dcl OpenPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %OpenPrinter='OpenPrinterW';
 %end; %else %do;
   %OpenPrinter='OpenPrinterA';
 %end; /* !UNICODE */

 dcl ResetPrinterA
     entry (type HANDLE,
            type PRINTER_DEFAULTSA byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('ResetPrinterA');
 dcl ResetPrinterW
     entry (type HANDLE,
            type PRINTER_DEFAULTSW byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('ResetPrinterW');

 %dcl ResetPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %ResetPrinter='ResetPrinterW';
 %end; %else %do;
   %ResetPrinter='ResetPrinterA';
 %end; /* !UNICODE */

 dcl SetJobA
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetJobA');
 dcl SetJobW
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetJobW');

 %dcl SetJob char ext;
 %if UNICODE ^= '' %then %do;
   %SetJob='SetJobW';
 %end; %else %do;
   %SetJob='SetJobA';
 %end; /* !UNICODE */

 dcl GetJobA
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetJobA');
 dcl GetJobW
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetJobW');

 %dcl GetJob char ext;
 %if UNICODE ^= '' %then %do;
   %GetJob='GetJobW';
 %end; %else %do;
   %GetJob='GetJobA';
 %end; /* !UNICODE */

 dcl EnumJobsA
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumJobsA');
 dcl EnumJobsW
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumJobsW');

 %dcl EnumJobs char ext;
 %if UNICODE ^= '' %then %do;
   %EnumJobs='EnumJobsW';
 %end; %else %do;
   %EnumJobs='EnumJobsA';
 %end; /* !UNICODE */

 dcl AddPrinterA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type HANDLE byvalue optional)
     WINAPI external ('AddPrinterA');
 dcl AddPrinterW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type HANDLE byvalue optional)
     WINAPI external ('AddPrinterW');

 %dcl AddPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrinter='AddPrinterW';
 %end; %else %do;
   %AddPrinter='AddPrinterA';
 %end; /* !UNICODE */

 dcl DeletePrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinter');

 dcl SetPrinterA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetPrinterA');
 dcl SetPrinterW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetPrinterW');

 %dcl SetPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %SetPrinter='SetPrinterW';
 %end; %else %do;
   %SetPrinter='SetPrinterA';
 %end; /* !UNICODE */

 dcl GetPrinterA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterA');
 dcl GetPrinterW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterW');

 %dcl GetPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinter='GetPrinterW';
 %end; %else %do;
   %GetPrinter='GetPrinterA';
 %end; /* !UNICODE */

 dcl AddPrinterDriverA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterDriverA');
 dcl AddPrinterDriverW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterDriverW');

 %dcl AddPrinterDriver char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrinterDriver='AddPrinterDriverW';
 %end; %else %do;
   %AddPrinterDriver='AddPrinterDriverA';
 %end; /* !UNICODE */

 dcl AddPrinterDriverExA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterDriverExA');
 dcl AddPrinterDriverExW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterDriverExW');

 %dcl AddPrinterDriverEx char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrinterDriverEx='AddPrinterDriverExW';
 %end; %else %do;
   %AddPrinterDriverEx='AddPrinterDriverExA';
 %end; /* !UNICODE */

 dcl EnumPrinterDriversA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrinterDriversA');
 dcl EnumPrinterDriversW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrinterDriversW');

 %dcl EnumPrinterDrivers char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrinterDrivers='EnumPrinterDriversW';
 %end; %else %do;
   %EnumPrinterDrivers='EnumPrinterDriversA';
 %end; /* !UNICODE */

 dcl GetPrinterDriverA
     entry (type HANDLE,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterDriverA');
 dcl GetPrinterDriverW
     entry (type HANDLE,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterDriverW');

 %dcl GetPrinterDriver char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinterDriver='GetPrinterDriverW';
 %end; %else %do;
   %GetPrinterDriver='GetPrinterDriverA';
 %end; /* !UNICODE */

 dcl GetPrinterDriverDirectoryA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterDriverDirectoryA');
 dcl GetPrinterDriverDirectoryW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrinterDriverDirectoryW');

 %dcl GetPrinterDriverDirectory char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinterDriverDirectory='GetPrinterDriverDirectoryW';
 %end; %else %do;
   %GetPrinterDriverDirectory='GetPrinterDriverDirectoryA';
 %end; /* !UNICODE */

 dcl DeletePrinterDriverA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterDriverA');
 dcl DeletePrinterDriverW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterDriverW');

 %dcl DeletePrinterDriver char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterDriver='DeletePrinterDriverW';
 %end; %else %do;
   %DeletePrinterDriver='DeletePrinterDriverA';
 %end; /* !UNICODE */

 dcl DeletePrinterDriverExA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterDriverExA');
 dcl DeletePrinterDriverExW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterDriverExW');

 %dcl DeletePrinterDriverEx char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterDriverEx='DeletePrinterDriverExW';
 %end; %else %do;
   %DeletePrinterDriverEx='DeletePrinterDriverExA';
 %end; /* !UNICODE */

 dcl AddPerMachineConnectionA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPerMachineConnectionA');
 dcl AddPerMachineConnectionW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPerMachineConnectionW');

 %dcl AddPerMachineConnection char ext;
 %if UNICODE ^= '' %then %do;
   %AddPerMachineConnection='AddPerMachineConnectionW';
 %end; %else %do;
   %AddPerMachineConnection='AddPerMachineConnectionA';
 %end; /* !UNICODE */

 dcl DeletePerMachineConnectionA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePerMachineConnectionA');
 dcl DeletePerMachineConnectionW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePerMachineConnectionW');

 %dcl DeletePerMachineConnection char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePerMachineConnection='DeletePerMachineConnectionW';
 %end; %else %do;
   %DeletePerMachineConnection='DeletePerMachineConnectionA';
 %end; /* !UNICODE */

 dcl EnumPerMachineConnectionsA
     entry (char (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPerMachineConnectionsA');
 dcl EnumPerMachineConnectionsW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPerMachineConnectionsW');

 %dcl EnumPerMachineConnections char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPerMachineConnections='EnumPerMachineConnectionsW';
 %end; %else %do;
   %EnumPerMachineConnections='EnumPerMachineConnectionsA';
 %end; /* !UNICODE */

 dcl AddPrintProcessorA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrintProcessorA');
 dcl AddPrintProcessorW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrintProcessorW');

 %dcl AddPrintProcessor char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrintProcessor='AddPrintProcessorW';
 %end; %else %do;
   %AddPrintProcessor='AddPrintProcessorA';
 %end; /* !UNICODE */

 dcl EnumPrintProcessorsA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintProcessorsA');
 dcl EnumPrintProcessorsW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintProcessorsW');

 %dcl EnumPrintProcessors char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrintProcessors='EnumPrintProcessorsW';
 %end; %else %do;
   %EnumPrintProcessors='EnumPrintProcessorsA';
 %end; /* !UNICODE */


 dcl GetPrintProcessorDirectoryA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrintProcessorDirectoryA');
 dcl GetPrintProcessorDirectoryW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetPrintProcessorDirectoryW');

 %dcl GetPrintProcessorDirectory char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrintProcessorDirectory='GetPrintProcessorDirectoryW';
 %end; %else %do;
   %GetPrintProcessorDirectory='GetPrintProcessorDirectoryA';
 %end; /* !UNICODE */

 dcl EnumPrintProcessorDatatypesA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintProcessorDatatypesA');
 dcl EnumPrintProcessorDatatypesW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPrintProcessorDatatypesW');

 %dcl EnumPrintProcessorDatatypes char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrintProcessorDatatypes='EnumPrintProcessorDatatypesW';
 %end; %else %do;
   %EnumPrintProcessorDatatypes='EnumPrintProcessorDatatypesA';
 %end; /* !UNICODE */

 dcl DeletePrintProcessorA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrintProcessorA');
 dcl DeletePrintProcessorW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrintProcessorW');

 %dcl DeletePrintProcessor char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrintProcessor='DeletePrintProcessorW';
 %end; %else %do;
   %DeletePrintProcessor='DeletePrintProcessorA';
 %end; /* !UNICODE */

 dcl StartDocPrinterA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE)
     returns (type DWORD byvalue optional)
     WINAPI external ('StartDocPrinterA');
 dcl StartDocPrinterW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE)
     returns (type DWORD byvalue optional)
     WINAPI external ('StartDocPrinterW');

 %dcl StartDocPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %StartDocPrinter='StartDocPrinterW';
 %end; %else %do;
   %StartDocPrinter='StartDocPrinterA';
 %end; /* !UNICODE */

 dcl StartPagePrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('StartPagePrinter');

 dcl WritePrinter
     entry (type HANDLE,
            type LPVOID,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('WritePrinter');

 dcl FlushPrinter
     entry (type HANDLE,
            type LPVOID,
            type DWORD,
            type DWORD byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('FlushPrinter');

 dcl EndPagePrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('EndPagePrinter');

 dcl AbortPrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AbortPrinter');

 dcl ReadPrinter
     entry (type HANDLE,
            type LPVOID,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('ReadPrinter');

 dcl EndDocPrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('EndDocPrinter');

 dcl AddJobA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddJobA');
 dcl AddJobW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddJobW');

 %dcl AddJob char ext;
 %if UNICODE ^= '' %then %do;
   %AddJob='AddJobW';
 %end; %else %do;
   %AddJob='AddJobA';
 %end; /* !UNICODE */

 dcl ScheduleJob
     entry (type HANDLE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external ('ScheduleJob');

 dcl PrinterProperties
     entry (type HWND,
            type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('PrinterProperties');

 dcl DocumentPropertiesA
     entry (type HWND,
            type HANDLE,
            char (*) varz byaddr,
            type DEVMODEA byaddr optional,
            type DEVMODEA byaddr optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external ('DocumentPropertiesA');
 dcl DocumentPropertiesW
     entry (type HWND,
            type HANDLE,
            WCHAR (*) varz byaddr,
            type DEVMODEW byaddr optional,
            type DEVMODEW byaddr optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external ('DocumentPropertiesW');

 %dcl DocumentProperties char ext;
 %if UNICODE ^= '' %then %do;
   %DocumentProperties='DocumentPropertiesW';
 %end; %else %do;
   %DocumentProperties='DocumentPropertiesA';
 %end; /* !UNICODE */

 dcl AdvancedDocumentPropertiesA
     entry (type HWND,
            type HANDLE,
            char (*) varz byaddr,
            type DEVMODEA byaddr optional,
            type DEVMODEA byaddr optional)
     returns (type LONG byvalue optional)
     WINAPI external ('AdvancedDocumentPropertiesA');
 dcl AdvancedDocumentPropertiesW
     entry (type HWND,
            type HANDLE,
            WCHAR (*) varz byaddr,
            type DEVMODEW byaddr optional,
            type DEVMODEW byaddr optional)
     returns (type LONG byvalue optional)
     WINAPI external ('AdvancedDocumentPropertiesW');

 %dcl AdvancedDocumentProperties char ext;
 %if UNICODE ^= '' %then %do;
   %AdvancedDocumentProperties='AdvancedDocumentPropertiesW';
 %end; %else %do;
   %AdvancedDocumentProperties='AdvancedDocumentPropertiesA';
 %end; /* !UNICODE */

 dcl GetPrinterDataA
     entry (type HANDLE,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterDataA');
 dcl GetPrinterDataW
     entry (type HANDLE,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterDataW');

 %dcl GetPrinterData char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinterData='GetPrinterDataW';
 %end; %else %do;
   %GetPrinterData='GetPrinterDataA';
 %end; /* !UNICODE */

 dcl GetPrinterDataExA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterDataExA');
 dcl GetPrinterDataExW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterDataExW');

 %dcl GetPrinterDataEx char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinterDataEx='GetPrinterDataExW';
 %end; %else %do;
   %GetPrinterDataEx='GetPrinterDataExA';
 %end; /* !UNICODE */

 dcl EnumPrinterDataA
     entry (type HANDLE,
            type DWORD,
            char (*) varz byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterDataA');
 dcl EnumPrinterDataW
     entry (type HANDLE,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr optional,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterDataW');

 %dcl EnumPrinterData char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrinterData='EnumPrinterDataW';
 %end; %else %do;
   %EnumPrinterData='EnumPrinterDataA';
 %end; /* !UNICODE */

 dcl EnumPrinterDataExA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterDataExA');
 dcl EnumPrinterDataExW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterDataExW');

 %dcl EnumPrinterDataEx char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrinterDataEx='EnumPrinterDataExW';
 %end; %else %do;
   %EnumPrinterDataEx='EnumPrinterDataExA';
 %end; /* !UNICODE */

 dcl EnumPrinterKeyA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn,
            pointer, /* concatenation of nul-terminated strings */
            type DWORD,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterKeyA');
 dcl EnumPrinterKeyW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn,
            pointer, /* concatenation of nul-terminated wide strings */
            type DWORD,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('EnumPrinterKeyW');

 %dcl EnumPrinterKey char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPrinterKey='EnumPrinterKeyW';
 %end; %else %do;
   %EnumPrinterKey='EnumPrinterKeyA';
 %end; /* !UNICODE */


 dcl SetPrinterDataA
     entry (type HANDLE,
            char (*) varz byaddr,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterDataA');
 dcl SetPrinterDataW
     entry (type HANDLE,
            WCHAR (*) varz byaddr,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterDataW');

 %dcl SetPrinterData char ext;
 %if UNICODE ^= '' %then %do;
   %SetPrinterData='SetPrinterDataW';
 %end; %else %do;
   %SetPrinterData='SetPrinterDataA';
 %end; /* !UNICODE */


 dcl SetPrinterDataExA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterDataExA');
 dcl SetPrinterDataExW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterDataExW');

 %dcl SetPrinterDataEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetPrinterDataEx='SetPrinterDataExW';
 %end; %else %do;
   %SetPrinterDataEx='SetPrinterDataExA';
 %end; /* !UNICODE */


 dcl DeletePrinterDataA
     entry (type HANDLE,
            char (*) varz byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterDataA');
 dcl DeletePrinterDataW
     entry (type HANDLE,
            WCHAR (*) varz byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterDataW');

 %dcl DeletePrinterData char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterData='DeletePrinterDataW';
 %end; %else %do;
   %DeletePrinterData='DeletePrinterDataA';
 %end; /* !UNICODE */


 dcl DeletePrinterDataExA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterDataExA');
 dcl DeletePrinterDataExW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterDataExW');

 %dcl DeletePrinterDataEx char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterDataEx='DeletePrinterDataExW';
 %end; %else %do;
   %DeletePrinterDataEx='DeletePrinterDataExA';
 %end; /* !UNICODE */


 dcl DeletePrinterKeyA
     entry (type HANDLE,
            char (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterKeyA');
 dcl DeletePrinterKeyW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('DeletePrinterKeyW');

 %dcl DeletePrinterKey char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterKey='DeletePrinterKeyW';
 %end; %else %do;
   %DeletePrinterKey='DeletePrinterKeyA';
 %end; /* !UNICODE */


 dcl PRINTER_NOTIFY_TYPE                        type WORD value('00'xu);
 dcl JOB_NOTIFY_TYPE                            type WORD value('01'xu);

 dcl ( PRINTER_NOTIFY_FIELD_SERVER_NAME         value('00'xu),
       PRINTER_NOTIFY_FIELD_PRINTER_NAME        value('01'xu),
       PRINTER_NOTIFY_FIELD_SHARE_NAME          value('02'xu),
       PRINTER_NOTIFY_FIELD_PORT_NAME           value('03'xu),
       PRINTER_NOTIFY_FIELD_DRIVER_NAME         value('04'xu),
       PRINTER_NOTIFY_FIELD_COMMENT             value('05'xu),
       PRINTER_NOTIFY_FIELD_LOCATION            value('06'xu),
       PRINTER_NOTIFY_FIELD_DEVMODE             value('07'xu),
       PRINTER_NOTIFY_FIELD_SEPFILE             value('08'xu),
       PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR     value('09'xu),
       PRINTER_NOTIFY_FIELD_PARAMETERS          value('0A'xu),
       PRINTER_NOTIFY_FIELD_DATATYPE            value('0B'xu),
       PRINTER_NOTIFY_FIELD_SECURITY_DESCRIPTOR value('0C'xu),
       PRINTER_NOTIFY_FIELD_ATTRIBUTES          value('0D'xu),
       PRINTER_NOTIFY_FIELD_PRIORITY            value('0E'xu),
       PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY    value('0F'xu),
       PRINTER_NOTIFY_FIELD_START_TIME          value('10'xu),
       PRINTER_NOTIFY_FIELD_UNTIL_TIME          value('11'xu),
       PRINTER_NOTIFY_FIELD_STATUS              value('12'xu),
       PRINTER_NOTIFY_FIELD_STATUS_STRING       value('13'xu),
       PRINTER_NOTIFY_FIELD_CJOBS               value('14'xu),
       PRINTER_NOTIFY_FIELD_AVERAGE_PPM         value('15'xu),
       PRINTER_NOTIFY_FIELD_TOTAL_PAGES         value('16'xu),
       PRINTER_NOTIFY_FIELD_PAGES_PRINTED       value('17'xu),
       PRINTER_NOTIFY_FIELD_TOTAL_BYTES         value('18'xu),
       PRINTER_NOTIFY_FIELD_BYTES_PRINTED       value('19'xu),
       PRINTER_NOTIFY_FIELD_OBJECT_GUID         value('1A'xu)
     ) type WORD;

 dcl ( JOB_NOTIFY_FIELD_PRINTER_NAME            value('00'xu),
       JOB_NOTIFY_FIELD_MACHINE_NAME            value('01'xu),
       JOB_NOTIFY_FIELD_PORT_NAME               value('02'xu),
       JOB_NOTIFY_FIELD_USER_NAME               value('03'xu),
       JOB_NOTIFY_FIELD_NOTIFY_NAME             value('04'xu),
       JOB_NOTIFY_FIELD_DATATYPE                value('05'xu),
       JOB_NOTIFY_FIELD_PRINT_PROCESSOR         value('06'xu),
       JOB_NOTIFY_FIELD_PARAMETERS              value('07'xu),
       JOB_NOTIFY_FIELD_DRIVER_NAME             value('08'xu),
       JOB_NOTIFY_FIELD_DEVMODE                 value('09'xu),
       JOB_NOTIFY_FIELD_STATUS                  value('0A'xu),
       JOB_NOTIFY_FIELD_STATUS_STRING           value('0B'xu),
       JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR     value('0C'xu),
       JOB_NOTIFY_FIELD_DOCUMENT                value('0D'xu),
       JOB_NOTIFY_FIELD_PRIORITY                value('0E'xu),
       JOB_NOTIFY_FIELD_POSITION                value('0F'xu),
       JOB_NOTIFY_FIELD_SUBMITTED               value('10'xu),
       JOB_NOTIFY_FIELD_START_TIME              value('11'xu),
       JOB_NOTIFY_FIELD_UNTIL_TIME              value('12'xu),
       JOB_NOTIFY_FIELD_TIME                    value('13'xu),
       JOB_NOTIFY_FIELD_TOTAL_PAGES             value('14'xu),
       JOB_NOTIFY_FIELD_PAGES_PRINTED           value('15'xu),
       JOB_NOTIFY_FIELD_TOTAL_BYTES             value('16'xu),
       JOB_NOTIFY_FIELD_BYTES_PRINTED           value('17'xu)
     ) type WORD;


 define structure
   1 PRINTER_NOTIFY_OPTIONS_TYPE,
     2 Type      type WORD,
     2 Reserved0 type WORD,
     2 Reserved1 type DWORD,
     2 Reserved2 type DWORD,
     2 Count     type DWORD,
     2 pFields   type PWORD;
 define alias   PPRINTER_NOTIFY_OPTIONS_TYPE
              handle PRINTER_NOTIFY_OPTIONS_TYPE;
 define alias LPPRINTER_NOTIFY_OPTIONS_TYPE
              handle PRINTER_NOTIFY_OPTIONS_TYPE;

 dcl PRINTER_NOTIFY_OPTIONS_REFRESH type DWORD value('01'xu);

 define structure
   1 PRINTER_NOTIFY_OPTIONS,
     2 Version type DWORD,
     2 Flags   type DWORD,
     2 Count   type DWORD,
     2 pTypes  type PPRINTER_NOTIFY_OPTIONS_TYPE;
 define alias  PPRINTER_NOTIFY_OPTIONS handle PRINTER_NOTIFY_OPTIONS;
 define alias LPPRINTER_NOTIFY_OPTIONS handle PRINTER_NOTIFY_OPTIONS;


 dcl PRINTER_NOTIFY_INFO_DISCARDED  type DWORD value('01'xu);

 define structure
   1 PRINTER_NOTIFY_INFO_DATA,
     2 Type       type WORD,
     2 Field      type WORD,
     2 Reserved   type DWORD,
     2 Id         type DWORD,
     2 NotifyData union,
       3 adwData (2) type DWORD,
       3 Data,
         4 cbBuf  type DWORD,
         4 pBuf   type LPVOID;
 define alias  PPRINTER_NOTIFY_INFO_DATA
              handle PRINTER_NOTIFY_INFO_DATA;
 define alias LPPRINTER_NOTIFY_INFO_DATA
              handle PRINTER_NOTIFY_INFO_DATA;

 /* overlay following with based / refer version */
 define structure
   1 PRINTER_NOTIFY_INFO,
     2 Version type DWORD,
     2 Flags   type DWORD,
     2 Count   type DWORD,
     2 aData   (1) type PRINTER_NOTIFY_INFO_DATA;
 define alias  PPRINTER_NOTIFY_INFO handle PRINTER_NOTIFY_INFO;
 define alias LPPRINTER_NOTIFY_INFO handle PRINTER_NOTIFY_INFO;

 dcl WaitForPrinterChange
     entry (type HANDLE,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('WaitForPrinterChange');

 dcl FindFirstPrinterChangeNotification
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type LPVOID)
     returns (type HANDLE byvalue optional)
     WINAPI external ('FindFirstPrinterChangeNotification');

 dcl FindNextPrinterChangeNotification
     entry (type HANDLE,
            type PDWORD,
            type LPVOID,
            type LPVOID byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('FindNextPrinterChangeNotification');

 dcl FreePrinterNotifyInfo
     entry (type PRINTER_NOTIFY_INFO byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('FreePrinterNotifyInfo');

 dcl FindClosePrinterChangeNotification
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('FindClosePrinterChangeNotification');

 dcl ( PRINTER_CHANGE_ADD_PRINTER               value('00000001'xu),
       PRINTER_CHANGE_SET_PRINTER               value('00000002'xu),
       PRINTER_CHANGE_DELETE_PRINTER            value('00000004'xu),
       PRINTER_CHANGE_FAILED_CONNECTION_PRINTER value('00000008'xu),
       PRINTER_CHANGE_PRINTER                   value('000000FF'xu),
       PRINTER_CHANGE_ADD_JOB                   value('00000100'xu),
       PRINTER_CHANGE_SET_JOB                   value('00000200'xu),
       PRINTER_CHANGE_DELETE_JOB                value('00000400'xu),
       PRINTER_CHANGE_WRITE_JOB                 value('00000800'xu),
       PRINTER_CHANGE_JOB                       value('0000FF00'xu),
       PRINTER_CHANGE_ADD_FORM                  value('00010000'xu),
       PRINTER_CHANGE_SET_FORM                  value('00020000'xu),
       PRINTER_CHANGE_DELETE_FORM               value('00040000'xu),
       PRINTER_CHANGE_FORM                      value('00070000'xu),
       PRINTER_CHANGE_ADD_PORT                  value('00100000'xu),
       PRINTER_CHANGE_CONFIGURE_PORT            value('00200000'xu),
       PRINTER_CHANGE_DELETE_PORT               value('00400000'xu),
       PRINTER_CHANGE_PORT                      value('00700000'xu),
       PRINTER_CHANGE_ADD_PRINT_PROCESSOR       value('01000000'xu),
       PRINTER_CHANGE_DELETE_PRINT_PROCESSOR    value('04000000'xu),
       PRINTER_CHANGE_PRINT_PROCESSOR           value('07000000'xu),
       PRINTER_CHANGE_ADD_PRINTER_DRIVER        value('10000000'xu),
       PRINTER_CHANGE_SET_PRINTER_DRIVER        value('20000000'xu),
       PRINTER_CHANGE_DELETE_PRINTER_DRIVER     value('40000000'xu),
       PRINTER_CHANGE_PRINTER_DRIVER            value('70000000'xu),
       PRINTER_CHANGE_TIMEOUT                   value('80000000'xu),
       PRINTER_CHANGE_ALL                       value('7777FFFF'xu)
     ) type DWORD;

 dcl PrinterMessageBoxA
     entry (type HANDLE,
            type DWORD,
            type HWND,
            char (*) varz byaddr,
            char (*) varz byaddr optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('PrinterMessageBoxA');
 dcl PrinterMessageBoxW
     entry (type HANDLE,
            type DWORD,
            type HWND,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external ('PrinterMessageBoxW');

 %dcl PrinterMessageBox char ext;
 %if UNICODE ^= '' %then %do;
   %PrinterMessageBox='PrinterMessageBoxW';
 %end; %else %do;
   %PrinterMessageBox='PrinterMessageBoxA';
 %end; /* !UNICODE */



 dcl PRINTER_ERROR_INFORMATION type DWORD value('80000000'xu);
 dcl PRINTER_ERROR_WARNING     type DWORD value('40000000'xu);
 dcl PRINTER_ERROR_SEVERE      type DWORD value('20000000'xu);

 dcl PRINTER_ERROR_OUTOFPAPER  type DWORD value('00000001'xu);
 dcl PRINTER_ERROR_JAM         type DWORD value('00000002'xu);
 dcl PRINTER_ERROR_OUTOFTONER  type DWORD value('00000004'xu);

 dcl ClosePrinter
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external ('ClosePrinter');

 dcl AddFormA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddFormA');
 dcl AddFormW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddFormW');

 %dcl AddForm char ext;
 %if UNICODE ^= '' %then %do;
   %AddForm='AddFormW';
 %end; %else %do;
   %AddForm='AddFormA';
 %end; /* !UNICODE */


 dcl DeleteFormA
     entry (type HANDLE,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeleteFormA');
 dcl DeleteFormW
     entry (type HANDLE,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeleteFormW');

 %dcl DeleteForm char ext;
 %if UNICODE ^= '' %then %do;
   %DeleteForm='DeleteFormW';
 %end; %else %do;
   %DeleteForm='DeleteFormA';
 %end; /* !UNICODE */


 dcl GetFormA
     entry (type HANDLE,
            char (*) varz byaddr,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetFormA');
 dcl GetFormW
     entry (type HANDLE,
            WCHAR (*) varz byaddr,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetFormW');

 %dcl GetForm char ext;
 %if UNICODE ^= '' %then %do;
   %GetForm='GetFormW';
 %end; %else %do;
   %GetForm='GetFormA';
 %end; /* !UNICODE */


 dcl SetFormA
     entry (type HANDLE,
            char (*) varz byaddr,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetFormA');
 dcl SetFormW
     entry (type HANDLE,
            WCHAR (*) varz byaddr,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetFormW');

 %dcl SetForm char ext;
 %if UNICODE ^= '' %then %do;
   %SetForm='SetFormW';
 %end; %else %do;
   %SetForm='SetFormA';
 %end; /* !UNICODE */


 dcl EnumFormsA
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumFormsA');
 dcl EnumFormsW
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumFormsW');

 %dcl EnumForms char ext;
 %if UNICODE ^= '' %then %do;
   %EnumForms='EnumFormsW';
 %end; %else %do;
   %EnumForms='EnumFormsA';
 %end; /* !UNICODE */


 dcl EnumMonitorsA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumMonitorsA');
 dcl EnumMonitorsW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumMonitorsW');

 %dcl EnumMonitors char ext;
 %if UNICODE ^= '' %then %do;
   %EnumMonitors='EnumMonitorsW';
 %end; %else %do;
   %EnumMonitors='EnumMonitorsA';
 %end; /* !UNICODE */


 dcl AddMonitorA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddMonitorA');
 dcl AddMonitorW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddMonitorW');

 %dcl AddMonitor char ext;
 %if UNICODE ^= '' %then %do;
   %AddMonitor='AddMonitorW';
 %end; %else %do;
   %AddMonitor='AddMonitorA';
 %end; /* !UNICODE */


 dcl DeleteMonitorA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeleteMonitorA');
 dcl DeleteMonitorW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeleteMonitorW');

 %dcl DeleteMonitor char ext;
 %if UNICODE ^= '' %then %do;
   %DeleteMonitor='DeleteMonitorW';
 %end; %else %do;
   %DeleteMonitor='DeleteMonitorA';
 %end; /* !UNICODE */


 dcl EnumPortsA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPortsA');
 dcl EnumPortsW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('EnumPortsW');

 %dcl EnumPorts char ext;
 %if UNICODE ^= '' %then %do;
   %EnumPorts='EnumPortsW';
 %end; %else %do;
   %EnumPorts='EnumPortsA';
 %end; /* !UNICODE */


 dcl AddPortA
     entry (char (*) varz byaddr optional,
            type HWND,
            type LPSTR)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPortA');
 dcl AddPortW
     entry (WCHAR (*) varz byaddr optional,
            type HWND,
            type LPWSTR)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPortW');

 %dcl AddPort char ext;
 %if UNICODE ^= '' %then %do;
   %AddPort='AddPortW';
 %end; %else %do;
   %AddPort='AddPortA';
 %end; /* !UNICODE */


 dcl ConfigurePortA
     entry (char (*) varz byaddr optional,
            type HWND,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('ConfigurePortA');
 dcl ConfigurePortW
     entry (WCHAR (*) varz byaddr optional,
            type HWND,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('ConfigurePortW');

 %dcl ConfigurePort char ext;
 %if UNICODE ^= '' %then %do;
   %ConfigurePort='ConfigurePortW';
 %end; %else %do;
   %ConfigurePort='ConfigurePortA';
 %end; /* !UNICODE */

 dcl DeletePortA
     entry (char (*) varz byaddr optional,
            type HWND,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePortA');
 dcl DeletePortW
     entry (WCHAR (*) varz byaddr optional,
            type HWND,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePortW');

 %dcl DeletePort char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePort='DeletePortW';
 %end; %else %do;
   %DeletePort='DeletePortA';
 %end; /* !UNICODE */

 dcl XcvDataW
     entry (type HANDLE,
            WCHAR (*) varz byaddr nonasgn,
            type PBYTE,
            type DWORD,
            type PBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('XcvDataW');
 %dcl XcvData char ext;
 %XcvData='XcvDataW';


 dcl GetDefaultPrinterA
     entry (char (*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetDefaultPrinterA');
 dcl GetDefaultPrinterW
     entry (WCHAR (*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('GetDefaultPrinterW');
 %dcl GetDefaultPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %GetDefaultPrinter='GetDefaultPrinterW';
 %end; %else %do;
   %GetDefaultPrinter='GetDefaultPrinterA';
 %end; /* !UNICODE */

 dcl SetDefaultPrinterA
     entry (char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetDefaultPrinterA');
 dcl SetDefaultPrinterW
     entry (WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetDefaultPrinterW');
 %dcl SetDefaultPrinter char ext;
 %if UNICODE ^= '' %then %do;
   %SetDefaultPrinter='SetDefaultPrinterW';
 %end; %else %do;
   %SetDefaultPrinter='SetDefaultPrinterA';
 %end; /* !UNICODE */


 dcl SetPortA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetPortA');
 dcl SetPortW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('SetPortW');

 %dcl SetPort char ext;
 %if UNICODE ^= '' %then %do;
   %SetPort='SetPortW';
 %end; %else %do;
   %SetPort='SetPortA';
 %end; /* !UNICODE */


 dcl AddPrinterConnectionA
     entry (char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterConnectionA');
 dcl AddPrinterConnectionW
     entry (WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrinterConnectionW');

 %dcl AddPrinterConnection char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrinterConnection='AddPrinterConnectionW';
 %end; %else %do;
   %AddPrinterConnection='AddPrinterConnectionA';
 %end; /* !UNICODE */


 dcl DeletePrinterConnectionA
     entry (char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterConnectionA');
 dcl DeletePrinterConnectionW
     entry (WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrinterConnectionW');

 %dcl DeletePrinterConnection char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrinterConnection='DeletePrinterConnectionW';
 %end; %else %do;
   %DeletePrinterConnection='DeletePrinterConnectionA';
 %end; /* !UNICODE */


 dcl ConnectToPrinterDlg
     entry (type HWND,
            type DWORD)
     returns (type HANDLE byvalue optional)
     WINAPI external ('ConnectToPrinterDlg');

 define structure
   1 PROVIDOR_INFO_1A,
     2 pName        type LPSTR,
     2 pEnvironment type LPSTR,
     2 pDLLName     type LPSTR;
 define alias  PPROVIDOR_INFO_1A handle PROVIDOR_INFO_1A;
 define alias LPPROVIDOR_INFO_1A handle PROVIDOR_INFO_1A;

 define structure
   1 PROVIDOR_INFO_1W,
     2 pName        type LPWSTR,
     2 pEnvironment type LPWSTR,
     2 pDLLName     type LPWSTR;
 define alias  PPROVIDOR_INFO_1W handle PROVIDOR_INFO_1W;
 define alias LPPROVIDOR_INFO_1W handle PROVIDOR_INFO_1W;

 %if UNICODE ^= '' %then %do;
 define alias   PROVIDOR_INFO_1 type   PROVIDOR_INFO_1W;
 define alias  PPROVIDOR_INFO_1 type  PPROVIDOR_INFO_1W;
 define alias LPPROVIDOR_INFO_1 type LPPROVIDOR_INFO_1W;
 %end; %else %do;
 define alias   PROVIDOR_INFO_1 type   PROVIDOR_INFO_1A;
 define alias  PPROVIDOR_INFO_1 type  PPROVIDOR_INFO_1A;
 define alias LPPROVIDOR_INFO_1 type LPPROVIDOR_INFO_1A;
 %end; /* UNICODE */

 define structure
   1 PROVIDOR_INFO_2A,
     2 pOrder type LPSTR;
 define alias  PPROVIDOR_INFO_2A handle PROVIDOR_INFO_2A;
 define alias LPPROVIDOR_INFO_2A handle PROVIDOR_INFO_2A;

 define structure
   1 PROVIDOR_INFO_2W,
     2 pOrder type LPWSTR;
 define alias  PPROVIDOR_INFO_2W handle PROVIDOR_INFO_2W;
 define alias LPPROVIDOR_INFO_2W handle PROVIDOR_INFO_2W;

 %if UNICODE ^= '' %then %do;
 define alias   PROVIDOR_INFO_2 type   PROVIDOR_INFO_2W;
 define alias  PPROVIDOR_INFO_2 type  PPROVIDOR_INFO_2W;
 define alias LPPROVIDOR_INFO_2 type LPPROVIDOR_INFO_2W;
 %end; %else %do;
 define alias   PROVIDOR_INFO_2 type   PROVIDOR_INFO_2A;
 define alias  PPROVIDOR_INFO_2 type  PPROVIDOR_INFO_2A;
 define alias LPPROVIDOR_INFO_2 type LPPROVIDOR_INFO_2A;
 %end; /* UNICODE */

 dcl AddPrintProvidorA
     entry (char (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrintProvidorA');
 dcl AddPrintProvidorW
     entry (WCHAR (*) varz byaddr optional,
            type DWORD,
            type LPBYTE)
     returns (type BOOL byvalue optional)
     WINAPI external ('AddPrintProvidorW');

 %dcl AddPrintProvidor char ext;
 %if UNICODE ^= '' %then %do;
   %AddPrintProvidor='AddPrintProvidorW';
 %end; %else %do;
   %AddPrintProvidor='AddPrintProvidorA';
 %end; /* !UNICODE */

 dcl DeletePrintProvidorA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr optional,
            char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrintProvidorA');
 dcl DeletePrintProvidorW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external ('DeletePrintProvidorW');

 %dcl DeletePrintProvidor char ext;
 %if UNICODE ^= '' %then %do;
   %DeletePrintProvidor='DeletePrintProvidorW';
 %end; %else %do;
   %DeletePrintProvidor='DeletePrintProvidorA';
 %end; /* !UNICODE */


 /* SetPrinterData and GetPrinterData Server Handle Key values */

 dcl SPLREG_DEFAULT_SPOOL_DIRECTORY           TCHAR
     value('DefaultSpoolDirectory');
 dcl SPLREG_PORT_THREAD_PRIORITY_DEFAULT      TCHAR
     value('PortThreadPriorityDefault');
 dcl SPLREG_PORT_THREAD_PRIORITY              TCHAR
     value('PortThreadPriority');
 dcl SPLREG_SCHEDULER_THREAD_PRIORITY_DEFAULT TCHAR
     value('SchedulerThreadPriorityDefault');
 dcl SPLREG_SCHEDULER_THREAD_PRIORITY         TCHAR
     value('SchedulerThreadPriority');
 dcl SPLREG_BEEP_ENABLED          TCHAR value('BeepEnabled');
 dcl SPLREG_NET_POPUP             TCHAR value('NetPopup');
 dcl SPLREG_RETRY_POPUP           TCHAR value('RetryPopup');
 dcl SPLREG_NET_POPUP_TO_COMPUTER TCHAR value('NetPopupToComputer');
 dcl SPLREG_EVENT_LOG             TCHAR value('EventLog');
 dcl SPLREG_MAJOR_VERSION         TCHAR value('MajorVersion');
 dcl SPLREG_MINOR_VERSION         TCHAR value('MinorVersion');
 dcl SPLREG_ARCHITECTURE          TCHAR value('Architecture');
 dcl SPLREG_OS_VERSION            TCHAR value('OSVersion');
 dcl SPLREG_DS_PRESENT            TCHAR value('DsPresent');
 dcl SPLREG_DS_PRESENT_FOR_USER   TCHAR value('DsPresentForUser');
 dcl SPLREG_REMOTE_FAX            TCHAR value('RemoteFax');
 dcl SPLREG_RESTART_JOB_ON_POOL_ERROR   TCHAR
     value('RestartJobOnPoolError');
 dcl SPLREG_RESTART_JOB_ON_POOL_ENABLED TCHAR
     value('RestartJobOnPoolEnabled');
 dcl SPLREG_DNS_MACHINE_NAME      TCHAR value('DNSMachineName');

 dcl SERVER_ACCESS_ADMINISTER  type DWORD value('00000001'xu);
 dcl SERVER_ACCESS_ENUMERATE   type DWORD value('00000002'xu);

 dcl PRINTER_ACCESS_ADMINISTER type DWORD value('00000004'xu);
 dcl PRINTER_ACCESS_USE        type DWORD value('00000008'xu);

 dcl JOB_ACCESS_ADMINISTER     type DWORD value('00000010'xu);


 /* Access rights for print servers */

 dcl SERVER_ALL_ACCESS fixed bin (31)
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 SERVER_ACCESS_ADMINISTER,
                 SERVER_ACCESS_ENUMERATE));

 dcl SERVER_READ       fixed bin (31)
     value (ior (STANDARD_RIGHTS_READ,
                 SERVER_ACCESS_ENUMERATE));

 dcl SERVER_WRITE      fixed bin (31)
     value (ior (STANDARD_RIGHTS_WRITE,
                 SERVER_ACCESS_ADMINISTER,
                 SERVER_ACCESS_ENUMERATE));

 dcl SERVER_EXECUTE    fixed bin (31)
     value (ior (STANDARD_RIGHTS_EXECUTE,
                 SERVER_ACCESS_ENUMERATE));


 /* Access rights for printers */

 dcl PRINTER_ALL_ACCESS fixed bin (31)
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 PRINTER_ACCESS_ADMINISTER,
                 PRINTER_ACCESS_USE));

 dcl PRINTER_READ       fixed bin (31)
     value (ior (STANDARD_RIGHTS_READ,
                 PRINTER_ACCESS_USE));

 dcl PRINTER_WRITE      fixed bin (31)
     value (ior (STANDARD_RIGHTS_WRITE,
                 PRINTER_ACCESS_USE));

 dcl PRINTER_EXECUTE    fixed bin (31)
     value (ior (STANDARD_RIGHTS_EXECUTE,
                 PRINTER_ACCESS_USE));


 /* Access rights for jobs */

 dcl JOB_ALL_ACCESS fixed bin (31)
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 JOB_ACCESS_ADMINISTER));

 dcl JOB_READ       fixed bin (31)
     value (ior (STANDARD_RIGHTS_READ,
                 JOB_ACCESS_ADMINISTER));

 dcl JOB_WRITE      fixed bin (31)
     value (ior (STANDARD_RIGHTS_WRITE,
                 JOB_ACCESS_ADMINISTER));

 dcl JOB_EXECUTE    fixed bin (31)
     value (ior (STANDARD_RIGHTS_EXECUTE,
                 JOB_ACCESS_ADMINISTER));


 /* DS Print-Queue property tables */


 /* Predefined Registry Keys used by Set/GetPrinterDataEx */
 dcl SPLDS_SPOOLER_KEY TCHAR value('DsSpooler');
 dcl SPLDS_DRIVER_KEY  TCHAR value('DsDriver');
 dcl SPLDS_USER_KEY    TCHAR value('DsUser');


 /* DS Print-Queue properties */

 dcl SPLDS_ASSET_NUMBER            TCHAR value('assetNumber');
 dcl SPLDS_BYTES_PER_MINUTE        TCHAR value('bytesPerMinute');
 dcl SPLDS_DESCRIPTION             TCHAR value('description');
 dcl SPLDS_DRIVER_NAME             TCHAR value('driverName');
 dcl SPLDS_DRIVER_VERSION          TCHAR value('driverVersion');
 dcl SPLDS_LOCATION                TCHAR value('location');
 dcl SPLDS_PORT_NAME               TCHAR value('portName');
 dcl SPLDS_PRINT_ATTRIBUTES        TCHAR value('printAttributes');
 dcl SPLDS_PRINT_BIN_NAMES         TCHAR value('printBinNames');
 dcl SPLDS_PRINT_COLLATE           TCHAR value('printCollate');
 dcl SPLDS_PRINT_COLOR             TCHAR value('printColor');
 dcl SPLDS_PRINT_DUPLEX_SUPPORTED  TCHAR value('printDuplexSupported');
 dcl SPLDS_PRINT_END_TIME          TCHAR value('printEndTime');
 dcl SPLDS_PRINTER_CLASS           TCHAR value('printQueue');
 dcl SPLDS_PRINTER_NAME            TCHAR value('printerName');
 dcl SPLDS_PRINT_KEEP_PRINTED_JOBS TCHAR value('printKeepPrintedJobs');
 dcl SPLDS_PRINT_LANGUAGE          TCHAR value('printLanguage');
 dcl SPLDS_PRINT_MAC_ADDRESS       TCHAR value('printMACAddress');
 dcl SPLDS_PRINT_MAX_X_EXTENT      TCHAR value('printMaxXExtent');
 dcl SPLDS_PRINT_MAX_Y_EXTENT      TCHAR value('printMaxYExtent');
 dcl SPLDS_PRINT_MAX_RESOLUTION_SUPPORTED
     TCHAR value('printMaxResolutionSupported');
 dcl SPLDS_PRINT_MEDIA_READY       TCHAR value('printMediaReady');
 dcl SPLDS_PRINT_MEDIA_SUPPORTED   TCHAR value('printMediaSupported');
 dcl SPLDS_PRINT_MEMORY            TCHAR value('printMemory');
 dcl SPLDS_PRINT_MIN_X_EXTENT      TCHAR value('printMinXExtent');
 dcl SPLDS_PRINT_MIN_Y_EXTENT      TCHAR value('printMinYExtent');
 dcl SPLDS_PRINT_NETWORK_ADDRESS   TCHAR value('printNetworkAddress');
 dcl SPLDS_PRINT_NOTIFY            TCHAR value('printNotify');
 dcl SPLDS_PRINT_NUMBER_UP         TCHAR value('printNumberUp');
 dcl SPLDS_PRINT_ORIENTATIONS_SUPPORTED
     TCHAR value('printOrientationsSupported');
 dcl SPLDS_PRINT_OWNER             TCHAR value('printOwner');
 dcl SPLDS_PRINT_PAGES_PER_MINUTE  TCHAR value('printPagesPerMinute');
 dcl SPLDS_PRINT_RATE              TCHAR value('printRate');
 dcl SPLDS_PRINT_RATE_UNIT         TCHAR value('printRateUnit');
 dcl SPLDS_PRINT_SEPARATOR_FILE    TCHAR value('printSeparatorFile');
 dcl SPLDS_PRINT_SHARE_NAME        TCHAR value('printShareName');
 dcl SPLDS_PRINT_SPOOLING          TCHAR value('printSpooling');
 dcl SPLDS_PRINT_STAPLING_SUPPORTED
     TCHAR value('printStaplingSupported');
 dcl SPLDS_PRINT_START_TIME        TCHAR value('printStartTime');
 dcl SPLDS_PRINT_STATUS            TCHAR value('printStatus');
 dcl SPLDS_PRIORITY                TCHAR value('priority');
 dcl SPLDS_SERVER_NAME             TCHAR value('serverName');
 dcl SPLDS_SHORT_SERVER_NAME       TCHAR value('shortServerName');
 dcl SPLDS_UNC_NAME                TCHAR value('uNCName');
 dcl SPLDS_URL                     TCHAR value('url');
 dcl SPLDS_FLAGS                   TCHAR value('flags');
 dcl SPLDS_VERSION_NUMBER          TCHAR value('versionNumber');

 /*   -- Additional Print-Queue properties --                       */
 /*                                                                 */
 /*   These properties are not defined in the default Directory     */
 /*   Services Schema, but should be used when extending the Schema */
 /*   so a consistent interface is maintained.                      */

 dcl SPLDS_PRINTER_NAME_ALIASES    TCHAR value('printerNameAliases');
                                   /* MULTI_SZ */
 dcl SPLDS_PRINTER_LOCATIONS       TCHAR value('printerLocations');
                                   /* MULTI_SZ */
 dcl SPLDS_PRINTER_MODEL           TCHAR value('printerModel');
                                   /* SZ */


 dcl PRINTER_HTML_VIEW_QUEUE           type DWORD value(0);
 dcl PRINTER_HTML_VIEW_PRINTPROPERTIES type DWORD value(1);
 dcl PRINTER_HTML_VIEW_INSTALL         type DWORD value(2);
 dcl PRINTER_HTML_VIEW_JOBPROPERTIES   type DWORD value(3);


 dcl SetPrinterHTMLViewA
     entry (type HANDLE,
            type DWORD,
            char (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterHTMLViewA');
 dcl SetPrinterHTMLViewW
     entry (type HANDLE,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINAPI external ('SetPrinterHTMLViewW');

 %dcl SetPrinterHTMLView char ext;
 %if UNICODE ^= '' %then %do;
   %SetPrinterHTMLView='SetPrinterHTMLViewW';
 %end; %else %do;
   %SetPrinterHTMLView='SetPrinterHTMLViewA';
 %end; /* !UNICODE */

 dcl GetPrinterHTMLViewA
     entry (type HANDLE,
            type DWORD,
            char (*) varz byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterHTMLViewA');
 dcl GetPrinterHTMLViewW
     entry (type HANDLE,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external ('GetPrinterHTMLViewW');

 %dcl GetPrinterHTMLView char ext;
 %if UNICODE ^= '' %then %do;
   %GetPrinterHTMLView='GetPrinterHTMLViewW';
 %end; %else %do;
   %GetPrinterHTMLView='GetPrinterHTMLViewA';
 %end; /* !UNICODE */

 %end; /* #WINSPOOL_ */
