 /* $XConsortium: X.h,v 1.66 88/09/06 15:55:56 jim Exp $ */

 /* Definitions for the X window system likely to be used by  */
 /* applications                                              */

 %dcl X_H char ext;
 %if X_H = '' %then %do;
 %X_H = 'Y';

 /*********************************************************************/
 /* Copyright 1987 by Digital Equipment Corporation, Maynard,         */
 /* Massachusetts, and the Massachusetts Institute of Technology,     */
 /* Cambridge, Massachusetts.                                         */
 /*                                                                   */
 /*                       All Rights Reserved                         */
 /*                                                                   */
 /* Permission to use, copy, modify, and distribute this software and */
 /* its documentation for any purpose and without fee is hereby       */
 /* granted, provided that the above copyright notice appear in all   */
 /* copies and that both that copyright notice and this permission    */
 /* notice appear in supporting documentation, and that the names of  */
 /* Digital or MIT not be used in advertising or publicity pertaining */
 /* to distribution of the software without specific, written prior   */
 /* permission.                                                       */
 /*                                                                   */
 /* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,    */
 /* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,  */
 /* IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR  */
 /* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM    */
 /* LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,   */
 /* NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN         */
 /* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.          */
 /*********************************************************************/

 dcl X_PROTOCOL fixed bin(31) value(11); /* current protocol version */
 dcl X_PROTOCOL_REVISION fixed bin(31) value(0);
                                         /* current minor version */

 /* Resources */

 define alias XID unsigned fixed bin(32);

 define alias Window    type XID;
 define alias Drawable  type XID;
 define alias Font      type XID;
 define alias Pixmap    type XID;
 define alias Cursor    type XID;
 define alias XColormap type XID;  /* originally: Colormap */
 define alias GContext  type XID;
 define alias KeySym    type XID;

 define alias Mask     unsigned fixed bin(32);
 define alias XAtom    unsigned fixed bin(32); /* originally: Atom */
 define alias VisualID unsigned fixed bin(32);
 define alias Time     unsigned fixed bin(32);
 define alias KeyCode  unsigned fixed bin(16);

 /*********************************************************************/
 /* RESERVED RESOURCE AND CONSTANT DEFINITIONS                        */
 /*********************************************************************/

 dcl None fixed bin(31) value(0);
     /* universal null resource or null atom */

 dcl ParentRelative fixed bin(31) value(1);
     /* background pixmap in CreateWindow and ChangeWindowAttributes  */

 dcl CopyFromParent fixed bin(31) value(0);
     /* border pixmap in CreateWindow and ChangeWindowAttributes      */
     /* special VisualID and special window class passed to           */
     /* CreateWindow                                                  */

 dcl PointerWindow   fixed bin(31) value(0);
     /* destination window in SendEvent */
 dcl InputFocus      fixed bin(31) value(1);
     /* destination window in SendEvent */
 dcl PointerRoot     fixed bin(31) value(1);
     /* focus window in SetInputFocus */
 dcl AnyPropertyType fixed bin(31) value(0);
     /* special Atom, passed to GetProperty */
 dcl AnyKey          fixed bin(31) value(0);
     /* special Key Code, passed to GrabKey */
 dcl AnyButton       fixed bin(31) value(0);
     /* special Button Code, passed to GrabButton */
 dcl AllTemporary    fixed bin(31) value(0);
     /* special Resource ID passed to KillClient */
 dcl CurrentTime     fixed bin(31) value(0); /* special Time */
 dcl NoSymbol        fixed bin(31) value(0); /* special KeySym */

 /*********************************************************************/
 /* EVENT DEFINITIONS                                                 */
 /*********************************************************************/

 /* Input Event Masks. Used as event-mask window attribute and as     */
 /* arguments to Grab requests.  Not to be confused with event names. */

 dcl NoEventMask              fixed bin (31) value(0);
 dcl KeyPressMask             fixed bin (31) value (raise2(1,0));
 dcl KeyReleaseMask           fixed bin (31) value (raise2(1,1));
 dcl ButtonPressMask          fixed bin (31) value (raise2(1,2));
 dcl ButtonReleaseMask        fixed bin (31) value (raise2(1,3));
 dcl EnterWindowMask          fixed bin (31) value (raise2(1,4));
 dcl LeaveWindowMask          fixed bin (31) value (raise2(1,5));
 dcl PointerMotionMask        fixed bin (31) value (raise2(1,6));
 dcl PointerMotionHintMask    fixed bin (31) value (raise2(1,7));
 dcl Button1MotionMask        fixed bin (31) value (raise2(1,8));
 dcl Button2MotionMask        fixed bin (31) value (raise2(1,9));
 dcl Button3MotionMask        fixed bin (31) value (raise2(1,10));
 dcl Button4MotionMask        fixed bin (31) value (raise2(1,11));
 dcl Button5MotionMask        fixed bin (31) value (raise2(1,12));
 dcl ButtonMotionMask         fixed bin (31) value (raise2(1,13));
 dcl KeymapStateMask          fixed bin (31) value (raise2(1,14));
 dcl ExposureMask             fixed bin (31) value (raise2(1,15));
 dcl VisibilityChangeMask     fixed bin (31) value (raise2(1,16));
 dcl StructureNotifyMask      fixed bin (31) value (raise2(1,17));
 dcl ResizeRedirectMask       fixed bin (31) value (raise2(1,18));
 dcl SubstructureNotifyMask   fixed bin (31) value (raise2(1,19));
 dcl SubstructureRedirectMask fixed bin (31) value (raise2(1,20));
 dcl FocusChangeMask          fixed bin (31) value (raise2(1,21));
 dcl PropertyChangeMask       fixed bin (31) value (raise2(1,22));
 dcl ColormapChangeMask       fixed bin (31) value (raise2(1,23));
 dcl OwnerGrabButtonMask      fixed bin (31) value (raise2(1,24));

 /* Event names.  Used in "type" field in XEvent structures. Not to   */
 /* be confused with event masks above.  They start from 2 because    */
 /* 0 and 1 are reserved in the protocol for errors and replies.      */

 dcl KeyPress         fixed bin(31) value(2);
 dcl KeyRelease       fixed bin(31) value(3);
 dcl ButtonPress      fixed bin(31) value(4);
 dcl ButtonRelease    fixed bin(31) value(5);
 dcl MotionNotify     fixed bin(31) value(6);
 dcl EnterNotify      fixed bin(31) value(7);
 dcl LeaveNotify      fixed bin(31) value(8);
 dcl FocusIn          fixed bin(31) value(9);
 dcl FocusOut         fixed bin(31) value(10);
 dcl KeymapNotify     fixed bin(31) value(11);
 dcl Expose           fixed bin(31) value(12);
 dcl GraphicsExpose   fixed bin(31) value(13);
 dcl NoExpose         fixed bin(31) value(14);
 dcl VisibilityNotify fixed bin(31) value(15);
 dcl CreateNotify     fixed bin(31) value(16);
 dcl DestroyNotify    fixed bin(31) value(17);
 dcl UnmapNotify      fixed bin(31) value(18);
 dcl MapNotify        fixed bin(31) value(19);
 dcl MapRequest       fixed bin(31) value(20);
 dcl ReparentNotify   fixed bin(31) value(21);
 dcl ConfigureNotify  fixed bin(31) value(22);
 dcl ConfigureRequest fixed bin(31) value(23);
 dcl GravityNotify    fixed bin(31) value(24);
 dcl ResizeRequest    fixed bin(31) value(25);
 dcl CirculateNotify  fixed bin(31) value(26);
 dcl CirculateRequest fixed bin(31) value(27);
 dcl PropertyNotify   fixed bin(31) value(28);
 dcl SelectionClear   fixed bin(31) value(29);
 dcl SelectionRequest fixed bin(31) value(30);
 dcl SelectionNotify  fixed bin(31) value(31);
 dcl ColormapNotify   fixed bin(31) value(32);
 dcl ClientMessage    fixed bin(31) value(33);
 dcl MappingNotify    fixed bin(31) value(34);
 dcl LASTEvent        fixed bin(31) value(35);
     /* must be bigger than any event # */


 /* Key masks. Used as modifiers to GrabButton and GrabKey, results   */
 /* of QueryPointer, state in various key-, mouse-, and button-       */
 /* related events.                                                   */

 dcl ShiftMask   fixed bin (31) value (raise2(1,0));
 dcl LockMask    fixed bin (31) value (raise2(1,1));
 dcl ControlMask fixed bin (31) value (raise2(1,2));
 dcl Mod1Mask    fixed bin (31) value (raise2(1,3));
 dcl Mod2Mask    fixed bin (31) value (raise2(1,4));
 dcl Mod3Mask    fixed bin (31) value (raise2(1,5));
 dcl Mod4Mask    fixed bin (31) value (raise2(1,6));
 dcl Mod5Mask    fixed bin (31) value (raise2(1,7));

 /* modifier names. Used to build a SetModifierMapping request or     */
 /* to read a GetModifierMapping request.  These correspond to the    */
 /* masks defined above.                                              */
 dcl ShiftMapIndex   fixed bin(31) value(0);
 dcl LockMapIndex    fixed bin(31) value(1);
 dcl ControlMapIndex fixed bin(31) value(2);
 dcl Mod1MapIndex    fixed bin(31) value(3);
 dcl Mod2MapIndex    fixed bin(31) value(4);
 dcl Mod3MapIndex    fixed bin(31) value(5);
 dcl Mod4MapIndex    fixed bin(31) value(6);
 dcl Mod5MapIndex    fixed bin(31) value(7);


 /* button masks.  Used in same manner as Key masks above.            */
 /* Not to be confused with button names below.                       */

 dcl Button1Mask fixed bin (31) value (raise2(1,8));
 dcl Button2Mask fixed bin (31) value (raise2(1,9));
 dcl Button3Mask fixed bin (31) value (raise2(1,10));
 dcl Button4Mask fixed bin (31) value (raise2(1,11));
 dcl Button5Mask fixed bin (31) value (raise2(1,12));

 dcl AnyModifier fixed bin (31) value (raise2(1,15));
     /* used in GrabButton, GrabKey */


 /* button names. Used as arguments to GrabButton and as detail in    */
 /* ButtonPress and ButtonRelease events.                             */
 /* Not to be confused with button masks above.                       */
 /* Note that 0 is already defined above as "AnyButton".              */

 dcl Button1 fixed bin(31) value(1);
 dcl Button2 fixed bin(31) value(2);
 dcl Button3 fixed bin(31) value(3);
 dcl Button4 fixed bin(31) value(4);
 dcl Button5 fixed bin(31) value(5);

 /* Notify modes */

 dcl NotifyNormal       fixed bin(31) value(0);
 dcl NotifyGrab         fixed bin(31) value(1);
 dcl NotifyUngrab       fixed bin(31) value(2);
 dcl NotifyWhileGrabbed fixed bin(31) value(3);

 dcl NotifyHint         fixed bin(31) value(1);
     /* for MotionNotify events */

 /* Notify detail */

 dcl NotifyAncestor         fixed bin(31) value(0);
 dcl NotifyVirtual          fixed bin(31) value(1);
 dcl NotifyInferior         fixed bin(31) value(2);
 dcl NotifyNonlinear        fixed bin(31) value(3);
 dcl NotifyNonlinearVirtual fixed bin(31) value(4);
 dcl NotifyPointer          fixed bin(31) value(5);
 dcl NotifyPointerRoot      fixed bin(31) value(6);
 dcl NotifyDetailNone       fixed bin(31) value(7);

 /* Visibility notify */

 dcl VisibilityUnobscured        fixed bin(31) value(0);
 dcl VisibilityPartiallyObscured fixed bin(31) value(1);
 dcl VisibilityFullyObscured     fixed bin(31) value(2);

 /* Circulation request */

 dcl PlaceOnTop    fixed bin(31) value(0);
 dcl PlaceOnBottom fixed bin(31) value(1);

 /* protocol families */

 dcl FamilyInternet fixed bin(31) value(0);
 dcl FamilyDECnet   fixed bin(31) value(1);
 dcl FamilyChaos    fixed bin(31) value(2);

 /* Property notification */

 dcl PropertyNewValue fixed bin(31) value(0);
 dcl PropertyDelete   fixed bin(31) value(1);

 /* Color Map notification */

 dcl ColormapUninstalled fixed bin(31) value(0);
 dcl ColormapInstalled   fixed bin(31) value(1);

 /* GrabPointer, GrabButton, GrabKeyboard, GrabKey Modes */

 dcl GrabModeSync  fixed bin(31) value(0);
 dcl GrabModeAsync fixed bin(31) value(1);

 /* GrabPointer, GrabKeyboard reply status */

 dcl GrabSuccess     fixed bin(31) value(0);
 dcl AlreadyGrabbed  fixed bin(31) value(1);
 dcl GrabInvalidTime fixed bin(31) value(2);
 dcl GrabNotViewable fixed bin(31) value(3);
 dcl GrabFrozen      fixed bin(31) value(4);

 /* AllowEvents modes */

 dcl AsyncPointer   fixed bin(31) value(0);
 dcl SyncPointer    fixed bin(31) value(1);
 dcl ReplayPointer  fixed bin(31) value(2);
 dcl AsyncKeyboard  fixed bin(31) value(3);
 dcl SyncKeyboard   fixed bin(31) value(4);
 dcl ReplayKeyboard fixed bin(31) value(5);
 dcl AsyncBoth      fixed bin(31) value(6);
 dcl SyncBoth       fixed bin(31) value(7);

 /* Used in SetInputFocus, GetInputFocus */

 dcl RevertToNone        fixed bin(31) value(None);
 dcl RevertToPointerRoot fixed bin(31) value(PointerRoot);
 dcl RevertToParent      fixed bin(31) value(2);

 /*********************************************************************/
 /* ERROR CODES                                                       */
 /*********************************************************************/

 dcl Success     fixed bin(31) value(0); /* everything's okay         */
 dcl BadRequest  fixed bin(31) value(1); /* bad request code          */
 dcl BadValue    fixed bin(31) value(2); /* int parameter out of range*/
 dcl BadWindow   fixed bin(31) value(3); /* parameter not a Window    */
 dcl BadPixmap   fixed bin(31) value(4); /* parameter not a Pixmap    */
 dcl BadAtom     fixed bin(31) value(5); /* parameter not an Atom     */
 dcl BadCursor   fixed bin(31) value(6); /* parameter not a Cursor    */
 dcl BadFont     fixed bin(31) value(7); /* parameter not a Font      */
 dcl BadMatch    fixed bin(31) value(8); /* parameter mismatch        */
 dcl BadDrawable fixed bin(31) value(9);
                               /* parameter not a Pixmap or Window    */
 dcl BadAccess   fixed bin(31) value(10); /* depending on context:    */
     /* - key/button already grabbed                                  */
     /* - attempt to free an illegal cmap entry                       */
     /* - attempt to store into a read-only color map entry.          */
     /* - attempt to modify the access control list                   */
     /*   from other than the local host.                             */
 dcl BadAlloc    fixed bin(31) value(11); /* insufficient resources   */
 dcl BadColor    fixed bin(31) value(12); /* no such colormap         */
 dcl BadGC       fixed bin(31) value(13); /* parameter not a GC       */
 dcl BadIDChoice fixed bin(31) value(14);
                            /* choice not in range or already used    */
 dcl BadName     fixed bin(31) value(15);
                               /* font or color name doesn't exist    */
 dcl BadLength   fixed bin(31) value(16); /* Request length incorrect */
 dcl BadImplementation fixed bin(31) value(17); /* server is defective*/
 dcl FirstExtensionError fixed bin(31) value(128);
 dcl LastExtensionError  fixed bin(31) value(255);

 /*********************************************************************/
 /* WINDOW DEFINITIONS                                                */
 /*********************************************************************/

 /* Window classes used by CreateWindow */
 /* Note that CopyFromParent is already defined as 0 above */

 dcl InputOutput fixed bin(31) value(1);
 dcl InputOnly   fixed bin(31) value(2);

 /* Window attributes for CreateWindow and ChangeWindowAttributes */

 dcl CWBackPixmap       fixed bin (31) value (raise2(1,0));
 dcl CWBackPixel        fixed bin (31) value (raise2(1,1));
 dcl CWBorderPixmap     fixed bin (31) value (raise2(1,2));
 dcl CWBorderPixel      fixed bin (31) value (raise2(1,3));
 dcl CWBitGravity       fixed bin (31) value (raise2(1,4));
 dcl CWWinGravity       fixed bin (31) value (raise2(1,5));
 dcl CWBackingStore     fixed bin (31) value (raise2(1,6));
 dcl CWBackingPlanes    fixed bin (31) value (raise2(1,7));
 dcl CWBackingPixel     fixed bin (31) value (raise2(1,8));
 dcl CWOverrideRedirect fixed bin (31) value (raise2(1,9));
 dcl CWSaveUnder        fixed bin (31) value (raise2(1,10));
 dcl CWEventMask        fixed bin (31) value (raise2(1,11));
 dcl CWDontPropagate    fixed bin (31) value (raise2(1,12));
 dcl CWColormap         fixed bin (31) value (raise2(1,13));
 dcl CWCursor           fixed bin (31) value (raise2(1,14));

 /* ConfigureWindow structure */

 dcl CWX           fixed bin (31) value (raise2(1,0));
 dcl CWY           fixed bin (31) value (raise2(1,1));
 dcl CWWidth       fixed bin (31) value (raise2(1,2));
 dcl CWHeight      fixed bin (31) value (raise2(1,3));
 dcl CWBorderWidth fixed bin (31) value (raise2(1,4));
 dcl CWSibling     fixed bin (31) value (raise2(1,5));
 dcl CWStackMode   fixed bin (31) value (raise2(1,6));


 /* Bit Gravity */

 dcl ForgetGravity    fixed bin(31) value(0);
 dcl NorthWestGravity fixed bin(31) value(1);
 dcl NorthGravity     fixed bin(31) value(2);
 dcl NorthEastGravity fixed bin(31) value(3);
 dcl WestGravity      fixed bin(31) value(4);
 dcl CenterGravity    fixed bin(31) value(5);
 dcl EastGravity      fixed bin(31) value(6);
 dcl SouthWestGravity fixed bin(31) value(7);
 dcl SouthGravity     fixed bin(31) value(8);
 dcl SouthEastGravity fixed bin(31) value(9);
 dcl StaticGravity    fixed bin(31) value(10);

 /* Window gravity + bit gravity above */

 dcl UnmapGravity    fixed bin(31) value(0);

 /* Used in CreateWindow for backing-store hint */

 dcl NotUseful  fixed bin(31) value(0);
 dcl WhenMapped fixed bin(31) value(1);
 dcl Always     fixed bin(31) value(2);

 /* Used in GetWindowAttributes reply */

 dcl IsUnmapped   fixed bin(31) value(0);
 dcl IsUnviewable fixed bin(31) value(1);
 dcl IsViewable   fixed bin(31) value(2);

 /* Used in ChangeSaveSet */

  dcl SetModeInsert fixed bin(31) value(0);
  dcl SetModeDelete fixed bin(31) value(1);

 /* Used in ChangeCloseDownMode */

 dcl DestroyAll      fixed bin(31) value(0);
 dcl RetainPermanent fixed bin(31) value(1);
 dcl RetainTemporary fixed bin(31) value(2);

 /* Window stacking method (in configureWindow) */

 dcl Above    fixed bin(31) value(0);
 dcl Below    fixed bin(31) value(1);
 dcl TopIf    fixed bin(31) value(2);
 dcl BottomIf fixed bin(31) value(3);
 dcl Opposite fixed bin(31) value(4);

 /* Circulation direction */

 dcl RaiseLowest  fixed bin(31) value(0);
 dcl LowerHighest fixed bin(31) value(1);

 /* Property modes */

 dcl PropModeReplace fixed bin(31) value(0);
 dcl PropModePrepend fixed bin(31) value(1);
 dcl PropModeAppend  fixed bin(31) value(2);

 /*********************************************************************/
 /* GRAPHICS DEFINITIONS                                              */
 /*********************************************************************/

 /* graphics functions, as in GC.alu */

 dcl GXclear        fixed bin(31) value('0'xn); /* 0 */
 dcl GXand          fixed bin(31) value('1'xn); /* src AND dst */
 dcl GXandReverse   fixed bin(31) value('2'xn); /* src AND NOT dst */
 dcl GXcopy         fixed bin(31) value('3'xn); /* src */
 dcl GXandInverted  fixed bin(31) value('4'xn); /* NOT src AND dst */
 dcl GXnoop         fixed bin(31) value('5'xn); /* dst */
 dcl GXxor          fixed bin(31) value('6'xn); /* src XOR dst */
 dcl GXor           fixed bin(31) value('7'xn); /* src OR dst */
 dcl GXnor          fixed bin(31) value('8'xn); /* NOT src AND NOT dst*/
 dcl GXequiv        fixed bin(31) value('9'xn); /* NOT src XOR dst */
 dcl GXinvert       fixed bin(31) value('a'xn); /* NOT dst */
 dcl GXorReverse    fixed bin(31) value('b'xn); /* src OR NOT dst */
 dcl GXcopyInverted fixed bin(31) value('c'xn); /* NOT src */
 dcl GXorInverted   fixed bin(31) value('d'xn); /* NOT src OR dst */
 dcl GXnand         fixed bin(31) value('e'xn); /* NOT src OR NOT dst */
 dcl GXset          fixed bin(31) value('f'xn); /* 1 */

 /* LineStyle */

 dcl LineSolid      fixed bin(31) value(0);
 dcl LineOnOffDash  fixed bin(31) value(1);
 dcl LineDoubleDash fixed bin(31) value(2);

 /* capStyle */

 dcl CapNotLast    fixed bin(31) value(0);
 dcl CapButt       fixed bin(31) value(1);
 dcl CapRound      fixed bin(31) value(2);
 dcl CapProjecting fixed bin(31) value(3);

 /* joinStyle */

 dcl JoinMiter fixed bin(31) value(0);
 dcl JoinRound fixed bin(31) value(1);
 dcl JoinBevel fixed bin(31) value(2);

 /* fillStyle */

 dcl FillSolid          fixed bin(31) value(0);
 dcl FillTiled          fixed bin(31) value(1);
 dcl FillStippled       fixed bin(31) value(2);
 dcl FillOpaqueStippled fixed bin(31) value(3);

 /* fillRule */

 dcl EvenOddRule fixed bin(31) value(0);
 dcl WindingRule fixed bin(31) value(1);

 /* subwindow mode */

 dcl ClipByChildren   fixed bin(31) value(0);
 dcl IncludeInferiors fixed bin(31) value(1);

 /* SetClipRectangles ordering */

 dcl Unsorted fixed bin(31) value(0);
 dcl YSorted  fixed bin(31) value(1);
 dcl YXSorted fixed bin(31) value(2);
 dcl YXBanded fixed bin(31) value(3);

 /* CoordinateMode for drawing routines */

 dcl CoordModeOrigin   fixed bin(31) value(0);
     /* relative to the origin */
 dcl CoordModePrevious fixed bin(31) value(1);
     /* relative to previous point */

 /* Polygon shapes */

 dcl Complex   fixed bin(31) value(0); /* paths may intersect */
 dcl Nonconvex fixed bin(31) value(1);
                                /* no paths intersect, but not convex */
 dcl Convex    fixed bin(31) value(2); /* wholly convex */

 /* Arc modes for PolyFillArc */

 dcl ArcChord    fixed bin(31) value(0); /* join endpoints of arc */
 dcl ArcPieSlice fixed bin(31) value(1);
                               /* join endpoints to center of arc */

 /* GC components: masks used in CreateGC, CopyGC, ChangeGC, OR'ed */
 /* into GC.stateChanges                                           */

 dcl GCFunction          fixed bin (31) value (raise2(1,0));
 dcl GCPlaneMask         fixed bin (31) value (raise2(1,1));
 dcl GCForeground        fixed bin (31) value (Raise2(1,2));
 dcl GCBackground        fixed bin (31) value (raise2(1,3));
 dcl GCLineWidth         fixed bin (31) value (raise2(1,4));
 dcl GCLineStyle         fixed bin (31) value (raise2(1,5));
 dcl GCCapStyle          fixed bin (31) value (raise2(1,6));
 Dcl GCJoinStyle         fixed bin (31) value (raise2(1,7));
 dcl GCFillStyle         fixed bin (31) value (raise2(1,8));
 dcl GCFillRule          fixed bin (31) value (raise2(1,9));
 dcl GCTile              fixed bin (31) value (raise2(1,10));
 dcl GCStipple           fixed bin (31) value (raise2(1,11));
 dcl GCTileStipXOrigin   fixed bin (31) value (raise2(1,12));
 dcl GCTileStipYOrigin   fixed bin (31) value (raise2(1,13));
 dcl GCFont              fixed bin (31) value (raise2(1,14));
 dcl GCSubwindowMode     fixed bin (31) value (raise2(1,15));
 dcl GCGraphicsExposures fixed bin (31) value (raise2(1,16));
 dcl GCClipXOrigin       fixed bin (31) value (raise2(1,17));
 dcl GCClipYOrigin       fixed bin (31) value (raise2(1,18));
 dcl GCClipMask          fixed bin (31) value (raise2(1,19));
 dcl GCDashOffset        fixed bin (31) value (raise2(1,20));
 dcl GCDashList          fixed bin (31) value (raise2(1,21));
 dcl GCArcMode           fixed bin (31) value (raise2(1,22));

 dcl GCLastBit           fixed bin (31) value(22);

 /*********************************************************************/
 /* FONTS                                                             */
 /*********************************************************************/

 /* used in QueryFont -- draw direction */

 dcl FontLeftToRight fixed bin(31) value(0);
 dcl FontRightToLeft fixed bin(31) value(1);

 dcl FontChange      fixed bin(31) value(255);

 /*********************************************************************/
 /*  IMAGING                                                          */
 /*********************************************************************/

 /* ImageFormat -- PutImage, GetImage */

 dcl XYBitmap fixed bin(31) value(0); /* depth 1, XYFormat */
 dcl XYPixmap fixed bin(31) value(1); /* depth == drawable depth */
 dcl ZPixmap  fixed bin(31) value(2); /* depth == drawable depth */

 /*********************************************************************/
 /*  COLOR MAP STUFF                                                  */
 /*********************************************************************/

 /* For CreateColormap */

 dcl AllocNone fixed bin(31) value(0); /* create map with no entries */
 dcl AllocAll  fixed bin(31) value(1); /*allocate entire map writeable*/


 /* Flags used in StoreNamedColor, StoreColors */

 dcl DoRed   fixed bin (31) value (raise2(1,0));
 dcl DoGreen fixed bin (31) value (raise2(1,1));
 dcl DoBlue  fixed bin (31) value (raise2(1,2));

 /*********************************************************************/
 /* CURSOR STUFF                                                      */
 /*********************************************************************/

 /* QueryBestSize Class */

 dcl CursorShape  fixed bin(31) value(0);
                                /* largest size that can be displayed */
 dcl TileShape    fixed bin(31) value(1); /* size tiled fastest       */
 dcl StippleShape fixed bin(31) value(2); /* size stippled fastest    */

 /*********************************************************************/
 /* KEYBOARD/POINTER STUFF                                            */
 /*********************************************************************/

 dcl AutoRepeatModeOff     fixed bin(31) value(0);
 dcl AutoRepeatModeOn      fixed bin(31) value(1);
 dcl AutoRepeatModeDefault fixed bin(31) value(2);

 dcl LedModeOff            fixed bin(31) value(0);
 dcl LedModeOn             fixed bin(31) value(1);

 /* masks for ChangeKeyboardControl */

 dcl KBKeyClickPercent fixed bin (31) value (raise2(1,0));
 dcl KBBellPercent     fixed bin (31) value (raise2(1,1));
 dcl KBBellPitch       fixed bin (31) value (raise2(1,2));
 dcl KBBellDuration    fixed bin (31) value (raise2(1,3));
 dcl KBLed             fixed bin (31) value (raise2(1,4));
 dcl KBLedMode         fixed bin (31) value (raise2(1,5));
 dcl KBKey             fixed bin (31) value (raise2(1,6));
 dcl KBAutoRepeatMode  fixed bin (31) value (raise2(1,7));

 dcl MappingSuccess  fixed bin(31) value(0);
 dcl MappingBusy     fixed bin(31) value(1);
 dcl MappingFailed   fixed bin(31) value(2);

 dcl MappingModifier fixed bin(31) value(0);
 dcl MappingKeyboard fixed bin(31) value(1);
 dcl MappingPointer  fixed bin(31) value(2);

 /*********************************************************************/
 /* SCREEN SAVER STUFF                                                */
 /*********************************************************************/

 dcl DontPreferBlanking    fixed bin(31) value(0);
 dcl PreferBlanking        fixed bin(31) value(1);
 dcl DefaultBlanking       fixed bin(31) value(2);

 dcl DisableScreenSaver    fixed bin(31) value(0);
 dcl DisableScreenInterval fixed bin(31) value(0);

 dcl DontAllowExposures    fixed bin(31) value(0);
 dcl AllowExposures        fixed bin(31) value(1);
 dcl DefaultExposures      fixed bin(31) value(2);

 /* for ForceScreenSaver */

 dcl ScreenSaverReset      fixed bin(31) value(0);
 dcl ScreenSaverActive     fixed bin(31) value(1);

 /*********************************************************************/
 /* HOSTS AND CONNECTIONS                                             */
 /*********************************************************************/

 /* for ChangeHosts */

 dcl HostInsert fixed bin(31) value(0);
 dcl HostDelete fixed bin(31) value(1);

 /* for ChangeAccessControl */

 dcl EnableAccess  fixed bin(31) value(1);
 dcl DisableAccess fixed bin(31) value(0);

 /* Display classes  used in opening the connection                   */
 /* Note that the statically allocated ones are even numbered and the */
 /* dynamically changeable ones are odd numbered                      */

 dcl StaticGray  fixed bin(31) value(0);
 dcl GrayScale   fixed bin(31) value(1);
 dcl StaticColor fixed bin(31) value(2);
 dcl PseudoColor fixed bin(31) value(3);
 dcl TrueColor   fixed bin(31) value(4);
 dcl DirectColor fixed bin(31) value(5);


 /* Byte order  used in imageByteOrder and bitmapBitOrder */

 dcl LSBFirst fixed bin(31) value(0);
 dcl MSBFirst fixed bin(31) value(1);

 %end; /* X_H */
